/**
 * @license
 * Copyright 2021 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@tensorflow/tfjs-core"),require("path"),require("fs"),require("worker_threads"),require("perf_hooks"),require("os")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","path","fs","worker_threads","perf_hooks","os"],t):t(((e=e||self).tf=e.tf||{},e.tf.wasm=e.tf.wasm||{}),e.tf,e.path,e.fs,e.worker_threads,e.perf_hooks,e.os)}(this,(function(e,t,n,a,r,s,u){"use strict";var i,o;let l;n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n,a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a,r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s,u=u&&Object.prototype.hasOwnProperty.call(u,"default")?u.default:u,function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(i||(i={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu",e[e.leakyrelu=4]="leakyrelu",e[e.sigmoid=5]="sigmoid"}(o||(o={}));const c={kernelName:t._FusedMatMul,backendName:"wasm",setupFunc:function(e){l=e.wasm.cwrap(t._FusedMatMul,null,["number","array","number","number","array","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{a:r,b:s,bias:u,preluActivationWeights:i}=t;if("float32"!==r.dtype||"float32"!==s.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");const{transposeA:c,transposeB:d,activation:p,leakyreluAlpha:f}=a,m=n.dataIdMap.get(r.dataId).id,h=n.dataIdMap.get(s.dataId).id;let b=0;if(null!=u){const e=n.dataIdMap.get(u.dataId);if(1!==e.shape.length)throw new Error(`_FusedMatMul only supports rank-1 bias but got rank ${e.shape.length}.`);b=e.id}const y=null==i?0:n.dataIdMap.get(i.dataId).id,_=o[p];if(null==_)throw new Error(`${p} activation not yet supported for FusedConv2D in the wasm backend.`);const g=c?r.shape[2]:r.shape[1],w=d?s.shape[1]:s.shape[2],k=r.shape[0],I=n.makeOutput([k,g,w],r.dtype),v=n.dataIdMap.get(I.dataId).id,M=new Uint8Array(new Int32Array(r.shape).buffer),A=new Uint8Array(new Int32Array(s.shape).buffer);return l(m,M,r.shape.length,h,A,s.shape.length,c,d,_,b,y,f||0,v),I}};function d(e){let n;return{kernelName:e,backendName:"wasm",setupFunc:function(t){n=t.wasm.cwrap(e,null,["number","number"])},kernelFunc:function(e){const{backend:a,inputs:{x:r}}=e,s=a.dataIdMap.get(r.dataId).id,u=a.makeOutput(r.shape,r.dtype),i=a.dataIdMap.get(u.dataId).id;return 0===t.util.sizeFromShape(u.shape)||n(s,i),u}}}const p=d(t.Abs);function f(e,n,a){let r;return{kernelName:e,backendName:"wasm",setupFunc:function(t){r=t.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(s){const{backend:u,inputs:o}=s,{a:l,b:c}=o,d=u.dataIdMap.get(l.dataId).id,p=u.dataIdMap.get(c.dataId).id,f=null!=a?a:l.dtype,m=t.backend_util.assertAndGetBroadcastShape(l.shape,c.shape),h=u.makeOutput(m,f);if(0===t.util.sizeFromShape(m))return h;const b=new Uint8Array(new Int32Array(l.shape).buffer),y=new Uint8Array(new Int32Array(c.shape).buffer),_=u.dataIdMap.get(h.dataId).id,g=()=>r(d,b,l.shape.length,p,y,c.shape.length,i[l.dtype],_);if(n&&"float32"===l.dtype)return g(),h;const w=t.backend_util.getBroadcastDims(l.shape,m),k=t.backend_util.getBroadcastDims(c.shape,m),I=w.every(((e,t)=>e===t)),v=k.every(((e,t)=>e===t));if(I&&v)return g(),h;throw new Error(`Broadcasting along outer dims is not yet supported for ${l.dtype} ${e}.`)}}}const m=f(t.Add,!0);let h;const b={kernelName:t.AddN,backendName:"wasm",setupFunc:function(e){h=e.wasm.cwrap(t.AddN,null,["array","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:a}=e,r=a.makeOutput(n[0].shape,n[0].dtype);if(0===t.util.sizeFromShape(r.shape))return r;const s=n.map((e=>a.dataIdMap.get(e.dataId).id)),u=new Uint8Array(new Int32Array(s).buffer),o=a.dataIdMap.get(r.dataId).id;return h(u,s.length,i[r.dtype],o),r}};function y(e){const{inputs:{x:t},backend:n}=e,a=n.makeOutput(t.shape,t.dtype),r=n.typedArrayFromHeap(t);return n.typedArrayFromHeap(a).set(r),a}const _={kernelName:t.Identity,backendName:"wasm",kernelFunc:y};let g;function w(e){const{inputs:t,backend:n,attrs:a}=e,[r,s]=function(e,t){const n=[],a=[];for(let r=0;r<e.length;++r)1!==e[r]&&n.push(e[r]),1!==e[t[r]]&&a.push(t[r]);for(let e=0;e<a.length;++e){let t=-1;for(let n=0;n<a.length;++n)a[n]>=e&&(-1===t||a[t]>a[n])&&(t=n);a[t]=e}return[n,a]}(t.x.shape,a.perm);let u=!0;for(let e=0;e<s.length;e++)s[e]!==e&&(u=!1);const o=function(e,t){const n=new Array(e.length);for(let a=0;a<n.length;a++)n[a]=e[t[a]];return n}(t.x.shape,a.perm),l={dataId:t.x.dataId,shape:r,dtype:t.x.dtype};if(u){const e=y({inputs:t,backend:n});return e.shape=o,e}const c=n.makeOutput(o,l.dtype),d=n.dataIdMap.get(l.dataId).id,p=n.dataIdMap.get(c.dataId).id,f=new Uint8Array(new Int32Array(s).buffer),m=new Uint8Array(new Int32Array(l.shape).buffer);return g(d,m,l.shape.length,i[l.dtype],p,f,s.length),c}const k={kernelName:t.Transpose,backendName:"wasm",kernelFunc:w,setupFunc:function(e){g=e.wasm.cwrap(t.Transpose,null,["number","array","number","number","number","array","number"])}};function I(e,n,a){const r=e.shape,s=e.shape.length,u=t.util.parseAxisParam(n,r);let i=u;const o=t.backend_util.getAxesPermutation(i,s);let l=null,c=!1;if(null!=o){const n=new Array(s);for(let e=0;e<n.length;e++)n[e]=r[o[e]];i=t.backend_util.getInnerMostAxes(i.length,s),l=w({inputs:{x:e},attrs:{perm:o},backend:a});const u=a.dataIdMap.get(e.dataId).id;a.dataIdMap.get(l.dataId).id!==u&&(c=!0)}return{transposed:l,originalAxes:u,axes:i,inputWasTransposed:c}}let v;const M={kernelName:t.All,backendName:"wasm",setupFunc:function(e){v=e.wasm.cwrap(t.All,null,["number, number, number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a;let o=n.dataIdMap.get(i.dataId).id,l=i;const{transposed:c,axes:d,originalAxes:p,inputWasTransposed:f}=I(i,s,n);if(f){l=c,o=n.dataIdMap.get(c.dataId).id}const m=l.shape.length;t.backend_util.assertAxesAreInnerMostDims("all",d,m);const[h,b]=t.backend_util.computeOutAndReduceShapes(l.shape,d),y=t.util.sizeFromShape(b),_=n.makeOutput(h,i.dtype);if(0!==t.util.sizeFromShape(l.shape)){const e=n.dataIdMap.get(_.dataId).id;v(o,y,e)}if(f&&n.disposeData(c.dataId),u){const e=t.backend_util.expandShapeToKeepDim(_.shape,p);_.shape=e}return _}};let A;const x={kernelName:t.Any,backendName:"wasm",setupFunc:function(e){A=e.wasm.cwrap(t.Any,null,["number, number, number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a;let o=n.dataIdMap.get(i.dataId).id,l=i;const{transposed:c,axes:d,originalAxes:p,inputWasTransposed:f}=I(i,s,n);if(f){l=c,o=n.dataIdMap.get(c.dataId).id}const m=l.shape.length;t.backend_util.assertAxesAreInnerMostDims("any",d,m);const[h,b]=t.backend_util.computeOutAndReduceShapes(l.shape,d),y=t.util.sizeFromShape(b),_=n.makeOutput(h,i.dtype);if(0!==t.util.sizeFromShape(l.shape)){const e=n.dataIdMap.get(_.dataId).id;A(o,y,e)}if(f&&n.disposeData(c.dataId),u){const e=t.backend_util.expandShapeToKeepDim(_.shape,p);_.shape=e}return _}};let S;const F={kernelName:t.ArgMax,backendName:"wasm",kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s}=r,{x:u}=a,o=n.dataIdMap.get(u.dataId).id;let l=o,c=u;const{transposed:d,axes:p,inputWasTransposed:f}=I(u,s,n);if(f){const e=n.dataIdMap.get(d.dataId).id;e!==o&&(c=d,l=e)}const m=c.shape.slice(0,-1),h=n.makeOutput(m,"int32"),b=n.dataIdMap.get(h.dataId).id,y=t.util.sizeFromShape(h.shape),_=c.shape[p[0]];return S(l,i[c.dtype],y,_,b),f&&n.disposeData(d.dataId),h},setupFunc:function(e){S=e.wasm.cwrap(t.ArgMax,null,["number","number","number","number","number"])}};let N;const E={kernelName:t.AvgPool,backendName:"wasm",setupFunc:function(e){N=e.wasm.cwrap(t.AvgPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,s=n.x,u=r.dataIdMap.get(s.dataId).id,{filterSize:i,strides:o,pad:l,dimRoundingMode:c}=a,d=t.backend_util.computePool2DInfo(s.shape,i,o,1,l,c),p=d.filterHeight,f=d.filterWidth,m=d.padInfo.top,h=d.padInfo.right,b=d.padInfo.bottom,y=d.padInfo.left,_=d.strideHeight,g=d.strideWidth,w=d.inChannels;if("channelsLast"!==d.dataFormat)throw new Error(`wasm backend does not support dataFormat:'${d.dataFormat}'. Please use 'channelsLast'.`);if(1!==d.dilationWidth||1!==d.dilationHeight)throw new Error(`was backend only supports average pooling with dilation = [1, 1], got [${d.dilationHeight}, ${d.dilationWidth}].`);const k=r.makeOutput(d.outShape,"float32"),I=r.dataIdMap.get(k.dataId).id;return N(u,s.shape[0],s.shape[1],s.shape[2],p,f,m,h,b,y,_,g,w,I),k}};function T(e){const{inputs:n,attrs:a}=e,{x:r}=n,{shape:s}=a,u=t.util.sizeFromShape(r.shape),i=t.util.inferFromImplicitShape(s,u);return t.util.assert(u===t.util.sizeFromShape(i),(()=>`new shape: ${i}, old shape: ${r.shape}. New shape and old shape must have the same number of elements.`)),e.backend.incRef(r.dataId),{dataId:r.dataId,shape:i,dtype:r.dtype}}const C={kernelName:t.Reshape,backendName:"wasm",kernelFunc:T};let D;const O={kernelName:t.BatchMatMul,backendName:"wasm",setupFunc:function(e){D=e.wasm.cwrap(t.BatchMatMul,null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{a:s,b:u}=n,{transposeA:i,transposeB:o}=r;if("float32"!==s.dtype||"float32"!==u.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");const l=s.shape.length,c=u.shape.length,d=i?s.shape[l-2]:s.shape[l-1],p=o?u.shape[c-1]:u.shape[c-2],f=i?s.shape[l-1]:s.shape[l-2],m=o?u.shape[c-2]:u.shape[c-1],h=s.shape.slice(0,-2),b=u.shape.slice(0,-2),y=t.util.sizeFromShape(h),_=t.util.sizeFromShape(b),g=y===_||1===y||1===_;t.util.assert(l>=2&&c>=2&&g,(()=>`Error in matMul: the input batch dimensions must either be the same or at least one input batch dimension must be 1. Got input batch dimensions of (${h}) and (${b}).`));const w=(y>_?s.shape.slice(0,-2):u.shape.slice(0,-2)).concat([f,m]);t.util.assert(d===p,(()=>`Error in matMul: inner shapes (${d}) and (${p}) of Tensors with shapes ${s.shape} and ${u.shape} and transposeA=${i} and transposeB=${o} must match.`));const k=o?[_,m,p]:[_,p,m],I=T({inputs:{x:s},backend:a,attrs:{shape:i?[y,d,f]:[y,f,d]}}),v=T({inputs:{x:u},backend:a,attrs:{shape:k}}),M=a.dataIdMap.get(I.dataId).id,A=a.dataIdMap.get(v.dataId).id,x=i?I.shape[2]:I.shape[1],S=o?v.shape[1]:v.shape[2],F=Math.max(y,_),N=a.makeOutput([F,x,S],I.dtype),E=a.dataIdMap.get(N.dataId).id,C=new Uint8Array(new Int32Array(I.shape).buffer),O=new Uint8Array(new Int32Array(v.shape).buffer);return D(M,C,I.shape.length,A,O,v.shape.length,i,o,E),a.disposeData(I.dataId),a.disposeData(v.dataId),N.shape=w,N}};function P(e){const{inputs:{x:t},attrs:{dtype:n},backend:a}=e,r=a.makeOutput(t.shape,n),s=a.typedArrayFromHeap(t);return a.typedArrayFromHeap(r).set(s),r}const R={kernelName:t.Cast,backendName:"wasm",kernelFunc:P},W=d(t.Ceil);let H;const z={kernelName:t.ClipByValue,backendName:"wasm",setupFunc:function(e){H=e.wasm.cwrap(t.ClipByValue,null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{x:r}=t,{clipValueMin:s,clipValueMax:u}=a,i=n.dataIdMap.get(r.dataId).id,o=n.makeOutput(r.shape,r.dtype),l=n.dataIdMap.get(o.dataId).id;return H(i,s,u,l),o}};function L(e,n,a,r,s){const u=t.slice_util.isSliceContinous(r,n,a),i=t.util.sizeFromShape(a),o=t.util.computeStrides(r);if(u){const a=t.slice_util.computeFlatOffset(n,o);return"string"===s?e.slice(a,a+i):e.subarray(a,a+i)}const l="string"===s?t.backend_util.fromUint8ToStringArray(e):e,c=t.buffer(r,s,l),d=t.buffer(a,s);for(let e=0;e<d.size;++e){const t=d.indexToLoc(e),a=t.map(((e,t)=>e+n[t]));d.set(c.get(...a),...t)}return"string"===s?t.backend_util.fromStringArrayToUint8(d.values):d.values}function U(e){const{inputs:n,backend:a}=e,r=t.util.parseAxisParam(e.attrs.axis,n[0].shape)[0];let s=t.backend_util.computeOutShape(n.map((e=>e.shape)),r);const u=n.filter((e=>t.util.sizeFromShape(e.shape)>0));if(1===u.length)return y({inputs:{x:u[0]},backend:a});const i=a.makeOutput(s,n[0].dtype);if(0===t.util.sizeFromShape(s))return i;const o=u.map((e=>e.shape));if(t.backend_util.assertParamsConsistent(o,r),"string"===u[0].dtype){const e=u.map((e=>{const n=t.util.sizeFromShape(e.shape.slice(r));return T({inputs:{x:e},backend:a,attrs:{shape:[-1,n]}})})),o=e.map((e=>({vals:a.readSync(e.dataId),shape:e.shape})));s=t.backend_util.computeOutShape(e.map((e=>e.shape)),1);const l=1===e[0].shape[0],c=function(e,n,a,r){const s=t.util.getArrayFromDType(a,t.util.sizeFromShape(n));if(r&&"string"!==a){let n=0;e.forEach((e=>{const a=t.util.sizeFromShape(e.shape);s.set(e.vals,n),n+=a}))}else{let r=0;e.forEach((e=>{const u="string"===a?t.backend_util.fromUint8ToStringArray(e.vals):e.vals;let i=0;for(let t=0;t<e.shape[0];++t){const a=t*n[1]+r;for(let t=0;t<e.shape[1];++t)s[a+t]=u[i++]}r+=e.shape[1]}))}return s}(o,s,n[0].dtype,l),d=t.backend_util.computeOutShape(u.map((e=>e.shape)),r);i.shape=d;return a.dataIdMap.get(i.dataId).stringBytes=t.backend_util.fromStringArrayToUint8(c),e.forEach((e=>a.disposeData(e.dataId))),i}const l=t.util.sizeFromShape(u[0].shape.slice(0,r));let c=0;const d=u.map((e=>{const n=t.util.sizeFromShape(e.shape.slice(r));return c+=n,n})),p=u.map((e=>a.typedArrayFromHeap(e))),f=a.typedArrayFromHeap(i);for(let e=0;e<l;e++){let t=e*c;for(let n=0;n<p.length;n++){const a=d[n],r=e*a,s=p[n].subarray(r,r+a);f.set(s,t),t+=a}}return i}const B={kernelName:t.Concat,backendName:"wasm",kernelFunc:U};let j;const q={kernelName:t.Conv2D,backendName:"wasm",setupFunc:function(e){j=e.wasm.cwrap(t.Conv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s,filter:u}=n,i=r.dataIdMap.get(s.dataId).id,o=r.dataIdMap.get(u.dataId).id,{strides:l,dilations:c,pad:d,dimRoundingMode:p,dataFormat:f}=a,m=t.backend_util.convertConv2DDataFormat(f),h=t.backend_util.computeConv2DInfo(s.shape,u.shape,l,c,d,p,!1,m),b=h.filterHeight,y=h.filterWidth,_=h.padInfo.top,g=h.padInfo.right,w=h.padInfo.bottom,k=h.padInfo.left,I=h.dilationHeight,v=h.dilationWidth,M=h.strideHeight,A=h.strideWidth,x=h.inChannels,S=h.outChannels,F="SAME"===h.padInfo.type?1:0;if("channelsLast"!==h.dataFormat)throw new Error(`wasm backend Conv2D does not support dataFormat:'${h.dataFormat}'. Please use 'channelsLast'.`);const N=r.makeOutput(h.outShape,"float32"),E=r.dataIdMap.get(N.dataId).id;return j(i,s.shape[0],s.shape[1],s.shape[2],o,b,y,_,g,w,k,F,I,v,M,A,x,S,E),N}};let V;const G={kernelName:t.Conv2DBackpropInput,backendName:"wasm",setupFunc:function(e){V=e.wasm.cwrap(t.Conv2DBackpropInput,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{dy:s,filter:u}=a,{strides:i,pad:o,dataFormat:l,dimRoundingMode:c,inputShape:d}=r,p=t.backend_util.convertConv2DDataFormat(l),f=t.backend_util.computeConv2DInfo(d,u.shape,i,1,o,c,!1,p),{batchSize:m,filterHeight:h,filterWidth:b,inChannels:y,inHeight:_,inWidth:g,outChannels:w,outHeight:k,outWidth:I,strideHeight:v,strideWidth:M}=f,A=h-1-f.padInfo.top,x=b-1-f.padInfo.left,S="channelsLast"===f.dataFormat,F=t.util.computeStrides(f.inShape),N=t.util.computeStrides(s.shape),[E,T,C]=t.util.computeStrides(u.shape),D=F[0],O=S?F[1]:F[2],P=S?F[2]:1,R=S?1:F[1],W=N[0],H=S?N[1]:N[2],z=S?N[2]:1,L=S?1:N[1],U=n.makeOutput(f.inShape,"float32"),B=n.dataIdMap.get(U.dataId).id,j=n.dataIdMap.get(s.dataId).id,q=n.dataIdMap.get(u.dataId).id;return V(j,q,m,h,b,_,g,y,k,I,w,v,M,A,x,E,T,C,D,O,P,R,W,H,z,L,B),U}},$=d(t.Cos);var K;let Q;!function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(K||(K={}));const X={kernelName:t.CropAndResize,backendName:"wasm",setupFunc:function(e){Q=e.wasm.cwrap(t.CropAndResize,null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{method:r,extrapolationValue:s,cropSize:u}=a,{image:i,boxes:o,boxInd:l}=n,c=o.shape[0],[d,p]=u,f=[c,d,p,i.shape[3]];let m,h=t.dataIdMap.get(i.dataId);"float32"!==i.dtype&&(m=P({backend:t,inputs:{x:i},attrs:{dtype:"float32"}}),h=t.dataIdMap.get(m.dataId));const b=h.id,y=t.dataIdMap.get(o.dataId).id,_=t.dataIdMap.get(l.dataId).id,g=t.makeOutput(f,"float32"),w=t.dataIdMap.get(g.dataId).id,k=new Uint8Array(new Int32Array(i.shape).buffer);return Q(b,y,_,c,k,d,p,K[r],s,w),null!=m&&t.disposeData(m.dataId),g}};let Z;const Y={kernelName:t.Cumsum,backendName:"wasm",setupFunc:function(e){Z=e.wasm.cwrap(t.Cumsum,null,["number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{x:s}=n,{axis:u,exclusive:o,reverse:l}=r,c=s.shape.length;t.util.assert("float32"===s.dtype||"int32"===s.dtype,(()=>`cumsum does not support ${s.dtype} tensors in the WASM backend`));const d=t.backend_util.getAxesPermutation([u],c);let p=s;null!==d&&(p=w({inputs:{x:s},attrs:{perm:d},backend:a}));const f=t.backend_util.getInnerMostAxes(1,c)[0];t.backend_util.assertAxesAreInnerMostDims("cumsum",[f],c);const m=a.makeOutput(p.shape,p.dtype),h=p.shape[f],b=a.dataIdMap.get(p.dataId).id,y=a.dataIdMap.get(m.dataId).id;Z(b,o?1:0,l?1:0,h,y,i[s.dtype]);let _=m;if(null!==d){_=w({inputs:{x:m},attrs:{perm:t.backend_util.getUndoAxesPermutation(d)},backend:a}),a.disposeData(p.dataId),a.disposeData(m.dataId)}return _}};let J;const ee={kernelName:t.DepthToSpace,backendName:"wasm",setupFunc:function(e){J=e.wasm.cwrap(t.DepthToSpace,null,["number","number","number","array","number","array","array","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{x:s}=a,{blockSize:u,dataFormat:i}=r;t.util.assert(u>1,(()=>`blockSize should be > 1 for depthToSpace, but was: ${u}`));const o=s.shape[0],l="NHWC"===i?s.shape[1]:s.shape[2],c="NHWC"===i?s.shape[2]:s.shape[3],d="NHWC"===i?s.shape[3]:s.shape[1],p=l*u,f=c*u,m=d/(u*u),h="NHWC"===i?[o,p,f,m]:[o,m,p,f],b=n.makeOutput(h,"float32"),y=n.dataIdMap.get(s.dataId).id,_=new Uint8Array(new Int32Array(t.util.computeStrides(s.shape)).buffer),g=new Uint8Array(new Int32Array(h).buffer),w=new Uint8Array(new Int32Array(t.util.computeStrides(h)).buffer),k=n.dataIdMap.get(b.dataId).id;return J(y,u,"NHWC"===i?1:0,_,s.shape.length-1,g,w,h.length,k),b}};let te;const ne={kernelName:t.DepthwiseConv2dNative,backendName:"wasm",setupFunc:function(e){te=e.wasm.cwrap(t.DepthwiseConv2dNative,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s,filter:u}=n,i=r.dataIdMap.get(s.dataId).id,o=r.dataIdMap.get(u.dataId).id,{strides:l,dilations:c,pad:d,dimRoundingMode:p}=a,f=null==c?[1,1]:c,m=t.backend_util.computeConv2DInfo(s.shape,u.shape,l,f,d,p,!0),h=m.filterHeight,b=m.filterWidth,y=m.padInfo.top,_=m.padInfo.right,g=m.padInfo.bottom,w=m.padInfo.left,k=m.dilationHeight,I=m.dilationWidth,v=m.strideHeight,M=m.strideWidth,A=m.inChannels,x=m.outChannels,S="SAME"===m.padInfo.type?1:0;if("channelsLast"!==m.dataFormat)throw new Error(`wasm backend DepthwiseConv2dNative does not support dataFormat:'${m.dataFormat}'. Please use 'channelsLast'.`);const F=r.makeOutput(m.outShape,"float32"),N=r.dataIdMap.get(F.dataId).id;return te(i,s.shape[0],s.shape[1],s.shape[2],o,h,b,y,_,g,w,S,k,I,v,M,A,x,N),F}},ae=f(t.Equal,!1,"bool"),re=d(t.Exp);function se(e){const{inputs:n,attrs:a,backend:r}=e,{input:s}=n,{dim:u}=a,i=s.shape.length,o=s.shape.slice();let l=u;return u<0&&(t.util.assert(-(i+1)<=u,(()=>`Axis must be in the interval [${-(i+1)}, ${i}]`)),l=i+u+1),o.splice(l,0,1),T({inputs:{x:s},backend:r,attrs:{shape:o}})}const ue={kernelName:t.ExpandDims,backendName:"wasm",kernelFunc:se};const ie={kernelName:t.Fill,backendName:"wasm",kernelFunc:function(e){const{attrs:{shape:t,value:n,dtype:a},backend:r}=e,s=r.makeOutput(t,a);return r.typedArrayFromHeap(s).fill(n),s}};let oe;const le={kernelName:t.FlipLeftRight,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:n}=e,{image:a}=t,r=n.makeOutput(a.shape,a.dtype),s=n.dataIdMap.get(a.dataId).id,u=n.dataIdMap.get(r.dataId).id,[i,o,l,c]=a.shape;return oe(s,i,o,l,c,u),r},setupFunc:function(e){oe=e.wasm.cwrap(t.FlipLeftRight,null,["number","number","number","number","number","number"])}},ce=d(t.Floor),de=f(t.FloorDiv,!1);let pe;const fe={kernelName:t.FusedBatchNorm,backendName:"wasm",setupFunc:function(e){pe=e.wasm.cwrap(t.FusedBatchNorm,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{varianceEpsilon:s}=r,{x:u,mean:i,variance:o,offset:l,scale:c}=a,d=n.dataIdMap.get(u.dataId).id,p=n.dataIdMap.get(i.dataId).id,f=n.dataIdMap.get(o.dataId).id,m=null!=l?n.dataIdMap.get(l.dataId).id:0,h=null!=c?n.dataIdMap.get(c.dataId).id:0,b=n.makeOutput(u.shape,u.dtype);if(0===t.util.sizeFromShape(u.shape))return b;const y=n.dataIdMap.get(b.dataId).id;return pe(d,p,f,m,h,s,y),b}};let me;const he={kernelName:t.FusedConv2D,backendName:"wasm",setupFunc:function(e){me=e.wasm.cwrap(t.FusedConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s,filter:u,bias:i,preluActivationWeights:l}=n,{strides:c,pad:d,dilations:p,dataFormat:f,dimRoundingMode:m,activation:h,leakyreluAlpha:b}=a,y=t.backend_util.computeConv2DInfo(s.shape,u.shape,c,p,d,m),_=o[h];if(null==_)throw new Error(`${h} activation not yet supported for FusedConv2D in the wasm backend.`);const g=r.dataIdMap.get(s.dataId).id,w=r.dataIdMap.get(u.dataId).id,k=y.outChannels;let I=0;if(null!=i){const e=r.dataIdMap.get(i.dataId);if(1!==e.shape.length)throw new Error(`FusedConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==k)throw new Error(`FusedConv2D bias shape (${e.shape}) does not match the number of output channels (${k})`);I=e.id}const v=y.filterHeight,M=y.filterWidth,A=y.padInfo.top,x=y.padInfo.right,S=y.padInfo.bottom,F=y.padInfo.left,N=y.dilationHeight,E=y.dilationWidth,T=y.strideHeight,C=y.strideWidth,D=y.inChannels,O="SAME"===y.padInfo.type?1:0,P=y.batchSize,R=y.inHeight,W=y.inWidth;if("NHWC"!==f)throw new Error(`wasm backend FusedConv2D does not support dataFormat:'${f}'. Please use 'NHWC'.`);const H=r.makeOutput(y.outShape,"float32"),z=r.dataIdMap.get(H.dataId).id,L=null==l?0:r.dataIdMap.get(l.dataId).id;return me(g,P,R,W,w,v,M,I,A,x,S,F,O,N,E,T,C,D,k,_,L,b||0,z),H}};let be;const ye={kernelName:t.FusedDepthwiseConv2D,backendName:"wasm",setupFunc:function(e){be=e.wasm.cwrap(t.FusedDepthwiseConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s,filter:u,bias:i,preluActivationWeights:l}=n,{strides:c,pad:d,dilations:p,dataFormat:f,dimRoundingMode:m,activation:h,leakyreluAlpha:b}=a,y=t.backend_util.computeConv2DInfo(s.shape,u.shape,c,p,d,m,!0),_=o[h];if(null==_)throw new Error(`${h} activation not yet supported for FusedDepthwiseConv2D in the wasm backend.`);const g=r.dataIdMap.get(s.dataId).id,w=r.dataIdMap.get(u.dataId).id,k=y.outChannels;let I=0;if(null!=i){const e=r.dataIdMap.get(i.dataId);if(1!==e.shape.length)throw new Error(`FusedDepthwiseConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==k)throw new Error(`FusedDepthwiseConv2D bias shape (${e.shape}) does not match the number of output channels (${k})`);I=e.id}const v=y.filterHeight,M=y.filterWidth,A=y.padInfo.top,x=y.padInfo.right,S=y.padInfo.bottom,F=y.padInfo.left,N=y.dilationHeight,E=y.dilationWidth,T=y.strideHeight,C=y.strideWidth,D=y.inChannels,O="SAME"===y.padInfo.type?1:0,P=y.batchSize,R=y.inHeight,W=y.inWidth;if("NHWC"!==f)throw new Error(`wasm backend FusedDepthwiseConv2D does not support dataFormat:'${f}'. Please use 'NHWC'.`);const H=r.makeOutput(y.outShape,"float32"),z=r.dataIdMap.get(H.dataId).id,L=null==l?0:r.dataIdMap.get(l.dataId).id;return be(g,P,R,W,w,v,M,I,A,x,S,F,O,N,E,T,C,D,k,_,L,b||0,z),H}};let _e;const ge={kernelName:t.GatherNd,backendName:"wasm",setupFunc:function(e){_e=e.wasm.cwrap(t.GatherNd,null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){const{backend:n,inputs:a}=e,{params:r,indices:s}=a,[u,o,l,c]=t.gather_util.prepareAndValidate(r,s),d=n.makeOutput(u,r.dtype);if(0===o)return d;const p=s.shape,f=p[p.length-1],m=n.dataIdMap.get(r.dataId).id,h=n.dataIdMap.get(s.dataId).id,b=new Uint8Array(new Int32Array(c).buffer),y=n.dataIdMap.get(d.dataId).id;return _e(m,i[r.dtype],h,o,f,l,b,y),d}};let we;const ke={kernelName:t.GatherV2,backendName:"wasm",setupFunc:function(e){we=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{x:s,indices:u}=a,{axis:o,batchDims:l}=r,c=t.util.parseAxisParam(o,s.shape)[0],d=t.backend_util.segment_util.collectGatherOpShapeInfo(s,u,c,l),p=T({inputs:{x:s},attrs:{shape:[d.batchSize,d.outerSize,d.dimSize,d.sliceSize]},backend:n}),f=t.util.sizeFromShape(u.shape),m=T({inputs:{x:u},attrs:{shape:[d.batchSize,f/d.batchSize]},backend:n}),h=[d.batchSize,d.outerSize,f/d.batchSize,d.sliceSize],b=n.makeOutput(h,s.dtype);if(0===t.util.sizeFromShape(s.shape))return b;const y=p.shape.length-1,_=n.dataIdMap.get(p.dataId).id,g=n.dataIdMap.get(m.dataId).id,w=n.dataIdMap.get(b.dataId).id,k=new Uint8Array(new Int32Array(t.util.computeStrides(p.shape)).buffer),I=new Uint8Array(new Int32Array(t.util.computeStrides(h)).buffer);return we(_,i[s.dtype],k,y,g,d.batchSize,I,w),n.disposeData(p.dataId),n.disposeData(m.dataId),b.shape=d.outputShape,b}},Ie=f(t.Greater,!1,"bool"),ve=f(t.GreaterEqual,!1,"bool");let Me;const Ae={kernelName:t.LeakyRelu,backendName:"wasm",setupFunc:function(e){Me=e.wasm.cwrap(t.LeakyRelu,null,["number","number","number"])},kernelFunc:function(e){const{inputs:{x:n},attrs:{alpha:a},backend:r}=e,s=r.dataIdMap.get(n.dataId).id,u=r.makeOutput(n.shape,n.dtype);if(0!==t.util.sizeFromShape(n.shape)){const e=r.dataIdMap.get(u.dataId).id;Me(s,a,e)}return u}},xe=f(t.Less,!1,"bool"),Se=f(t.LessEqual,!1,"bool"),Fe=d(t.Log),Ne=f(t.LogicalAnd,!1,"bool");let Ee;const Te={kernelName:t.Max,backendName:"wasm",setupFunc:function(e){Ee=e.wasm.cwrap(t.Max,null,["number, number, number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{reductionIndices:s,keepDims:u}=r,{x:i}=a;let o=n.dataIdMap.get(i.dataId).id,l=i;const{transposed:c,axes:d,originalAxes:p,inputWasTransposed:f}=I(i,s,n);if(f){l=c,o=n.dataIdMap.get(c.dataId).id}const m=l.shape.length;t.backend_util.assertAxesAreInnerMostDims("max",d,m);const[h,b]=t.backend_util.computeOutAndReduceShapes(l.shape,d),y=t.util.sizeFromShape(b),_=n.makeOutput(h,i.dtype);if(0!==t.util.sizeFromShape(l.shape)){const e=n.dataIdMap.get(_.dataId).id;Ee(o,y,e)}if(f&&n.disposeData(c.dataId),u){const e=t.backend_util.expandShapeToKeepDim(_.shape,p);_.shape=e}return _}},Ce=f(t.Maximum,!1);let De;const Oe={kernelName:t.MaxPool,backendName:"wasm",setupFunc:function(e){De=e.wasm.cwrap(t.MaxPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,s=n.x,u=r.dataIdMap.get(s.dataId).id,{filterSize:i,strides:o,pad:l,dimRoundingMode:c}=a,d=t.backend_util.computePool2DInfo(s.shape,i,o,1,l,c),p=d.filterHeight,f=d.filterWidth,m=d.padInfo.top,h=d.padInfo.right,b=d.padInfo.bottom,y=d.padInfo.left,_=d.dilationHeight,g=d.dilationWidth,w=d.strideHeight,k=d.strideWidth,I=d.inChannels,v=d.outChannels;if("channelsLast"!==d.dataFormat)throw new Error(`wasm backend does not support dataFormat:'${d.dataFormat}'. Please use 'channelsLast'.`);const M=r.makeOutput(d.outShape,"float32"),A=r.dataIdMap.get(M.dataId).id;return De(u,s.shape[0],s.shape[1],s.shape[2],p,f,m,h,b,y,_,g,w,k,I,v,A),M}};let Pe;const Re={kernelName:t.Mean,backendName:"wasm",setupFunc:function(e){Pe=e.wasm.cwrap(t.Mean,null,["number, number, number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=n.dataIdMap.get(i.dataId).id;let l=o,c=i;const{transposed:d,axes:p,originalAxes:f,inputWasTransposed:m}=I(i,s,n);let h=p;if(m){const e=n.dataIdMap.get(d.dataId).id;e!==o&&(c=d,l=e,h=t.backend_util.getInnerMostAxes(h.length,c.shape.length))}t.backend_util.assertAxesAreInnerMostDims("mean",h,c.shape.length);const[b,y]=t.backend_util.computeOutAndReduceShapes(c.shape,h),_=t.util.sizeFromShape(y);let g=c;"float32"!==c.dtype&&(g=P({backend:n,inputs:{x:c},attrs:{dtype:"float32"}}),l=n.dataIdMap.get(g.dataId).id);const w=n.makeOutput(b,"float32");if(0!==t.util.sizeFromShape(c.shape)){const e=n.dataIdMap.get(w.dataId).id;Pe(l,_,e)}if(m&&n.disposeData(d.dataId),u){const e=t.backend_util.expandShapeToKeepDim(w.shape,f);w.shape=e}return"float32"!==c.dtype&&n.disposeData(g.dataId),w}};let We;const He={kernelName:t.Min,backendName:"wasm",setupFunc:function(e){We=e.wasm.cwrap(t.Min,null,["number, number, number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=n.dataIdMap.get(i.dataId).id;let l=o,c=i;const{transposed:d,axes:p,originalAxes:f,inputWasTransposed:m}=I(i,s,n);if(m){const e=n.dataIdMap.get(d.dataId).id;e!==o&&(c=d,l=e)}const h=c.shape.length;t.backend_util.assertAxesAreInnerMostDims("min",p,h);const[b,y]=t.backend_util.computeOutAndReduceShapes(c.shape,p),_=t.util.sizeFromShape(y),g=n.makeOutput(b,c.dtype);if(0!==t.util.sizeFromShape(c.shape)){const e=n.dataIdMap.get(g.dataId).id;We(l,_,e)}if(m&&n.disposeData(d.dataId),u){const e=t.backend_util.expandShapeToKeepDim(g.shape,f);g.shape=e}return g}},ze=f(t.Minimum,!1);var Le;let Ue;!function(e){e[e.reflect=0]="reflect",e[e.symmetric=1]="symmetric"}(Le||(Le={}));const Be={kernelName:t.MirrorPad,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n,attrs:{paddings:a,mode:r}}=e,s=a.map(((e,n)=>e[0]+t.shape[n]+e[1])),u=n.dataIdMap.get(t.dataId).id,o=n.makeOutput(s,t.dtype),l=n.dataIdMap.get(o.dataId).id,c=new Uint8Array(new Int32Array(t.shape).buffer),d=a.map((e=>e[0])),p=a.map((e=>e[1])),f=new Uint8Array(new Int32Array(d).buffer),m=new Uint8Array(new Int32Array(p).buffer);return Ue(u,c,t.shape.length,i[t.dtype],f,m,Le[r],l),o},setupFunc:function(e){Ue=e.wasm.cwrap(t.MirrorPad,null,["number","array","number","number","array","array","number","number"])}},je=f(t.Multiply,!0),qe=d(t.Neg);function Ve(e,t){const n=new Int32Array(e.wasm.HEAPU8.buffer,t,4),a=n[0],r=n[1],s=n[2],u=n[3];return e.wasm._free(t),{pSelectedIndices:a,selectedSize:r,pSelectedScores:s,pValidOutputs:u}}let Ge;const $e={kernelName:t.NonMaxSuppressionV3,backendName:"wasm",setupFunc:function(e){Ge=e.wasm.cwrap(t.NonMaxSuppressionV3,"number",["number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u}=a,{boxes:i,scores:o}=n,l=t.dataIdMap.get(i.dataId).id,c=t.dataIdMap.get(o.dataId).id,d=Ge(l,c,s,r,u),{pSelectedIndices:p,selectedSize:f,pSelectedScores:m,pValidOutputs:h}=Ve(t,d);return t.wasm._free(m),t.wasm._free(h),t.makeOutput([f],"int32",p)}};let Ke;const Qe={kernelName:t.NonMaxSuppressionV4,backendName:"wasm",setupFunc:function(e){Ke=e.wasm.cwrap(t.NonMaxSuppressionV4,"number",["number","number","number","number","number","bool"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,padToMaxOutputSize:i}=a,{boxes:o,scores:l}=n,c=t.dataIdMap.get(o.dataId).id,d=t.dataIdMap.get(l.dataId).id,p=Ke(c,d,s,r,u,i),{pSelectedIndices:f,selectedSize:m,pSelectedScores:h,pValidOutputs:b}=Ve(t,p);return t.wasm._free(h),[t.makeOutput([m],"int32",f),t.makeOutput([],"int32",b)]}};let Xe;const Ze={kernelName:t.NonMaxSuppressionV5,backendName:"wasm",setupFunc:function(e){Xe=e.wasm.cwrap(t.NonMaxSuppressionV5,"number",["number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,softNmsSigma:i}=a,{boxes:o,scores:l}=n,c=t.dataIdMap.get(o.dataId).id,d=t.dataIdMap.get(l.dataId).id,p=Xe(c,d,s,r,u,i),{pSelectedIndices:f,selectedSize:m,pSelectedScores:h,pValidOutputs:b}=Ve(t,p);return t.wasm._free(b),[t.makeOutput([m],"int32",f),t.makeOutput([m],"float32",h)]}},Ye=f(t.NotEqual,!1,"bool");let Je;const et={kernelName:t.OneHot,backendName:"wasm",setupFunc:function(e){Je=e.wasm.cwrap(t.OneHot,null,["number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{indices:r}=t,{depth:s,onValue:u,offValue:i}=a,o=n.makeOutput([...r.shape,s],"int32"),l=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(r.dataId).id;return Je(c,s,u,i,l),o}};const tt={kernelName:t.OnesLike,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n}=e,a=n.makeOutput(t.shape,t.dtype);return n.typedArrayFromHeap(a).fill(1),a}};const nt={kernelName:t.Pack,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{axis:s}=r;if(1===n.length)return se({inputs:{input:n[0]},backend:a,attrs:{dim:s}});const u=n[0].shape,i=n[0].dtype;n.forEach((e=>{t.util.assertShapesMatch(u,e.shape,"All tensors passed to stack must have matching shapes"),t.util.assert(i===e.dtype,(()=>"All tensors passed to stack must have matching dtypes"))}));const o=[],l=U({inputs:n.map((e=>{const t=se({inputs:{input:e},backend:a,attrs:{dim:s}});return o.push(t),t})),backend:a,attrs:{axis:s}});return o.forEach((e=>a.disposeData(e.dataId))),l}};let at;const rt={kernelName:t.PadV2,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n,attrs:{paddings:a,constantValue:r}}=e,s=a.map(((e,n)=>e[0]+t.shape[n]+e[1])),u=n.dataIdMap.get(t.dataId).id,o=n.makeOutput(s,t.dtype),l=n.dataIdMap.get(o.dataId).id,c=new Uint8Array(new Int32Array(t.shape).buffer),d=a.map((e=>e[0])),p=a.map((e=>e[1])),f=new Uint8Array(new Int32Array(d).buffer),m=new Uint8Array(new Int32Array(p).buffer);return at(u,c,t.shape.length,i[t.dtype],f,m,r,l),o},setupFunc:function(e){at=e.wasm.cwrap(t.PadV2,null,["number","array","number","number","array","array","number","number"])}},st=f(t.Pow,!1);let ut;const it={kernelName:t.Prelu,backendName:"wasm",setupFunc:function(e){ut=e.wasm.cwrap(t.Prelu,null,["number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:a,alpha:r}=t,s=n.dataIdMap.get(a.dataId).id,u=n.dataIdMap.get(r.dataId).id,i=n.makeOutput(a.shape,"float32"),o=n.dataIdMap.get(i.dataId).id;return ut(s,u,o),i}};let ot;const lt={kernelName:t.Prod,backendName:"wasm",setupFunc:function(e){ot=e.wasm.cwrap(t.Prod,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:o}=a,l=n.dataIdMap.get(o.dataId).id;let c=l,d=o;const{transposed:p,axes:f,originalAxes:m,inputWasTransposed:h}=I(o,s,n);let b=f;if(h){const e=n.dataIdMap.get(p.dataId).id;e!==l&&(d=p,c=e,b=t.backend_util.getInnerMostAxes(b.length,d.shape.length))}t.backend_util.assertAxesAreInnerMostDims("prod",b,d.shape.length);const[y,_]=t.backend_util.computeOutAndReduceShapes(d.shape,b),g=t.util.sizeFromShape(_),w=n.makeOutput(y,d.dtype);if(0!==t.util.sizeFromShape(d.shape)){const e=n.dataIdMap.get(w.dataId).id;ot(c,g,i[w.dtype],e)}if(h&&n.disposeData(p.dataId),u){const e=t.backend_util.expandShapeToKeepDim(w.shape,m);w.shape=e}return w}},ct={kernelName:t.Range,backendName:"wasm",kernelFunc:e=>{const{backend:n,attrs:a}=e,{start:r,stop:s,step:u,dtype:i}=a,o=function(e,n,a,r){if(e===n||e<n&&a<0||n<e&&a>1)return t.util.makeZerosTypedArray(0,r);const s=Math.abs(Math.ceil((n-e)/a)),u=t.util.makeZerosTypedArray(s,r);n<e&&1===a&&(a=-1),u[0]=e;for(let e=1;e<u.length;e++)u[e]=u[e-1]+a;return u}(r,s,u,i),l=n.makeOutput([o.length],i);return n.typedArrayFromHeap(l).set(o),l}},dt=f(t.RealDiv,!0),pt=d(t.Relu),ft=d(t.Relu6);let mt;const ht={kernelName:t.ResizeBilinear,backendName:"wasm",setupFunc:function(e){mt=e.wasm.cwrap(t.ResizeBilinear,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{images:s}=a,{alignCorners:u,halfPixelCenters:i,size:o}=r,[l,c]=o,[d,p,f,m]=s.shape,h=[d,l,c,m];let b,y=n.dataIdMap.get(s.dataId);"float32"!==y.dtype&&(b=P({backend:n,inputs:{x:s},attrs:{dtype:"float32"}}),y=n.dataIdMap.get(b.dataId));const _=y.id,g=n.makeOutput(h,"float32");if(0===t.util.sizeFromShape(s.shape))return g;const w=n.dataIdMap.get(g.dataId).id;return mt(_,d,p,f,m,l,c,u?1:0,i?1:0,w),null!=b&&n.disposeData(b.dataId),g}};let bt;const yt={kernelName:t.Reverse,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{x:s}=n,{dims:u}=r,i=t.util.parseAxisParam(u,s.shape);if(0===s.shape.length)return y({inputs:{x:s},backend:a});const o=a.makeOutput(s.shape,s.dtype),l=a.dataIdMap.get(s.dataId).id,c=a.dataIdMap.get(o.dataId).id,d=new Uint8Array(new Int32Array(i).buffer),p=new Uint8Array(new Int32Array(s.shape).buffer);bt(l,d,i.length,p,s.shape.length,c);const f=T({inputs:{x:o},attrs:{shape:s.shape},backend:a});return a.disposeData(o.dataId),f},setupFunc:function(e){bt=e.wasm.cwrap(t.Reverse,null,["number","array","number","array","number","number"])}};let _t;const gt={kernelName:t.RotateWithOffset,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a,attrs:r}=e,{image:s}=n,{radians:u,fillValue:i,center:o}=r,l=a.makeOutput(s.shape,s.dtype),c=a.dataIdMap.get(s.dataId).id,d=a.dataIdMap.get(l.dataId).id,[p,f,m,h]=s.shape,[b,y]=t.backend_util.getImageCenter(o,f,m),_="number"==typeof i?[i,i,i,0===i?0:255]:[...i,255],g=new Uint8Array(new Int32Array(_).buffer);return _t(c,p,f,m,h,u,b,y,g,_.length,d),l},setupFunc:function(e){_t=e.wasm.cwrap(t.RotateWithOffset,null,["number","number","number","number","number","number","number","number","array","number","number"])}},wt=d(t.Round);let kt;let It;let vt;function Mt(e){const{inputs:{x:n},attrs:{begin:a,size:r},backend:s}=e,[u,i]=t.slice_util.parseSliceParams(n,a,r),o=t.slice_util.isSliceContinous(n.shape,u,i),l=s.readSync(n.dataId),c=s.makeOutput(i,n.dtype),d=t.util.computeStrides(n.shape),p=s.dataIdMap.get(c.dataId);if(o){const e=t.slice_util.computeFlatOffset(u,d);if("string"===n.dtype)p.stringBytes=l.slice(e,e+t.util.sizeFromShape(i));else{s.typedArrayFromHeap(c).set(l.subarray(e,e+t.util.sizeFromShape(i)))}return c}if("string"===n.dtype){const e=L(l,u,i,n.shape,n.dtype);return p.stringBytes=e,c}const f=s.typedArrayFromHeap(c),m=n.shape.length;if(2===m)!function(e,t,n,a,r){let s=0;const u=a[0],i=a[1],o=u+r[0];for(let a=u;a<o;a++){const u=a*t+i;n.set(e.subarray(u,u+r[1]),s),s+=r[1]}}(l,d[0],f,u,i);else if(3===m)!function(e,t,n,a,r,s){let u=0;const i=r[0],o=r[1],l=r[2],c=i+s[0],d=o+s[1];for(let r=i;r<c;r++)for(let i=o;i<d;i++){const o=r*t+i*n+l;a.set(e.subarray(o,o+s[2]),u),u+=s[2]}}(l,d[0],d[1],f,u,i);else if(4===m)!function(e,t,n,a,r,s,u){let i=0;const o=s[0],l=s[1],c=s[2],d=o+u[0],p=l+u[1],f=c+u[2],m=s[3];for(let s=o;s<d;s++)for(let o=l;o<p;o++)for(let l=c;l<f;l++){const c=s*t+o*n+l*a+m;r.set(e.subarray(c,c+u[3]),i),i+=u[3]}}(l,d[0],d[1],d[2],f,u,i);else{const e=L(l,u,i,n.shape,n.dtype);f.set(e)}return c}let At;let xt;let St;let Ft;let Nt;let Et;let Tt;const Ct=[p,m,b,M,x,F,E,O,R,W,z,B,q,G,$,X,Y,ee,ne,ae,re,ue,ie,le,ce,de,c,fe,he,ye,ge,ke,Ie,ve,_,Ae,xe,Se,Fe,Ne,Te,Ce,Oe,Re,He,ze,Be,je,qe,$e,Qe,Ze,Ye,et,tt,nt,rt,st,it,lt,ct,dt,pt,ft,C,ht,yt,gt,d(t.Rsqrt),wt,{kernelName:t.ScatterNd,backendName:"wasm",setupFunc:function(e){kt=e.wasm.cwrap(t.ScatterNd,null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{indices:s,updates:u}=a,{shape:o}=r,l=n.makeOutput(o,u.dtype);if(0===t.util.sizeFromShape(o))return l;const{sliceRank:c,numUpdates:d,sliceSize:p,strides:f,outputSize:m}=t.scatter_util.calculateShapes(u,s,o),h=n.dataIdMap.get(s.dataId).id,b=n.dataIdMap.get(u.dataId).id,y=new Uint8Array(new Int32Array(f).buffer),_=n.dataIdMap.get(l.dataId).id;return kt(h,b,i[u.dtype],c,d,p,y,m,_),l}},{kernelName:t.Select,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:a}=e,{condition:r,t:s,e:u}=n,i=a.dataIdMap.get(r.dataId).id,o=a.dataIdMap.get(s.dataId).id,l=a.dataIdMap.get(u.dataId).id,c=a.makeOutput(s.shape,s.dtype),d=a.dataIdMap.get(c.dataId).id,p=r.shape.length,f=s.shape.length,m=0===p||p>1||1===f?1:t.util.sizeFromShape(s.shape.slice(1));return It(i,o,l,m,d),c},setupFunc:function(e){It=e.wasm.cwrap("SelectV2",null,["number","number","number","number","number"])}},{kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){vt=e.wasm.cwrap(t.Sigmoid,null,["number","number"])},kernelFunc:function(e){const{backend:n,inputs:{x:a}}=e,r=n.dataIdMap.get(a.dataId).id,s=n.makeOutput(a.shape,a.dtype),u=n.dataIdMap.get(s.dataId).id;return 0===t.util.sizeFromShape(s.shape)||vt(r,u),s}},d(t.Sin),{kernelName:t.Slice,backendName:"wasm",kernelFunc:Mt},{kernelName:t.Softmax,backendName:"wasm",setupFunc:function(e){At=e.wasm.cwrap(t.Softmax,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:{logits:a},attrs:{dim:r}}=e,s=n.dataIdMap.get(a.dataId).id,u=n.makeOutput(a.shape,a.dtype),i=n.dataIdMap.get(u.dataId).id,o=a.shape[r],l=t.util.sizeFromShape(a.shape)/o;return 0===t.util.sizeFromShape(u.shape)||At(s,i,o,l),u}},{kernelName:t.SplitV,backendName:"wasm",kernelFunc:function(e){const{inputs:n,attrs:a,backend:r}=e,{x:s}=n,{numOrSizeSplits:u,axis:i}=a,o=t.util.parseAxisParam(i,s.shape)[0],l=t.backend_util.prepareSplitSize(s,u,o),c=new Array(s.shape.length).fill(0),d=s.shape.slice();return l.map((e=>{const t=[...d];t[o]=e;const n=Mt({inputs:{x:s},attrs:{begin:c,size:t},backend:r});return c[o]+=e,n}))}},d(t.Sqrt),d(t.Square),f(t.SquaredDifference,!0),{kernelName:t.Step,backendName:"wasm",setupFunc:function(e){xt=e.wasm.cwrap(t.Step,null,["number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:n,attrs:a}=e,{alpha:r}=a,{x:s}=n,u=t.dataIdMap.get(s.dataId).id,i=t.makeOutput(s.shape,s.dtype),o=t.dataIdMap.get(i.dataId).id;return xt(u,r,o),i}},{kernelName:t.StridedSlice,backendName:"wasm",setupFunc:function(e){St=e.wasm.cwrap(t.StridedSlice,null,["number","array","number","array","array","array","array","array","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{x:s}=a;let{begin:u,end:i,strides:o}=r;null==o&&(o=new Array(u.length));const{beginMask:l,endMask:c,ellipsisMask:d,newAxisMask:p,shrinkAxisMask:f}=r,m=t.backend_util.slice_util.maskToAxes(d);if(m.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==d&&0!==p)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==d&&0!==f)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");const h=s.shape.length-u.length,b=t.backend_util.slice_util.maskToAxes(p),y=s.shape.slice();b.forEach((e=>{u[e]=0,i[e]=1,y.splice(e,0,1)}));const _=T({inputs:{x:s},attrs:{shape:y},backend:n}),{begin:g,end:w,strides:k}=t.backend_util.slice_util.getNormalizedAxes(_.shape,m,h,u,i,o,l,c,d);u=g,i=w,o=k;const I=t.backend_util.slice_util.maskToAxes(f);I.forEach((e=>{i[e]=u[e]+1,o[e]=1}));const v=t.backend_util.slice_util.computeOutShape(u,i,o),M=v.filter(((e,t)=>-1===I.indexOf(t)));if(o.every((e=>1===e))){const e=Mt({inputs:{x:_},attrs:{begin:u,size:v},backend:n});n.disposeData(_.dataId);const t=T({inputs:{x:e},attrs:{shape:M},backend:n});return n.disposeData(e.dataId),t}const A=n.makeOutput(M,"float32");if(!M.some((e=>0===e))){const e=n.dataIdMap.get(_.dataId).id,a=new Uint8Array(new Int32Array(t.util.computeStrides(_.shape)).buffer),r=new Uint8Array(new Int32Array(u).buffer),s=new Uint8Array(new Int32Array(i).buffer),l=new Uint8Array(new Int32Array(o).buffer),c=new Uint8Array(new Int32Array(M).buffer),d=new Uint8Array(new Int32Array(t.util.computeStrides(M)).buffer),p=n.dataIdMap.get(A.dataId).id;St(e,a,_.shape.length,r,s,l,c,d,M.length,p)}n.disposeData(_.dataId);const x=T({inputs:{x:A},attrs:{shape:M},backend:n});return n.disposeData(A.dataId),x}},f(t.Sub,!0),{kernelName:t.Sum,backendName:"wasm",setupFunc:function(e){Ft=e.wasm.cwrap(t.Sum,null,["number, number, number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=n.dataIdMap.get(i.dataId).id;let l=o,c=i;const{transposed:d,axes:p,originalAxes:f,inputWasTransposed:m}=I(i,s,n);let h=p;if(m){const e=n.dataIdMap.get(d.dataId).id;e!==o&&(c=d,l=e,h=t.backend_util.getInnerMostAxes(h.length,c.shape.length))}t.backend_util.assertAxesAreInnerMostDims("sum",h,c.shape.length);const[b,y]=t.backend_util.computeOutAndReduceShapes(c.shape,h),_=t.util.sizeFromShape(y),g=n.makeOutput(b,c.dtype);if(0!==t.util.sizeFromShape(c.shape)){const e=n.dataIdMap.get(g.dataId).id;Ft(l,_,e)}if(m&&n.disposeData(d.dataId),u){const e=t.backend_util.expandShapeToKeepDim(g.shape,f);g.shape=e}return g}},d(t.Tan),d(t.Tanh),{kernelName:t.Tile,backendName:"wasm",setupFunc:function(e){Nt=e.wasm.cwrap(t.Tile,null,["number","array","number","array","number","number"])},kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{x:r}=t,s=n.dataIdMap.get(r.dataId).id,{reps:u}=a,o=new Array(r.shape.length);for(let e=0;e<o.length;e++)o[e]=r.shape[e]*u[e];const l=new Uint8Array(new Int32Array(r.shape).buffer),c=new Uint8Array(new Int32Array(o).buffer),d=n.makeOutput(o,r.dtype),p=n.dataIdMap.get(d.dataId).id;return Nt(s,l,r.shape.length,c,o.length,i[d.dtype],p),d}},{kernelName:t.TopK,backendName:"wasm",setupFunc:function(e){Et=e.wasm.cwrap(t.TopK,null,["number","array","number","number","number","bool","number","number"])},kernelFunc:({inputs:e,backend:t,attrs:n})=>{const{x:a}=e,{k:r,sorted:s}=n,u=t.dataIdMap.get(a.dataId).id,o=new Uint8Array(new Int32Array(a.shape).buffer),l=a.shape.slice();l[l.length-1]=r;const c=t.makeOutput(l,a.dtype),d=t.dataIdMap.get(c.dataId).id,p=t.makeOutput(l,"int32"),f=t.dataIdMap.get(p.dataId).id;return Et(u,o,a.shape.length,i[a.dtype],r,s,d,f),[c,p]}},{kernelName:t.Transform,backendName:"wasm",setupFunc:function(e){Tt=e.wasm.cwrap(t.Transform,null,["number","number","bool","number","number","number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:a,attrs:r}=e,{image:s,transforms:u}=a,{interpolation:i,fillMode:o,fillValue:l,outputShape:c}=r,[d,p,f,m]=s.shape,[h,b]=null!=c?c:[p,f],y=[d,h,b,m],_=new Uint8Array(new Int32Array(t.util.computeStrides(s.shape)).buffer),g=n.makeOutput(y,s.dtype),w=n.dataIdMap.get(g.dataId).id,k=n.dataIdMap.get(s.dataId).id,I=n.dataIdMap.get(u.dataId).id,v="nearest"===i?1:2;let M;switch(o){case"constant":M=1;break;case"reflect":M=2;break;case"wrap":M=3;break;case"nearest":M=4;break;default:M=1}return Tt(k,I,u.shape[0]>1,d,h,b,m,f,p,_,s.shape.length-1,v,M,l,w),g}},k,{kernelName:t.Unpack,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:n,attrs:a}=e,{value:r}=t;let{axis:s}=a;s<0&&(s+=r.shape.length);const u=r.shape[s],i=r.shape.length,o=new Array(i-1);let l=0;for(let e=0;e<i;e++)e!==s&&(o[l++]=r.shape[e]);const c=new Array(u),d=new Array(i).fill(0),p=r.shape.slice();p[s]=1;for(let e=0;e<c.length;e++)d[s]=e,c[e]=Mt({inputs:{x:r},attrs:{begin:d,size:p},backend:n});return c.map((({dataId:e,dtype:t})=>({dataId:e,dtype:t,shape:o})))}},{kernelName:t.ZerosLike,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:n}=e,a=n.makeOutput(t.shape,t.dtype);return n.typedArrayFromHeap(a).fill(0),a}}];for(const e of Ct)t.registerKernel(e);const Dt=t.env();Dt.registerFlag("WASM_HAS_SIMD_SUPPORT",(async()=>WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11])))),Dt.registerFlag("WASM_HAS_MULTITHREAD_SUPPORT",(async()=>{if(Dt.get("IS_NODE"))return!1;try{return(new MessageChannel).port1.postMessage(new SharedArrayBuffer(1)),WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,5,4,1,3,1,1,10,11,1,9,0,65,0,254,16,2,0,26,11]))}catch(e){return!1}}));var Ot="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Pt(e,t){return e(t={exports:{}},t.exports),t.exports}var Rt=Pt((function(e,t){var i,o=(i="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(i=i||__filename),function(e){function t(){return O.buffer!=W&&te(O.buffer),H}function o(){return O.buffer!=W&&te(O.buffer),z}function l(){return O.buffer!=W&&te(O.buffer),L}function c(){return O.buffer!=W&&te(O.buffer),U}function d(){return O.buffer!=W&&te(O.buffer),B}var p,f,m="undefined"!=typeof(e=e||{})?e:{};m.ready=new Promise((function(e,t){p=e,f=t}));var h,b={};for(h in m)m.hasOwnProperty(h)&&(b[h]=m[h]);var y=function(e,t){throw t},_=!1,g=!1,w=!1,k=!1;_="object"==typeof window,g="function"==typeof importScripts,w="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,k=!_&&!w&&!g;var I=m.ENVIRONMENT_IS_PTHREAD||!1;I&&(W=m.buffer);var v,M,A,x,S,F="";function N(e){return m.locateFile?m.locateFile(e,F):F+e}if(w){var E;F=g?n.dirname(F)+"/":__dirname+"/",v=function(e,t){return x||(x=a),S||(S=n),e=S.normalize(e),x.readFileSync(e,t?null:"utf8")},A=function(e){var t=v(e,!0);return t.buffer||(t=new Uint8Array(t)),q(t.buffer),t},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof on))throw e})),process.on("unhandledRejection",_e),y=function(e){process.exit(e)},m.inspect=function(){return"[Emscripten Module object]"};try{E=r}catch(e){throw console.error('The "worker_threads" module is not supported in this node.js build - perhaps a newer version is needed?'),e}Ot.Worker=E.Worker}else k?("undefined"!=typeof read&&(v=function(e){return read(e)}),A=function(e){var t;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(q("object"==typeof(t=read(e,"binary"))),t)},"undefined"!=typeof scriptArgs&&scriptArgs,"function"==typeof quit&&(y=function(e){quit(e)}),"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(_||g)&&(g?F=self.location.href:"undefined"!=typeof document&&document.currentScript&&(F=document.currentScript.src),"undefined"!=typeof i&&i&&(F=i),F=0!==F.indexOf("blob:")?F.substr(0,F.lastIndexOf("/")+1):"",w?(v=function(e,t){return x||(x=a),S||(S=n),e=S.normalize(e),x.readFileSync(e,t?null:"utf8")},A=function(e){var t=v(e,!0);return t.buffer||(t=new Uint8Array(t)),q(t.buffer),t}):(v=function(e){var t=new XMLHttpRequest;return t.open("GET",e,!1),t.send(null),t.responseText},g&&(A=function(e){var t=new XMLHttpRequest;return t.open("GET",e,!1),t.responseType="arraybuffer",t.send(null),new Uint8Array(t.response)}),M=function(e,t,n){var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=function(){200==a.status||0==a.status&&a.response?t(a.response):n()},a.onerror=n,a.send(null)}));w&&"undefined"==typeof performance&&(Ot.performance=s.performance);var T,C=m.print||console.log.bind(console),D=m.printErr||console.warn.bind(console);for(h in b)b.hasOwnProperty(h)&&(m[h]=b[h]);b=null,m.arguments&&m.arguments,m.thisProgram&&m.thisProgram,m.quit&&(y=m.quit),m.wasmBinary&&(T=m.wasmBinary);var O,P,R=m.noExitRuntime||!0;"object"!=typeof WebAssembly&&_e("no native wasm support detected");var W,H,z,L,U,B,j=!1;function q(e,t){e||_e("Assertion failed: "+t)}function V(e){var t=m["_"+e];return q(t,"Cannot call unknown function "+e+", make sure it is exported"),t}function G(e,t,n,a,r){var s={string:function(e){var t=0;if(null!=e&&0!==e){var n=1+(e.length<<2);Z(e,t=nn(n),n)}return t},array:function(e){var t=nn(e.length);return J(e,t),t}},u=V(e),i=[],o=0;if(a)for(var l=0;l<a.length;l++){var c=s[n[l]];c?(0===o&&(o=en()),i[l]=c(a[l])):i[l]=a[l]}var d=u.apply(null,i);return d=function(e){return"string"===t?Q(e):"boolean"===t?Boolean(e):e}(d),0!==o&&tn(o),d}function $(e,t,n,a){var r=(n=n||[]).every((function(e){return"number"===e}));return"string"!==t&&r&&!a?V(e):function(){return G(e,t,n,arguments)}}function K(e,t,n){for(var a=t+n,r="";!(t>=a);){var s=e[t++];if(!s)return r;if(128&s){var u=63&e[t++];if(192!=(224&s)){var i=63&e[t++];if((s=224==(240&s)?(15&s)<<12|u<<6|i:(7&s)<<18|u<<12|i<<6|63&e[t++])<65536)r+=String.fromCharCode(s);else{var o=s-65536;r+=String.fromCharCode(55296|o>>10,56320|1023&o)}}else r+=String.fromCharCode((31&s)<<6|u)}else r+=String.fromCharCode(s)}return r}function Q(e,t){return e?K(o(),e,t):""}function X(e,t,n,a){if(!(a>0))return 0;for(var r=n,s=n+a-1,u=0;u<e.length;++u){var i=e.charCodeAt(u);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++u)),i<=127){if(n>=s)break;t[n++]=i}else if(i<=2047){if(n+1>=s)break;t[n++]=192|i>>6,t[n++]=128|63&i}else if(i<=65535){if(n+2>=s)break;t[n++]=224|i>>12,t[n++]=128|i>>6&63,t[n++]=128|63&i}else{if(n+3>=s)break;t[n++]=240|i>>18,t[n++]=128|i>>12&63,t[n++]=128|i>>6&63,t[n++]=128|63&i}}return t[n]=0,n-r}function Z(e,t,n){return X(e,o(),t,n)}function Y(e){for(var t=0,n=0;n<e.length;++n){var a=e.charCodeAt(n);a>=55296&&a<=57343&&(a=65536+((1023&a)<<10)|1023&e.charCodeAt(++n)),a<=127?++t:t+=a<=2047?2:a<=65535?3:4}return t}function J(e,n){t().set(e,n)}function ee(e,t){return e%t>0&&(e+=t-e%t),e}function te(e){W=e,m.HEAP8=H=new Int8Array(e),m.HEAP16=new Int16Array(e),m.HEAP32=L=new Int32Array(e),m.HEAPU8=z=new Uint8Array(e),m.HEAPU16=new Uint16Array(e),m.HEAPU32=U=new Uint32Array(e),m.HEAPF32=new Float32Array(e),m.HEAPF64=B=new Float64Array(e)}var ne,ae=m.INITIAL_MEMORY||16777216;if(I)O=m.wasmMemory,W=m.buffer;else if(m.wasmMemory)O=m.wasmMemory;else if(!((O=new WebAssembly.Memory({initial:ae/65536,maximum:32768,shared:!0})).buffer instanceof SharedArrayBuffer))throw D("requested a shared WebAssembly.Memory but the returned buffer is not a SharedArrayBuffer, indicating that while the browser has SharedArrayBuffer it does not have WebAssembly threads support - you may need to set a flag"),w&&console.log("(on node you may need: --experimental-wasm-threads --experimental-wasm-bulk-memory and also use a recent version)"),Error("bad memory");O&&(W=O.buffer),ae=W.byteLength,te(W);var re=[],se=[],ue=[],ie=[];function oe(){if(!I){if(m.preRun)for("function"==typeof m.preRun&&(m.preRun=[m.preRun]);m.preRun.length;)pe(m.preRun.shift());Ee(re)}}function le(){I||Ee(se)}function ce(){I||Ee(ue)}function de(){if(!I){if(m.postRun)for("function"==typeof m.postRun&&(m.postRun=[m.postRun]);m.postRun.length;)fe(m.postRun.shift());Ee(ie)}}function pe(e){re.unshift(e)}function fe(e){ie.unshift(e)}I||se.push({func:function(){Lt()}});var me=0,he=null;function be(e){q(!I,"addRunDependency cannot be used in a pthread worker"),me++,m.monitorRunDependencies&&m.monitorRunDependencies(me)}function ye(e){if(me--,m.monitorRunDependencies&&m.monitorRunDependencies(me),0==me&&he){var t=he;he=null,t()}}function _e(e){m.onAbort&&m.onAbort(e),I&&console.error("Pthread aborting at "+(new Error).stack),D(e+=""),j=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.";var t=new WebAssembly.RuntimeError(e);throw f(t),t}function ge(e,t){return String.prototype.startsWith?e.startsWith(t):0===e.indexOf(t)}m.preloadedImages={},m.preloadedAudios={};var we="data:application/octet-stream;base64,";function ke(e){return ge(e,we)}var Ie="file://";function ve(e){return ge(e,Ie)}var Me="tfjs-backend-wasm-threaded-simd.wasm";function Ae(e){try{if(e==Me&&T)return new Uint8Array(T);if(A)return A(e);throw"both async and sync fetching of the wasm failed"}catch(e){_e(e)}}function xe(){if(!T&&(_||g)){if("function"==typeof fetch&&!ve(Me))return fetch(Me,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+Me+"'";return e.arrayBuffer()})).catch((function(){return Ae(Me)}));if(M)return new Promise((function(e,t){M(Me,(function(t){e(new Uint8Array(t))}),t)}))}return Promise.resolve().then((function(){return Ae(Me)}))}function Se(){var e={a:zt};function t(e,t){var n=e.exports;if(m.asm=n,ne=m.asm.F,P=t,!I){var a=Re.unusedWorkers.length;Re.unusedWorkers.forEach((function(e){Re.loadWasmModuleToWorker(e,(function(){--a||ye()}))}))}}function n(e){t(e.instance,e.module)}function a(t){return xe().then((function(t){return WebAssembly.instantiate(t,e)})).then(t,(function(e){D("failed to asynchronously prepare wasm: "+e),_e(e)}))}if(I||be(),m.instantiateWasm)try{return m.instantiateWasm(e,t)}catch(e){return D("Module.instantiateWasm callback failed with error: "+e),!1}return(T||"function"!=typeof WebAssembly.instantiateStreaming||ke(Me)||ve(Me)||"function"!=typeof fetch?a(n):fetch(Me,{credentials:"same-origin"}).then((function(t){return WebAssembly.instantiateStreaming(t,e).then(n,(function(e){return D("wasm streaming compile failed: "+e),D("falling back to ArrayBuffer instantiation"),a(n)}))}))).catch(f),{}}ke(Me)||(Me=N(Me));var Fe={9816:function(){throw"Canceled!"},9834:function(e,t){setTimeout((function(){Qt(e,t)}),0)}};function Ne(){Re.initRuntime()}function Ee(e){for(;e.length>0;){var t=e.shift();if("function"!=typeof t){var n=t.func;"number"==typeof n?void 0===t.arg?ne.get(n)():ne.get(n)(t.arg):n(void 0===t.arg?null:t.arg)}else t(m)}}function Te(e,n){if(e<=0||e>t().length||!0&e||n<0)return-28;if(0==n)return 0;n>=2147483647&&(n=1/0);var a=Atomics.load(l(),un>>2),r=0;if(a==e&&Atomics.compareExchange(l(),un>>2,a,0)==a&&(r=1,--n<=0))return 1;var s=Atomics.notify(l(),e>>2,n);if(s>=0)return s+r;throw"Atomics.notify returned an unexpected value "+s}function Ce(e){if(I)throw"Internal Error! killThread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in killThread!";l()[e+12>>2]=0;var t=Re.pthreads[e];t.worker.terminate(),Re.freeThreadData(t),Re.runningWorkers.splice(Re.runningWorkers.indexOf(t.worker),1),t.worker.pthread=void 0}function De(e){if(I)throw"Internal Error! cancelThread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in cancelThread!";Re.pthreads[e].worker.postMessage({cmd:"cancel"})}function Oe(e){if(I)throw"Internal Error! cleanupThread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in cleanupThread!";var t=Re.pthreads[e];if(t){l()[e+12>>2]=0;var n=t.worker;Re.returnWorkerToPool(n)}}m._emscripten_futex_wake=Te;var Pe,Re={unusedWorkers:[],runningWorkers:[],initMainThreadBlock:function(){for(var e=Math.min(4,Math.max(1,(navigator.hardwareConcurrency||1)/2)),t=0;t<e;++t)Re.allocateUnusedWorker()},initRuntime:function(){for(var e=Ut(228),t=0;t<57;++t)c()[e/4+t]=0;l()[e+12>>2]=e;var n=e+152;l()[n>>2]=n;var a=Ut(512);for(t=0;t<128;++t)c()[a/4+t]=0;Atomics.store(c(),e+100>>2,a),Atomics.store(c(),e+40>>2,e),Jt(e,!g,1),Kt(e)},initWorker:function(){},pthreads:{},threadExitHandlers:[],setThreadStatus:function(){},runExitHandlers:function(){for(;Re.threadExitHandlers.length>0;)Re.threadExitHandlers.pop()();I&&Vt()&&Gt()},runExitHandlersAndDeinitThread:function(e,t){Atomics.store(c(),e+56>>2,1),Atomics.store(c(),e+60>>2,0),Re.runExitHandlers(),Atomics.store(c(),e+4>>2,t),Atomics.store(c(),e+0>>2,1),Te(e+0,2147483647),Jt(0,0,0)},threadExit:function(e){var t=Vt();t&&(Re.runExitHandlersAndDeinitThread(t,e),I&&postMessage({cmd:"exit"}))},threadCancel:function(){Re.runExitHandlersAndDeinitThread(Vt(),-1),postMessage({cmd:"cancelDone"})},terminateAllThreads:function(){for(var e in Re.pthreads)(a=Re.pthreads[e])&&a.worker&&Re.returnWorkerToPool(a.worker);Re.pthreads={};for(var t=0;t<Re.unusedWorkers.length;++t)(n=Re.unusedWorkers[t]).terminate();for(Re.unusedWorkers=[],t=0;t<Re.runningWorkers.length;++t){var n,a=(n=Re.runningWorkers[t]).pthread;Re.freeThreadData(a),n.terminate()}Re.runningWorkers=[]},freeThreadData:function(e){if(e){if(e.threadInfoStruct){var t=l()[e.threadInfoStruct+100>>2];l()[e.threadInfoStruct+100>>2]=0,Bt(t),Bt(e.threadInfoStruct)}e.threadInfoStruct=0,e.allocatedOwnStack&&e.stackBase&&Bt(e.stackBase),e.stackBase=0,e.worker&&(e.worker.pthread=null)}},returnWorkerToPool:function(e){Re.runWithoutMainThreadQueuedCalls((function(){delete Re.pthreads[e.pthread.threadInfoStruct],Re.unusedWorkers.push(e),Re.runningWorkers.splice(Re.runningWorkers.indexOf(e),1),Re.freeThreadData(e.pthread),e.pthread=void 0}))},runWithoutMainThreadQueuedCalls:function(e){l()[sn>>2]=0;try{e()}finally{l()[sn>>2]=1}},receiveObjectTransfer:function(e){},loadWasmModuleToWorker:function(e,t){e.onmessage=function(n){var a=n.data,r=a.cmd;if(e.pthread&&(Re.currentProxiedOperationCallerThread=e.pthread.threadInfoStruct),a.targetThread&&a.targetThread!=Vt()){var s=Re.pthreads[a.targetThread];return s?s.worker.postMessage(n.data,a.transferList):console.error('Internal error! Worker sent a message "'+r+'" to target pthread '+a.targetThread+", but that thread no longer exists!"),void(Re.currentProxiedOperationCallerThread=void 0)}if("processQueuedMainThreadWork"===r)$t();else if("spawnThread"===r)Dt(n.data);else if("cleanupThread"===r)Oe(a.thread);else if("killThread"===r)Ce(a.thread);else if("cancelThread"===r)De(a.thread);else if("loaded"===r)e.loaded=!0,t&&t(e),e.runPthread&&(e.runPthread(),delete e.runPthread);else if("print"===r)C("Thread "+a.threadId+": "+a.text);else if("printErr"===r)D("Thread "+a.threadId+": "+a.text);else if("alert"===r)alert("Thread "+a.threadId+": "+a.text);else if("exit"===r)e.pthread&&Atomics.load(c(),e.pthread.threadInfoStruct+64>>2)&&Re.returnWorkerToPool(e);else if("exitProcess"===r)try{cn(a.returnCode)}catch(n){if(n instanceof on)return;throw n}else"cancelDone"===r?Re.returnWorkerToPool(e):"objectTransfer"===r?Re.receiveObjectTransfer(n.data):"setimmediate"===n.data.target?e.postMessage(n.data):D("worker sent an unknown command "+r);Re.currentProxiedOperationCallerThread=void 0},e.onerror=function(e){D("pthread sent an error! "+e.filename+":"+e.lineno+": "+e.message)},w&&(e.on("message",(function(t){e.onmessage({data:t})})),e.on("error",(function(t){e.onerror(t)})),e.on("exit",(function(e){}))),e.postMessage({cmd:"load",urlOrBlob:m.mainScriptUrlOrBlob||i,wasmMemory:O,wasmModule:P})},allocateUnusedWorker:function(){var e=N("tfjs-backend-wasm-threaded-simd.worker.js");Re.unusedWorkers.push(new Worker(e))},getNewWorker:function(){return 0==Re.unusedWorkers.length&&(Re.allocateUnusedWorker(),Re.loadWasmModuleToWorker(Re.unusedWorkers[0])),Re.unusedWorkers.length>0?Re.unusedWorkers.pop():null},busySpinWait:function(e){for(var t=performance.now()+e;performance.now()<t;);}};function We(e,t){an(e,t),tn(e)}function He(){return R}function ze(e,t){return ne.get(e)(t)}function Le(e,t,n,a){_e("Assertion failed: "+Q(e)+", at: "+[t?Q(t):"unknown filename",n,a?Q(a):"unknown function"])}function Ue(e,t){_main(e,t)}function Be(e){return l()[jt()>>2]=e,e}function je(e,t){if(I)return Ze(1,1,e,t)}function qe(e,t){if(e==t)postMessage({cmd:"processQueuedMainThreadWork"});else if(I)postMessage({targetThread:e,cmd:"processThreadQueue"});else{var n=Re.pthreads[e],a=n&&n.worker;if(!a)return;a.postMessage({cmd:"processThreadQueue"})}return 1}function Ve(){_e()}function Ge(e,t,n){var a=et(t,n);return Fe[e].apply(null,a)}function $e(e,t){}function Ke(e,n,a){if(e<=0||e>t().length||!0&e)return-28;if(_){if(Atomics.load(l(),e>>2)!=n)return-6;var r=performance.now(),s=r+a;for(Atomics.exchange(l(),un>>2,e);;){if((r=performance.now())>s)return Atomics.exchange(l(),un>>2,0),-73;if(0==Atomics.exchange(l(),un>>2,0))break;if($t(),Atomics.load(l(),e>>2)!=n)return-6;Atomics.exchange(l(),un>>2,e)}return 0}var u=Atomics.wait(l(),e>>2,n,a);if("timed-out"===u)return-73;if("not-equal"===u)return-6;if("ok"===u)return 0;throw"Atomics.wait returned an unexpected value "+u}function Qe(e,t,n){o().copyWithin(e,t,t+n)}function Xe(){return w?u.cpus().length:navigator.hardwareConcurrency}function Ze(e,t){for(var n=arguments.length-2,a=en(),r=n,s=nn(8*r),u=s>>3,i=0;i<n;i++){var o=arguments[2+i];d()[u+i]=o}var l=Zt(e,r,s,t);return tn(a),l}m.establishStackSpace=We,m.getNoExitRuntime=He,m.invokeEntryPoint=ze,Pe=w?function(){var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:I?function(){return performance.now()-m.__performance_now_clock_drift}:"undefined"!=typeof dateNow?dateNow:function(){return performance.now()};var Ye=[],Je=[];function et(e,t){var n;for(Je.length=0,t>>=2;n=o()[e++];){var a=n<105;a&&1&t&&t++,Je.push(a?d()[t++>>1]:l()[t]),++t}return Je}function tt(e,t,n){Ye.length=t;for(var a=n>>3,r=0;r<t;r++)Ye[r]=d()[a+r];return(e<0?Fe[-e-1]:Ht[e]).apply(null,Ye)}function nt(){return o().length}function at(e){try{return O.grow(e-W.byteLength+65535>>>16),te(O.buffer),1}catch(e){}}function rt(e){var t=nt();if(e<=t)return!1;var n=2147483648;if(e>n)return!1;for(var a=1;a<=4;a*=2){var r=t*(1+.2/a);if(r=Math.min(r,e+100663296),at(Math.min(n,ee(Math.max(e,r),65536))))return!0}return!1}var st={inEventHandler:0,removeAllEventListeners:function(){for(var e=st.eventHandlers.length-1;e>=0;--e)st._removeHandler(e);st.eventHandlers=[],st.deferredCalls=[]},registerRemoveEventListeners:function(){st.removeEventListenersRegistered||(st.removeEventListenersRegistered=!0)},deferredCalls:[],deferCall:function(e,t,n){function a(e,t){if(e.length!=t.length)return!1;for(var n in e)if(e[n]!=t[n])return!1;return!0}for(var r in st.deferredCalls){var s=st.deferredCalls[r];if(s.targetFunction==e&&a(s.argsList,n))return}st.deferredCalls.push({targetFunction:e,precedence:t,argsList:n}),st.deferredCalls.sort((function(e,t){return e.precedence<t.precedence}))},removeDeferredCalls:function(e){for(var t=0;t<st.deferredCalls.length;++t)st.deferredCalls[t].targetFunction==e&&(st.deferredCalls.splice(t,1),--t)},canPerformEventHandlerRequests:function(){return st.inEventHandler&&st.currentEventHandler.allowsDeferredCalls},runDeferredCalls:function(){if(st.canPerformEventHandlerRequests())for(var e=0;e<st.deferredCalls.length;++e){var t=st.deferredCalls[e];st.deferredCalls.splice(e,1),--e,t.targetFunction.apply(null,t.argsList)}},eventHandlers:[],removeAllHandlersOnTarget:function(e,t){for(var n=0;n<st.eventHandlers.length;++n)st.eventHandlers[n].target!=e||t&&t!=st.eventHandlers[n].eventTypeString||st._removeHandler(n--)},_removeHandler:function(e){var t=st.eventHandlers[e];t.target.removeEventListener(t.eventTypeString,t.eventListenerFunc,t.useCapture),st.eventHandlers.splice(e,1)},registerOrRemoveHandler:function(e){var t=function(t){++st.inEventHandler,st.currentEventHandler=e,st.runDeferredCalls(),e.handlerFunc(t),st.runDeferredCalls(),--st.inEventHandler};if(e.callbackfunc)e.eventListenerFunc=t,e.target.addEventListener(e.eventTypeString,t,e.useCapture),st.eventHandlers.push(e),st.registerRemoveEventListeners();else for(var n=0;n<st.eventHandlers.length;++n)st.eventHandlers[n].target==e.target&&st.eventHandlers[n].eventTypeString==e.eventTypeString&&st._removeHandler(n--)},queueEventHandlerOnThread_iiii:function(e,t,n,a,r){var s=en(),u=nn(12);l()[u>>2]=n,l()[u+4>>2]=a,l()[u+8>>2]=r,Yt(0,e,637534208,t,a,u),tn(s)},getTargetThreadForEventCallback:function(e){switch(e){case 1:return 0;case 2:return Re.currentProxiedOperationCallerThread;default:return e}},getNodeNameForTarget:function(e){return e?e==window?"#window":e==screen?"#screen":e&&e.nodeName?e.nodeName:"":""},fullscreenEnabled:function(){return document.fullscreenEnabled||document.webkitFullscreenEnabled}};function ut(e){var t=Y(e)+1,n=Ut(t);return Z(e,n,t),n}function it(e,t,n,a){var r=en(),s=nn(12),u=0;t&&(u=ut(t)),l()[s>>2]=u,l()[s+4>>2]=n,l()[s+8>>2]=a,Yt(0,e,657457152,0,u,s),tn(r)}function ot(e,t,n,a){it(e,t=t?Q(t):"",n,a)}function lt(e){return e>2?Q(e):e}var ct=[0,"undefined"!=typeof document?document:0,"undefined"!=typeof window?window:0];function dt(e){return e=lt(e),ct[e]||("undefined"!=typeof document?document.querySelector(e):void 0)}function pt(e){return dt(e)}function ft(e,t,n){var a=pt(e);if(!a)return-4;if(a.canvasSharedPtr&&(l()[a.canvasSharedPtr>>2]=t,l()[a.canvasSharedPtr+4>>2]=n),!a.offscreenCanvas&&a.controlTransferredOffscreen)return a.canvasSharedPtr?(ot(l()[a.canvasSharedPtr+8>>2],e,t,n),1):-4;a.offscreenCanvas&&(a=a.offscreenCanvas);var r=!1;if(a.GLctxObject&&a.GLctxObject.GLctx){var s=a.GLctxObject.GLctx.getParameter(2978);r=0===s[0]&&0===s[1]&&s[2]===a.width&&s[3]===a.height}return a.width=t,a.height=n,r&&a.GLctxObject.GLctx.viewport(0,0,t,n),0}function mt(e,t,n){return I?Ze(2,1,e,t,n):ft(e,t,n)}function ht(e,t,n){return pt(e)?ft(e,t,n):mt(e,t,n)}function bt(e){}function yt(e,t){}function _t(e){var t=e.getExtension("ANGLE_instanced_arrays");if(t)return e.vertexAttribDivisor=function(e,n){t.vertexAttribDivisorANGLE(e,n)},e.drawArraysInstanced=function(e,n,a,r){t.drawArraysInstancedANGLE(e,n,a,r)},e.drawElementsInstanced=function(e,n,a,r,s){t.drawElementsInstancedANGLE(e,n,a,r,s)},1}function gt(e){var t=e.getExtension("OES_vertex_array_object");if(t)return e.createVertexArray=function(){return t.createVertexArrayOES()},e.deleteVertexArray=function(e){t.deleteVertexArrayOES(e)},e.bindVertexArray=function(e){t.bindVertexArrayOES(e)},e.isVertexArray=function(e){return t.isVertexArrayOES(e)},1}function wt(e){var t=e.getExtension("WEBGL_draw_buffers");if(t)return e.drawBuffers=function(e,n){t.drawBuffersWEBGL(e,n)},1}function kt(e){return!!(e.multiDrawWebgl=e.getExtension("WEBGL_multi_draw"))}var It={counter:1,buffers:[],programs:[],framebuffers:[],renderbuffers:[],textures:[],uniforms:[],shaders:[],vaos:[],contexts:{},offscreenCanvases:{},timerQueriesEXT:[],programInfos:{},stringCache:{},unpackAlignment:4,recordError:function(e){It.lastError||(It.lastError=e)},getNewId:function(e){for(var t=It.counter++,n=e.length;n<t;n++)e[n]=null;return t},getSource:function(e,t,n,a){for(var r="",s=0;s<t;++s){var u=a?l()[a+4*s>>2]:-1;r+=Q(l()[n+4*s>>2],u<0?void 0:u)}return r},createContext:function(e,t){var n=e.getContext("webgl",t);return n?It.registerContext(n,t):0},registerContext:function(e,t){var n=Ut(8);l()[n+4>>2]=Vt();var a={handle:n,attributes:t,version:t.majorVersion,GLctx:e};return e.canvas&&(e.canvas.GLctxObject=a),It.contexts[n]=a,("undefined"==typeof t.enableExtensionsByDefault||t.enableExtensionsByDefault)&&It.initExtensions(a),n},makeContextCurrent:function(e){return It.currentContext=It.contexts[e],m.ctx=xt=It.currentContext&&It.currentContext.GLctx,!(e&&!xt)},getContext:function(e){return It.contexts[e]},deleteContext:function(e){It.currentContext===It.contexts[e]&&(It.currentContext=null),"object"==typeof st&&st.removeAllHandlersOnTarget(It.contexts[e].GLctx.canvas),It.contexts[e]&&It.contexts[e].GLctx.canvas&&(It.contexts[e].GLctx.canvas.GLctxObject=void 0),Bt(It.contexts[e].handle),It.contexts[e]=null},initExtensions:function(e){if(e||(e=It.currentContext),!e.initExtensionsDone){e.initExtensionsDone=!0;var t=e.GLctx;_t(t),gt(t),wt(t),t.disjointTimerQueryExt=t.getExtension("EXT_disjoint_timer_query"),kt(t),(t.getSupportedExtensions()||[]).forEach((function(e){e.indexOf("lose_context")<0&&e.indexOf("debug")<0&&t.getExtension(e)}))}},populateUniformTable:function(e){for(var t=It.programs[e],n=It.programInfos[e]={uniforms:{},maxUniformLength:0,maxAttributeLength:-1,maxUniformBlockNameLength:-1},a=n.uniforms,r=xt.getProgramParameter(t,35718),s=0;s<r;++s){var u=xt.getActiveUniform(t,s),i=u.name;n.maxUniformLength=Math.max(n.maxUniformLength,i.length+1),"]"==i.slice(-1)&&(i=i.slice(0,i.lastIndexOf("[")));var o=xt.getUniformLocation(t,i);if(o){var l=It.getNewId(It.uniforms);a[i]=[u.size,l],It.uniforms[l]=o;for(var c=1;c<u.size;++c){var d=i+"["+c+"]";o=xt.getUniformLocation(t,d),l=It.getNewId(It.uniforms),It.uniforms[l]=o}}}}},vt=["default","low-power","high-performance"];function Mt(e,t){var n=t>>2,a=l()[n+6],r={alpha:!!l()[n+0],depth:!!l()[n+1],stencil:!!l()[n+2],antialias:!!l()[n+3],premultipliedAlpha:!!l()[n+4],preserveDrawingBuffer:!!l()[n+5],powerPreference:vt[a],failIfMajorPerformanceCaveat:!!l()[n+7],majorVersion:l()[n+8],minorVersion:l()[n+9],enableExtensionsByDefault:l()[n+10],explicitSwapControl:l()[n+11],proxyContextToMainThread:l()[n+12],renderViaOffscreenBackBuffer:l()[n+13]},s=pt(e);return s?r.explicitSwapControl?0:It.createContext(s,r):0}function At(e,t){return Mt(e,t)}var xt,St={mappings:{},buffers:[null,[],[]],printChar:function(e,t){var n=St.buffers[e];0===t||10===t?((1===e?C:D)(K(n,0)),n.length=0):n.push(t)},varargs:void 0,get:function(){return St.varargs+=4,l()[St.varargs-4>>2]},getStr:function(e){return Q(e)},get64:function(e,t){return e}};function Ft(e){return I?Ze(3,1,e):0}function Nt(e,t,n,a,r){if(I)return Ze(4,1,e,t,n,a,r)}function Et(e,t,n,a){if(I)return Ze(5,1,e,t,n,a);for(var r=0,s=0;s<n;s++){for(var u=l()[t+8*s>>2],i=l()[t+(8*s+4)>>2],c=0;c<i;c++)St.printChar(e,o()[u+c]);r+=i}return l()[a>>2]=r,0}function Tt(e){var t=Re.threadExitHandlers.pop();e&&t()}function Ct(e,t){Re.threadExitHandlers.push((function(){ne.get(e)(t)}))}function Dt(e){if(I)throw"Internal Error! spawnThread() can only ever be called from main application thread!";var t=Re.getNewWorker();if(void 0!==t.pthread)throw"Internal error!";if(!e.pthread_ptr)throw"Internal error, no pthread ptr!";Re.runningWorkers.push(t);for(var n=Ut(512),a=0;a<128;++a)l()[n+4*a>>2]=0;var r=e.stackBase+e.stackSize,s=Re.pthreads[e.pthread_ptr]={worker:t,stackBase:e.stackBase,stackSize:e.stackSize,allocatedOwnStack:e.allocatedOwnStack,threadInfoStruct:e.pthread_ptr},u=s.threadInfoStruct>>2;Atomics.store(c(),u+16,e.detached),Atomics.store(c(),u+25,n),Atomics.store(c(),u+10,s.threadInfoStruct),Atomics.store(c(),u+20,e.stackSize),Atomics.store(c(),u+19,r),Atomics.store(c(),u+26,e.stackSize),Atomics.store(c(),u+28,r),Atomics.store(c(),u+29,e.detached);var i=qt()+40;Atomics.store(c(),u+43,i),t.pthread=s;var o={cmd:"run",start_routine:e.startRoutine,arg:e.arg,threadInfoStruct:e.pthread_ptr,stackBase:e.stackBase,stackSize:e.stackSize};t.runPthread=function(){o.time=performance.now(),t.postMessage(o,e.transferList)},t.loaded&&(t.runPthread(),delete t.runPthread)}function Pt(e,t,n,a){if("undefined"==typeof SharedArrayBuffer)return D("Current environment does not support SharedArrayBuffer, pthreads are not available!"),6;if(!e)return D("pthread_create called with a null thread pointer!"),28;var r=[];if(I&&0===r.length)return Xt(687865856,e,t,n,a);var s=0,u=0,i=0;t&&-1!=t?(s=l()[t>>2],s+=81920,u=l()[t+8>>2],i=0!==l()[t+12>>2]):s=2097152;var o=0==u;o?u=rn(16,s):q((u-=s)>0);for(var d=Ut(228),p=0;p<57;++p)c()[(d>>2)+p]=0;l()[e>>2]=d,l()[d+12>>2]=d;var f=d+152;l()[f>>2]=f;var m={stackBase:u,stackSize:s,allocatedOwnStack:o,detached:i,startRoutine:n,pthread_ptr:d,arg:a,transferList:r};return I?(m.cmd="spawnThread",postMessage(m,r)):Dt(m),0}function Rt(e){if(I)return Ze(6,1,e);switch(e){case 30:return 16384;case 85:return 131072;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:case 80:case 81:case 79:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator&&navigator.hardwareConcurrency||1}return Be(28),-1}I||Re.initMainThreadBlock();var Wt,Ht=[null,je,mt,Ft,Nt,Et,Rt],zt={e:Le,r:Ue,x:qe,b:Ve,y:Ge,j:$e,c:Ke,d:Te,f:Pe,p:Qe,z:Xe,u:tt,q:rt,v:ht,i:bt,t:yt,w:At,m:Ft,n:Nt,g:Et,o:Ne,a:O||m.wasmMemory,k:Tt,l:Ct,h:Pt,s:Rt},Lt=(Se(),m.___wasm_call_ctors=function(){return(Lt=m.___wasm_call_ctors=m.asm.A).apply(null,arguments)}),Ut=(m._init=function(){return(m._init=m.asm.B).apply(null,arguments)},m._register_tensor=function(){return(m._register_tensor=m.asm.C).apply(null,arguments)},m._dispose_data=function(){return(m._dispose_data=m.asm.D).apply(null,arguments)},m._dispose=function(){return(m._dispose=m.asm.E).apply(null,arguments)},m._Abs=function(){return(m._Abs=m.asm.G).apply(null,arguments)},m._Add=function(){return(m._Add=m.asm.H).apply(null,arguments)},m._AddN=function(){return(m._AddN=m.asm.I).apply(null,arguments)},m._All=function(){return(m._All=m.asm.J).apply(null,arguments)},m._Any=function(){return(m._Any=m.asm.K).apply(null,arguments)},m._ArgMax=function(){return(m._ArgMax=m.asm.L).apply(null,arguments)},m._AvgPool=function(){return(m._AvgPool=m.asm.M).apply(null,arguments)},m._BatchMatMul=function(){return(m._BatchMatMul=m.asm.N).apply(null,arguments)},m._Ceil=function(){return(m._Ceil=m.asm.O).apply(null,arguments)},m._ClipByValue=function(){return(m._ClipByValue=m.asm.P).apply(null,arguments)},m._Conv2D=function(){return(m._Conv2D=m.asm.Q).apply(null,arguments)},m._Conv2DBackpropInput=function(){return(m._Conv2DBackpropInput=m.asm.R).apply(null,arguments)},m._Cos=function(){return(m._Cos=m.asm.S).apply(null,arguments)},m._CropAndResize=function(){return(m._CropAndResize=m.asm.T).apply(null,arguments)},m._Cumsum=function(){return(m._Cumsum=m.asm.U).apply(null,arguments)},m._DepthToSpace=function(){return(m._DepthToSpace=m.asm.V).apply(null,arguments)},m._DepthwiseConv2dNative=function(){return(m._DepthwiseConv2dNative=m.asm.W).apply(null,arguments)},m._Equal=function(){return(m._Equal=m.asm.X).apply(null,arguments)},m._Exp=function(){return(m._Exp=m.asm.Y).apply(null,arguments)},m._FlipLeftRight=function(){return(m._FlipLeftRight=m.asm.Z).apply(null,arguments)},m._Floor=function(){return(m._Floor=m.asm._).apply(null,arguments)},m._FloorDiv=function(){return(m._FloorDiv=m.asm.$).apply(null,arguments)},m._FusedBatchNorm=function(){return(m._FusedBatchNorm=m.asm.aa).apply(null,arguments)},m._FusedConv2D=function(){return(m._FusedConv2D=m.asm.ba).apply(null,arguments)},m._FusedDepthwiseConv2D=function(){return(m._FusedDepthwiseConv2D=m.asm.ca).apply(null,arguments)},m._Gather=function(){return(m._Gather=m.asm.da).apply(null,arguments)},m._GatherNd=function(){return(m._GatherNd=m.asm.ea).apply(null,arguments)},m._Greater=function(){return(m._Greater=m.asm.fa).apply(null,arguments)},m._GreaterEqual=function(){return(m._GreaterEqual=m.asm.ga).apply(null,arguments)},m._LeakyRelu=function(){return(m._LeakyRelu=m.asm.ha).apply(null,arguments)},m._Less=function(){return(m._Less=m.asm.ia).apply(null,arguments)},m._LessEqual=function(){return(m._LessEqual=m.asm.ja).apply(null,arguments)},m._Log=function(){return(m._Log=m.asm.ka).apply(null,arguments)},m._LogicalAnd=function(){return(m._LogicalAnd=m.asm.la).apply(null,arguments)},m._Max=function(){return(m._Max=m.asm.ma).apply(null,arguments)},m._MaxPool=function(){return(m._MaxPool=m.asm.na).apply(null,arguments)},m._Maximum=function(){return(m._Maximum=m.asm.oa).apply(null,arguments)},m._Mean=function(){return(m._Mean=m.asm.pa).apply(null,arguments)},m._Min=function(){return(m._Min=m.asm.qa).apply(null,arguments)},m._Minimum=function(){return(m._Minimum=m.asm.ra).apply(null,arguments)},m._MirrorPad=function(){return(m._MirrorPad=m.asm.sa).apply(null,arguments)},m._Multiply=function(){return(m._Multiply=m.asm.ta).apply(null,arguments)},m._Neg=function(){return(m._Neg=m.asm.ua).apply(null,arguments)},m._NonMaxSuppressionV3=function(){return(m._NonMaxSuppressionV3=m.asm.va).apply(null,arguments)},m._NonMaxSuppressionV4=function(){return(m._NonMaxSuppressionV4=m.asm.wa).apply(null,arguments)},m._NonMaxSuppressionV5=function(){return(m._NonMaxSuppressionV5=m.asm.xa).apply(null,arguments)},m._NotEqual=function(){return(m._NotEqual=m.asm.ya).apply(null,arguments)},m._OneHot=function(){return(m._OneHot=m.asm.za).apply(null,arguments)},m._PadV2=function(){return(m._PadV2=m.asm.Aa).apply(null,arguments)},m._Pow=function(){return(m._Pow=m.asm.Ba).apply(null,arguments)},m._Prelu=function(){return(m._Prelu=m.asm.Ca).apply(null,arguments)},m._Prod=function(){return(m._Prod=m.asm.Da).apply(null,arguments)},m._RealDiv=function(){return(m._RealDiv=m.asm.Ea).apply(null,arguments)},m._Relu=function(){return(m._Relu=m.asm.Fa).apply(null,arguments)},m._Relu6=function(){return(m._Relu6=m.asm.Ga).apply(null,arguments)},m._ResizeBilinear=function(){return(m._ResizeBilinear=m.asm.Ha).apply(null,arguments)},m._Reverse=function(){return(m._Reverse=m.asm.Ia).apply(null,arguments)},m._RotateWithOffset=function(){return(m._RotateWithOffset=m.asm.Ja).apply(null,arguments)},m._Round=function(){return(m._Round=m.asm.Ka).apply(null,arguments)},m._Rsqrt=function(){return(m._Rsqrt=m.asm.La).apply(null,arguments)},m._ScatterNd=function(){return(m._ScatterNd=m.asm.Ma).apply(null,arguments)},m._SelectV2=function(){return(m._SelectV2=m.asm.Na).apply(null,arguments)},m._Sigmoid=function(){return(m._Sigmoid=m.asm.Oa).apply(null,arguments)},m._Sin=function(){return(m._Sin=m.asm.Pa).apply(null,arguments)},m._Softmax=function(){return(m._Softmax=m.asm.Qa).apply(null,arguments)},m._Sqrt=function(){return(m._Sqrt=m.asm.Ra).apply(null,arguments)},m._Square=function(){return(m._Square=m.asm.Sa).apply(null,arguments)},m._SquaredDifference=function(){return(m._SquaredDifference=m.asm.Ta).apply(null,arguments)},m._Step=function(){return(m._Step=m.asm.Ua).apply(null,arguments)},m._StridedSlice=function(){return(m._StridedSlice=m.asm.Va).apply(null,arguments)},m._Sub=function(){return(m._Sub=m.asm.Wa).apply(null,arguments)},m._Sum=function(){return(m._Sum=m.asm.Xa).apply(null,arguments)},m._Tan=function(){return(m._Tan=m.asm.Ya).apply(null,arguments)},m._Tanh=function(){return(m._Tanh=m.asm.Za).apply(null,arguments)},m._Tile=function(){return(m._Tile=m.asm._a).apply(null,arguments)},m._TopK=function(){return(m._TopK=m.asm.$a).apply(null,arguments)},m._Transform=function(){return(m._Transform=m.asm.ab).apply(null,arguments)},m._Transpose=function(){return(m._Transpose=m.asm.bb).apply(null,arguments)},m.__FusedMatMul=function(){return(m.__FusedMatMul=m.asm.cb).apply(null,arguments)},m._malloc=function(){return(Ut=m._malloc=m.asm.db).apply(null,arguments)}),Bt=m._free=function(){return(Bt=m._free=m.asm.eb).apply(null,arguments)},jt=m.___errno_location=function(){return(jt=m.___errno_location=m.asm.fb).apply(null,arguments)},qt=m._emscripten_get_global_libc=function(){return(qt=m._emscripten_get_global_libc=m.asm.gb).apply(null,arguments)},Vt=m._pthread_self=function(){return(Vt=m._pthread_self=m.asm.hb).apply(null,arguments)},Gt=m.___pthread_tsd_run_dtors=function(){return(Gt=m.___pthread_tsd_run_dtors=m.asm.ib).apply(null,arguments)},$t=m._emscripten_main_thread_process_queued_calls=function(){return($t=m._emscripten_main_thread_process_queued_calls=m.asm.jb).apply(null,arguments)},Kt=(m._emscripten_current_thread_process_queued_calls=function(){return(m._emscripten_current_thread_process_queued_calls=m.asm.kb).apply(null,arguments)},m._emscripten_register_main_browser_thread_id=function(){return(Kt=m._emscripten_register_main_browser_thread_id=m.asm.lb).apply(null,arguments)}),Qt=m.__emscripten_do_dispatch_to_thread=function(){return(Qt=m.__emscripten_do_dispatch_to_thread=m.asm.mb).apply(null,arguments)},Xt=m._emscripten_sync_run_in_main_thread_4=function(){return(Xt=m._emscripten_sync_run_in_main_thread_4=m.asm.nb).apply(null,arguments)},Zt=m._emscripten_run_in_main_runtime_thread_js=function(){return(Zt=m._emscripten_run_in_main_runtime_thread_js=m.asm.ob).apply(null,arguments)},Yt=m.__emscripten_call_on_thread=function(){return(Yt=m.__emscripten_call_on_thread=m.asm.pb).apply(null,arguments)},Jt=(m._emscripten_tls_init=function(){return(m._emscripten_tls_init=m.asm.qb).apply(null,arguments)},m.__emscripten_thread_init=function(){return(Jt=m.__emscripten_thread_init=m.asm.rb).apply(null,arguments)}),en=m.stackSave=function(){return(en=m.stackSave=m.asm.sb).apply(null,arguments)},tn=m.stackRestore=function(){return(tn=m.stackRestore=m.asm.tb).apply(null,arguments)},nn=m.stackAlloc=function(){return(nn=m.stackAlloc=m.asm.ub).apply(null,arguments)},an=m._emscripten_stack_set_limits=function(){return(an=m._emscripten_stack_set_limits=m.asm.vb).apply(null,arguments)},rn=m._memalign=function(){return(rn=m._memalign=m.asm.wb).apply(null,arguments)},sn=m.__emscripten_allow_main_runtime_queued_calls=9808,un=m.__emscripten_main_thread_futex=11432;function on(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function ln(e){if(!(me>0)){if(I)return p(m),le(),void postMessage({cmd:"loaded"});oe(),me>0||(m.setStatus?(m.setStatus("Running..."),setTimeout((function(){setTimeout((function(){m.setStatus("")}),1),t()}),1)):t())}function t(){Wt||(Wt=!0,m.calledRun=!0,j||(le(),ce(),p(m),m.onRuntimeInitialized&&m.onRuntimeInitialized(),de()))}}function cn(e,t){if(!t||!R||0!==e){if(!t&&I)throw postMessage({cmd:"exitProcess",returnCode:e}),new on(e);R||(Re.terminateAllThreads(),m.onExit&&m.onExit(e),j=!0),y(e,new on(e))}}if(m.cwrap=$,m.PThread=Re,m.PThread=Re,m.wasmMemory=O,m.ExitStatus=on,he=function e(){Wt||ln(),Wt||(he=e)},m.run=ln,m.preInit)for("function"==typeof m.preInit&&(m.preInit=[m.preInit]);m.preInit.length>0;)m.preInit.pop()();return I&&(R=!1,Re.initWorker()),ln(),e.ready});e.exports=o}));var Wt=Pt((function(e,t){var r,s=(r="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(r=r||__filename),function(e){var t,s,u="undefined"!=typeof(e=e||{})?e:{};u.ready=new Promise((function(e,n){t=e,s=n}));var i,o={};for(i in u)u.hasOwnProperty(i)&&(o[i]=u[i]);var l=!1,c=!1,d=!1,p=!1;l="object"==typeof window,c="function"==typeof importScripts,d="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,p=!l&&!d&&!c;var f,m,h,b,y,_="";function g(e){return u.locateFile?u.locateFile(e,_):_+e}d?(_=c?n.dirname(_)+"/":__dirname+"/",f=function(e,t){return b||(b=a),y||(y=n),e=y.normalize(e),b.readFileSync(e,t?null:"utf8")},h=function(e){var t=f(e,!0);return t.buffer||(t=new Uint8Array(t)),A(t.buffer),t},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof Ce))throw e})),process.on("unhandledRejection",ne),u.inspect=function(){return"[Emscripten Module object]"}):p?("undefined"!=typeof read&&(f=function(e){return read(e)}),h=function(e){var t;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(A("object"==typeof(t=read(e,"binary"))),t)},"undefined"!=typeof scriptArgs&&scriptArgs,"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(l||c)&&(c?_=self.location.href:"undefined"!=typeof document&&document.currentScript&&(_=document.currentScript.src),r&&(_=r),_=0!==_.indexOf("blob:")?_.substr(0,_.lastIndexOf("/")+1):"",f=function(e){var t=new XMLHttpRequest;return t.open("GET",e,!1),t.send(null),t.responseText},c&&(h=function(e){var t=new XMLHttpRequest;return t.open("GET",e,!1),t.responseType="arraybuffer",t.send(null),new Uint8Array(t.response)}),m=function(e,t,n){var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=function(){200==a.status||0==a.status&&a.response?t(a.response):n()},a.onerror=n,a.send(null)});var w,k,I=u.print||console.log.bind(console),v=u.printErr||console.warn.bind(console);for(i in o)o.hasOwnProperty(i)&&(u[i]=o[i]);o=null,u.arguments&&u.arguments,u.thisProgram&&u.thisProgram,u.quit&&u.quit,u.wasmBinary&&(w=u.wasmBinary),u.noExitRuntime,"object"!=typeof WebAssembly&&ne("no native wasm support detected");var M=!1;function A(e,t){e||ne("Assertion failed: "+t)}function x(e){var t=u["_"+e];return A(t,"Cannot call unknown function "+e+", make sure it is exported"),t}function S(e,t,n,a,r){var s={string:function(e){var t=0;if(null!=e&&0!==e){var n=1+(e.length<<2);W(e,t=Te(n),n)}return t},array:function(e){var t=Te(e.length);return H(e,t),t}},u=x(e),i=[],o=0;if(a)for(var l=0;l<a.length;l++){var c=s[n[l]];c?(0===o&&(o=Ne()),i[l]=c(a[l])):i[l]=a[l]}var d=u.apply(null,i);return d=function(e){return"string"===t?P(e):"boolean"===t?Boolean(e):e}(d),0!==o&&Ee(o),d}function F(e,t,n,a){var r=(n=n||[]).every((function(e){return"number"===e}));return"string"!==t&&r&&!a?x(e):function(){return S(e,t,n,arguments)}}var N,E,T,C,D="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function O(e,t,n){for(var a=t+n,r=t;e[r]&&!(r>=a);)++r;if(r-t>16&&e.subarray&&D)return D.decode(e.subarray(t,r));for(var s="";t<r;){var u=e[t++];if(128&u){var i=63&e[t++];if(192!=(224&u)){var o=63&e[t++];if((u=224==(240&u)?(15&u)<<12|i<<6|o:(7&u)<<18|i<<12|o<<6|63&e[t++])<65536)s+=String.fromCharCode(u);else{var l=u-65536;s+=String.fromCharCode(55296|l>>10,56320|1023&l)}}else s+=String.fromCharCode((31&u)<<6|i)}else s+=String.fromCharCode(u)}return s}function P(e,t){return e?O(T,e,t):""}function R(e,t,n,a){if(!(a>0))return 0;for(var r=n,s=n+a-1,u=0;u<e.length;++u){var i=e.charCodeAt(u);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++u)),i<=127){if(n>=s)break;t[n++]=i}else if(i<=2047){if(n+1>=s)break;t[n++]=192|i>>6,t[n++]=128|63&i}else if(i<=65535){if(n+2>=s)break;t[n++]=224|i>>12,t[n++]=128|i>>6&63,t[n++]=128|63&i}else{if(n+3>=s)break;t[n++]=240|i>>18,t[n++]=128|i>>12&63,t[n++]=128|i>>6&63,t[n++]=128|63&i}}return t[n]=0,n-r}function W(e,t,n){return R(e,T,t,n)}function H(e,t){E.set(e,t)}function z(e,t){return e%t>0&&(e+=t-e%t),e}function L(e){N=e,u.HEAP8=E=new Int8Array(e),u.HEAP16=new Int16Array(e),u.HEAP32=C=new Int32Array(e),u.HEAPU8=T=new Uint8Array(e),u.HEAPU16=new Uint16Array(e),u.HEAPU32=new Uint32Array(e),u.HEAPF32=new Float32Array(e),u.HEAPF64=new Float64Array(e)}u.INITIAL_MEMORY;var U,B=[],j=[],q=[],V=[];function G(){if(u.preRun)for("function"==typeof u.preRun&&(u.preRun=[u.preRun]);u.preRun.length;)X(u.preRun.shift());pe(B)}function $(){pe(j)}function K(){pe(q)}function Q(){if(u.postRun)for("function"==typeof u.postRun&&(u.postRun=[u.postRun]);u.postRun.length;)Z(u.postRun.shift());pe(V)}function X(e){B.unshift(e)}function Z(e){V.unshift(e)}j.push({func:function(){Se()}});var Y=0,J=null;function ee(e){Y++,u.monitorRunDependencies&&u.monitorRunDependencies(Y)}function te(e){if(Y--,u.monitorRunDependencies&&u.monitorRunDependencies(Y),0==Y&&J){var t=J;J=null,t()}}function ne(e){u.onAbort&&u.onAbort(e),v(e+=""),M=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.";var t=new WebAssembly.RuntimeError(e);throw s(t),t}function ae(e,t){return String.prototype.startsWith?e.startsWith(t):0===e.indexOf(t)}u.preloadedImages={},u.preloadedAudios={};var re="data:application/octet-stream;base64,";function se(e){return ae(e,re)}var ue="file://";function ie(e){return ae(e,ue)}var oe="tfjs-backend-wasm.wasm";function le(e){try{if(e==oe&&w)return new Uint8Array(w);if(h)return h(e);throw"both async and sync fetching of the wasm failed"}catch(e){ne(e)}}function ce(){if(!w&&(l||c)){if("function"==typeof fetch&&!ie(oe))return fetch(oe,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+oe+"'";return e.arrayBuffer()})).catch((function(){return le(oe)}));if(m)return new Promise((function(e,t){m(oe,(function(t){e(new Uint8Array(t))}),t)}))}return Promise.resolve().then((function(){return le(oe)}))}function de(){var e={a:xe};function t(e,t){var n=e.exports;u.asm=n,L((k=u.asm.i).buffer),U=u.asm.o,te()}function n(e){t(e.instance)}function a(t){return ce().then((function(t){return WebAssembly.instantiate(t,e)})).then(t,(function(e){v("failed to asynchronously prepare wasm: "+e),ne(e)}))}if(ee(),u.instantiateWasm)try{return u.instantiateWasm(e,t)}catch(e){return v("Module.instantiateWasm callback failed with error: "+e),!1}return(w||"function"!=typeof WebAssembly.instantiateStreaming||se(oe)||ie(oe)||"function"!=typeof fetch?a(n):fetch(oe,{credentials:"same-origin"}).then((function(t){return WebAssembly.instantiateStreaming(t,e).then(n,(function(e){return v("wasm streaming compile failed: "+e),v("falling back to ArrayBuffer instantiation"),a(n)}))}))).catch(s),{}}function pe(e){for(;e.length>0;){var t=e.shift();if("function"!=typeof t){var n=t.func;"number"==typeof n?void 0===t.arg?U.get(n)():U.get(n)(t.arg):n(void 0===t.arg?null:t.arg)}else t(u)}}function fe(){ne()}function me(e,t,n){T.copyWithin(e,t,t+n)}function he(){return T.length}function be(e){try{return k.grow(e-N.byteLength+65535>>>16),L(k.buffer),1}catch(e){}}function ye(e){var t=he(),n=2147483648;if(e>n)return!1;for(var a=1;a<=4;a*=2){var r=t*(1+.2/a);if(r=Math.min(r,e+100663296),be(Math.min(n,z(Math.max(e,r),65536))))return!0}return!1}se(oe)||(oe=g(oe));var _e={mappings:{},buffers:[null,[],[]],printChar:function(e,t){var n=_e.buffers[e];0===t||10===t?((1===e?I:v)(O(n,0)),n.length=0):n.push(t)},varargs:void 0,get:function(){return _e.varargs+=4,C[_e.varargs-4>>2]},getStr:function(e){return P(e)},get64:function(e,t){return e}};function ge(e){return 0}function we(e,t,n,a,r){}function ke(e,t,n,a){for(var r=0,s=0;s<n;s++){for(var u=C[t+8*s>>2],i=C[t+(8*s+4)>>2],o=0;o<i;o++)_e.printChar(e,T[u+o]);r+=i}return C[a>>2]=r,0}function Ie(){return 6}function ve(e){return C[Fe()>>2]=e,e}function Me(e){switch(e){case 30:return 16384;case 85:return 131072;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:case 80:case 81:case 79:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator&&navigator.hardwareConcurrency||1}return ve(28),-1}var Ae,xe={a:fe,d:me,e:ye,f:ge,c:we,b:ke,g:Ie,h:Me},Se=(de(),u.___wasm_call_ctors=function(){return(Se=u.___wasm_call_ctors=u.asm.j).apply(null,arguments)}),Fe=(u._init=function(){return(u._init=u.asm.k).apply(null,arguments)},u._register_tensor=function(){return(u._register_tensor=u.asm.l).apply(null,arguments)},u._dispose_data=function(){return(u._dispose_data=u.asm.m).apply(null,arguments)},u._dispose=function(){return(u._dispose=u.asm.n).apply(null,arguments)},u._Abs=function(){return(u._Abs=u.asm.p).apply(null,arguments)},u._Add=function(){return(u._Add=u.asm.q).apply(null,arguments)},u._AddN=function(){return(u._AddN=u.asm.r).apply(null,arguments)},u._All=function(){return(u._All=u.asm.s).apply(null,arguments)},u._Any=function(){return(u._Any=u.asm.t).apply(null,arguments)},u._ArgMax=function(){return(u._ArgMax=u.asm.u).apply(null,arguments)},u._AvgPool=function(){return(u._AvgPool=u.asm.v).apply(null,arguments)},u._BatchMatMul=function(){return(u._BatchMatMul=u.asm.w).apply(null,arguments)},u._Ceil=function(){return(u._Ceil=u.asm.x).apply(null,arguments)},u._ClipByValue=function(){return(u._ClipByValue=u.asm.y).apply(null,arguments)},u._Conv2D=function(){return(u._Conv2D=u.asm.z).apply(null,arguments)},u._Conv2DBackpropInput=function(){return(u._Conv2DBackpropInput=u.asm.A).apply(null,arguments)},u._Cos=function(){return(u._Cos=u.asm.B).apply(null,arguments)},u._CropAndResize=function(){return(u._CropAndResize=u.asm.C).apply(null,arguments)},u._Cumsum=function(){return(u._Cumsum=u.asm.D).apply(null,arguments)},u._DepthToSpace=function(){return(u._DepthToSpace=u.asm.E).apply(null,arguments)},u._DepthwiseConv2dNative=function(){return(u._DepthwiseConv2dNative=u.asm.F).apply(null,arguments)},u._Equal=function(){return(u._Equal=u.asm.G).apply(null,arguments)},u._Exp=function(){return(u._Exp=u.asm.H).apply(null,arguments)},u._FlipLeftRight=function(){return(u._FlipLeftRight=u.asm.I).apply(null,arguments)},u._Floor=function(){return(u._Floor=u.asm.J).apply(null,arguments)},u._FloorDiv=function(){return(u._FloorDiv=u.asm.K).apply(null,arguments)},u._FusedBatchNorm=function(){return(u._FusedBatchNorm=u.asm.L).apply(null,arguments)},u._FusedConv2D=function(){return(u._FusedConv2D=u.asm.M).apply(null,arguments)},u._FusedDepthwiseConv2D=function(){return(u._FusedDepthwiseConv2D=u.asm.N).apply(null,arguments)},u._Gather=function(){return(u._Gather=u.asm.O).apply(null,arguments)},u._GatherNd=function(){return(u._GatherNd=u.asm.P).apply(null,arguments)},u._Greater=function(){return(u._Greater=u.asm.Q).apply(null,arguments)},u._GreaterEqual=function(){return(u._GreaterEqual=u.asm.R).apply(null,arguments)},u._LeakyRelu=function(){return(u._LeakyRelu=u.asm.S).apply(null,arguments)},u._Less=function(){return(u._Less=u.asm.T).apply(null,arguments)},u._LessEqual=function(){return(u._LessEqual=u.asm.U).apply(null,arguments)},u._Log=function(){return(u._Log=u.asm.V).apply(null,arguments)},u._LogicalAnd=function(){return(u._LogicalAnd=u.asm.W).apply(null,arguments)},u._Max=function(){return(u._Max=u.asm.X).apply(null,arguments)},u._MaxPool=function(){return(u._MaxPool=u.asm.Y).apply(null,arguments)},u._Maximum=function(){return(u._Maximum=u.asm.Z).apply(null,arguments)},u._Mean=function(){return(u._Mean=u.asm._).apply(null,arguments)},u._Min=function(){return(u._Min=u.asm.$).apply(null,arguments)},u._Minimum=function(){return(u._Minimum=u.asm.aa).apply(null,arguments)},u._MirrorPad=function(){return(u._MirrorPad=u.asm.ba).apply(null,arguments)},u._Multiply=function(){return(u._Multiply=u.asm.ca).apply(null,arguments)},u._Neg=function(){return(u._Neg=u.asm.da).apply(null,arguments)},u._NonMaxSuppressionV3=function(){return(u._NonMaxSuppressionV3=u.asm.ea).apply(null,arguments)},u._NonMaxSuppressionV4=function(){return(u._NonMaxSuppressionV4=u.asm.fa).apply(null,arguments)},u._NonMaxSuppressionV5=function(){return(u._NonMaxSuppressionV5=u.asm.ga).apply(null,arguments)},u._NotEqual=function(){return(u._NotEqual=u.asm.ha).apply(null,arguments)},u._OneHot=function(){return(u._OneHot=u.asm.ia).apply(null,arguments)},u._PadV2=function(){return(u._PadV2=u.asm.ja).apply(null,arguments)},u._Pow=function(){return(u._Pow=u.asm.ka).apply(null,arguments)},u._Prelu=function(){return(u._Prelu=u.asm.la).apply(null,arguments)},u._Prod=function(){return(u._Prod=u.asm.ma).apply(null,arguments)},u._RealDiv=function(){return(u._RealDiv=u.asm.na).apply(null,arguments)},u._Relu=function(){return(u._Relu=u.asm.oa).apply(null,arguments)},u._Relu6=function(){return(u._Relu6=u.asm.pa).apply(null,arguments)},u._ResizeBilinear=function(){return(u._ResizeBilinear=u.asm.qa).apply(null,arguments)},u._Reverse=function(){return(u._Reverse=u.asm.ra).apply(null,arguments)},u._RotateWithOffset=function(){return(u._RotateWithOffset=u.asm.sa).apply(null,arguments)},u._Round=function(){return(u._Round=u.asm.ta).apply(null,arguments)},u._Rsqrt=function(){return(u._Rsqrt=u.asm.ua).apply(null,arguments)},u._ScatterNd=function(){return(u._ScatterNd=u.asm.va).apply(null,arguments)},u._SelectV2=function(){return(u._SelectV2=u.asm.wa).apply(null,arguments)},u._Sigmoid=function(){return(u._Sigmoid=u.asm.xa).apply(null,arguments)},u._Sin=function(){return(u._Sin=u.asm.ya).apply(null,arguments)},u._Softmax=function(){return(u._Softmax=u.asm.za).apply(null,arguments)},u._Sqrt=function(){return(u._Sqrt=u.asm.Aa).apply(null,arguments)},u._Square=function(){return(u._Square=u.asm.Ba).apply(null,arguments)},u._SquaredDifference=function(){return(u._SquaredDifference=u.asm.Ca).apply(null,arguments)},u._Step=function(){return(u._Step=u.asm.Da).apply(null,arguments)},u._StridedSlice=function(){return(u._StridedSlice=u.asm.Ea).apply(null,arguments)},u._Sub=function(){return(u._Sub=u.asm.Fa).apply(null,arguments)},u._Sum=function(){return(u._Sum=u.asm.Ga).apply(null,arguments)},u._Tan=function(){return(u._Tan=u.asm.Ha).apply(null,arguments)},u._Tanh=function(){return(u._Tanh=u.asm.Ia).apply(null,arguments)},u._Tile=function(){return(u._Tile=u.asm.Ja).apply(null,arguments)},u._TopK=function(){return(u._TopK=u.asm.Ka).apply(null,arguments)},u._Transform=function(){return(u._Transform=u.asm.La).apply(null,arguments)},u._Transpose=function(){return(u._Transpose=u.asm.Ma).apply(null,arguments)},u.__FusedMatMul=function(){return(u.__FusedMatMul=u.asm.Na).apply(null,arguments)},u._malloc=function(){return(u._malloc=u.asm.Oa).apply(null,arguments)},u._free=function(){return(u._free=u.asm.Pa).apply(null,arguments)},u.___errno_location=function(){return(Fe=u.___errno_location=u.asm.Qa).apply(null,arguments)}),Ne=u.stackSave=function(){return(Ne=u.stackSave=u.asm.Ra).apply(null,arguments)},Ee=u.stackRestore=function(){return(Ee=u.stackRestore=u.asm.Sa).apply(null,arguments)},Te=u.stackAlloc=function(){return(Te=u.stackAlloc=u.asm.Ta).apply(null,arguments)};function Ce(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function De(e){function n(){Ae||(Ae=!0,u.calledRun=!0,M||($(),K(),t(u),u.onRuntimeInitialized&&u.onRuntimeInitialized(),Q()))}Y>0||(G(),Y>0||(u.setStatus?(u.setStatus("Running..."),setTimeout((function(){setTimeout((function(){u.setStatus("")}),1),n()}),1)):n()))}if(u.cwrap=F,J=function e(){Ae||De(),Ae||(J=e)},u.run=De,u.preInit)for("function"==typeof u.preInit&&(u.preInit=[u.preInit]);u.preInit.length>0;)u.preInit.pop()();return De(),e.ready});e.exports=s}));class Ht extends t.KernelBackend{constructor(e){super(),this.wasm=e,this.dataIdNextNumber=1,this.wasm.tfjs.init(),this.dataIdMap=new t.DataStorage(this,t.engine())}write(e,t,n){const a={id:this.dataIdNextNumber++};return this.move(a,e,t,n,1),a}numDataIds(){return this.dataIdMap.numDataIds()}async time(e){const n=t.util.now();e();return{kernelMs:t.util.now()-n}}move(e,n,a,r,s){const u=this.dataIdNextNumber++;if("string"===r){const t=n;return void this.dataIdMap.set(e,{id:u,stringBytes:t,shape:a,dtype:r,memoryOffset:null,refCount:s})}const i=t.util.sizeFromShape(a),o=i*t.util.bytesPerElement(r),l=this.wasm._malloc(o);this.dataIdMap.set(e,{id:u,memoryOffset:l,shape:a,dtype:r,refCount:s}),this.wasm.tfjs.registerTensor(u,i,l),null!=n&&this.wasm.HEAPU8.set(new Uint8Array(n.buffer,n.byteOffset,o),l)}async read(e){return this.readSync(e)}readSync(e){const{memoryOffset:n,dtype:a,shape:r,stringBytes:s}=this.dataIdMap.get(e);if("string"===a)return s;return function(e,t){switch(t){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error(`Unknown dtype ${t}`)}}(this.wasm.HEAPU8.slice(n,n+t.util.sizeFromShape(r)*t.util.bytesPerElement(a)).buffer,a)}disposeData(e,t=!1){if(this.dataIdMap.has(e)){const n=this.dataIdMap.get(e);if(n.refCount--,!t&&n.refCount>0)return!1;this.wasm._free(n.memoryOffset),this.wasm.tfjs.disposeData(n.id),this.dataIdMap.delete(e)}return!0}refCount(e){if(this.dataIdMap.has(e)){return this.dataIdMap.get(e).refCount}return 0}incRef(e){const t=this.dataIdMap.get(e);null!=t&&t.refCount++}floatPrecision(){return 32}getMemoryOffset(e){return this.dataIdMap.get(e).memoryOffset}dispose(){this.wasm.tfjs.dispose(),"PThread"in this.wasm&&this.wasm.PThread.terminateAllThreads(),this.wasm=null}memory(){return{unreliable:!1}}makeOutput(e,n,a){let r;if(null==a)r=this.write(null,e,n);else{const s=this.dataIdNextNumber++;r={id:s},this.dataIdMap.set(r,{id:s,memoryOffset:a,shape:e,dtype:n,refCount:1});const u=t.util.sizeFromShape(e);this.wasm.tfjs.registerTensor(s,u,a)}return{dataId:r,shape:e,dtype:n}}typedArrayFromHeap({shape:e,dtype:n,dataId:a}){const r=this.wasm.HEAPU8.buffer,{memoryOffset:s}=this.dataIdMap.get(a),u=t.util.sizeFromShape(e);switch(n){case"float32":return new Float32Array(r,s,u);case"int32":return new Int32Array(r,s,u);case"bool":return new Uint8Array(r,s,u);default:throw new Error(`Unknown dtype ${n}`)}}}function zt(e,t,n){if(null!=Bt)return Bt;let a="tfjs-backend-wasm.wasm";return e&&t?a="tfjs-backend-wasm-threaded-simd.wasm":e&&(a="tfjs-backend-wasm-simd.wasm"),null!=qt&&null!=qt[a]?qt[a]:n+a}async function Lt(){const[e,n]=await Promise.all([t.env().getAsync("WASM_HAS_SIMD_SUPPORT"),t.env().getAsync("WASM_HAS_MULTITHREAD_SUPPORT")]);return new Promise(((a,r)=>{const s={locateFile:(t,a)=>{if(t.endsWith(".worker.js")){const e=new Blob(['var Module={};function threadPrintErr(){var text=Array.prototype.slice.call(arguments).join(" ");console.error(text)}function threadAlert(){var text=Array.prototype.slice.call(arguments).join(" ");postMessage({cmd:"alert",text:text,threadId:Module["_pthread_self"]()})}var err=threadPrintErr;this.alert=threadAlert;Module["instantiateWasm"]=function(info,receiveInstance){var instance=new WebAssembly.Instance(Module["wasmModule"],info);Module["wasmModule"]=null;receiveInstance(instance);return instance.exports};function moduleLoaded(){}this.onmessage=function(e){try{if(e.data.cmd==="load"){Module["wasmModule"]=e.data.wasmModule;Module["wasmMemory"]=e.data.wasmMemory;Module["buffer"]=Module["wasmMemory"].buffer;Module["ENVIRONMENT_IS_PTHREAD"]=true;if(typeof e.data.urlOrBlob==="string"){importScripts(e.data.urlOrBlob)}else{var objectUrl=URL.createObjectURL(e.data.urlOrBlob);importScripts(objectUrl);URL.revokeObjectURL(objectUrl)}WasmBackendModuleThreadedSimd(Module).then(function(instance){Module=instance;moduleLoaded()})}else if(e.data.cmd==="objectTransfer"){Module["PThread"].receiveObjectTransfer(e.data)}else if(e.data.cmd==="run"){Module["__performance_now_clock_drift"]=performance.now()-e.data.time;Module["__emscripten_thread_init"](e.data.threadInfoStruct,0,0);var max=e.data.stackBase;var top=e.data.stackBase+e.data.stackSize;Module["establishStackSpace"](top,max);Module["_emscripten_tls_init"]();Module["PThread"].receiveObjectTransfer(e.data);Module["PThread"].setThreadStatus(Module["_pthread_self"](),1);try{var result=Module["invokeEntryPoint"](e.data.start_routine,e.data.arg);if(!Module["getNoExitRuntime"]())Module["PThread"].threadExit(result)}catch(ex){if(ex==="Canceled!"){Module["PThread"].threadCancel()}else if(ex!="unwind"){if(ex instanceof Module["ExitStatus"]){if(Module["getNoExitRuntime"]()){}else{Module["PThread"].threadExit(ex.status)}}else{Module["PThread"].threadExit(-2);throw ex}}}}else if(e.data.cmd==="cancel"){if(Module["_pthread_self"]()){Module["PThread"].threadCancel()}}else if(e.data.target==="setimmediate"){}else if(e.data.cmd==="processThreadQueue"){if(Module["_pthread_self"]()){Module["_emscripten_current_thread_process_queued_calls"]()}}else{err("worker.js received unknown command "+e.data.cmd);err(e.data)}}catch(ex){err("worker.js onmessage() captured an uncaught exception: "+ex);if(ex&&ex.stack)err(ex.stack);throw ex}};if(typeof process==="object"&&typeof process.versions==="object"&&typeof process.versions.node==="string"){self={location:{href:__filename}};var onmessage=this.onmessage;var nodeWorkerThreads=require("worker_threads");global.Worker=nodeWorkerThreads.Worker;var parentPort=nodeWorkerThreads.parentPort;parentPort.on("message",function(data){onmessage({data:data})});var nodeFS=require("fs");var nodeRead=function(filename){return nodeFS.readFileSync(filename,"utf8")};function globalEval(x){global.require=require;global.Module=Module;eval.call(null,x)}importScripts=function(f){globalEval(nodeRead(f))};postMessage=function(msg){parentPort.postMessage(msg)};if(typeof performance==="undefined"){performance={now:function(){return Date.now()}}}}'],{type:"application/javascript"});return URL.createObjectURL(e)}return t.endsWith(".wasm")?zt(e,n,null!=jt?jt:a):a+t}};Gt&&(s.instantiateWasm=function(e){return(n,a)=>(t.util.fetch(e,{credentials:"same-origin"}).then((t=>{t.ok||n.env.a(`failed to load wasm binary file at '${e}'`),t.arrayBuffer().then((e=>{WebAssembly.instantiate(e,n).then((e=>{a(e.instance,e.module)}))}))})),{})}(zt(e,n,null!=jt?jt:"")));let u,i=!1;s.onAbort=()=>{if(i)return;if(Vt)return;Vt=!0;r({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})},n&&e&&null==Bt?(s.mainScriptUrlOrBlob=new Blob(["var WasmBackendModuleThreadedSimd = "+Rt.toString()],{type:"text/javascript"}),u=Rt(s)):u=Wt(s),u.then((e=>{i=!0,Vt=!1;e.tfjs={init:e.cwrap("init",null,[]),registerTensor:e.cwrap("register_tensor",null,["number","number","number"]),disposeData:e.cwrap("dispose_data",null,["number"]),dispose:e.cwrap("dispose",null,[])},a({wasm:e})}))}))}const Ut=["tfjs-backend-wasm.wasm","tfjs-backend-wasm-simd.wasm","tfjs-backend-wasm-threaded-simd.wasm"];let Bt=null,jt=null,qt={},Vt=!1,Gt=!1;t.registerBackend("wasm",(async()=>{const{wasm:e}=await Lt();return new Ht(e)}),2),e.BackendWasm=Ht,e.setWasmPath=function(e,n=!1){if(t.deprecationWarn("setWasmPath has been deprecated in favor of setWasmPaths and will be removed in a future release."),Vt)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");Bt=e,Gt=n},e.setWasmPaths=function(e,t=!1){if(Vt)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPaths()` before you call `tf.setBackend()` or `tf.ready()`");if("string"==typeof e)jt=e;else{qt=e;const t=Ut.filter((e=>null==qt[e]));if(t.length>0)throw new Error(`There were no entries found for the following binaries: ${t.join(",")}. Please either call setWasmPaths with a map providing a path for each binary, or with a string indicating the directory where all the binaries can be found.`)}Gt=t},e.version_wasm="3.7.0",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-wasm.es2017.min.js.map
