/**
 * @license
 * Copyright 2021 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import{_FusedMatMul as e,util as n,Abs as t,backend_util as a,Add as r,AddN as s,Identity as u,Transpose as o,All as i,Any as c,ArgMax as d,AvgPool as l,Reshape as p,BatchMatMul as m,Cast as f,Ceil as h,ClipByValue as b,slice_util as y,buffer as g,Concat as _,Conv2D as w,Conv2DBackpropInput as k,Cos as I,CropAndResize as v,Cumsum as A,DepthToSpace as M,DepthwiseConv2dNative as x,Equal as S,Exp as F,ExpandDims as N,Fill as E,FlipLeftRight as T,Floor as C,FloorDiv as O,FusedBatchNorm as D,FusedConv2D as R,FusedDepthwiseConv2D as P,GatherNd as W,gather_util as H,GatherV2 as z,Greater as U,GreaterEqual as L,LeakyRelu as B,Less as j,LessEqual as q,Log as V,LogicalAnd as G,Max as $,Maximum as K,MaxPool as Q,Mean as X,Min as Y,Minimum as Z,MirrorPad as J,Multiply as ee,Neg as ne,NonMaxSuppressionV3 as te,NonMaxSuppressionV4 as ae,NonMaxSuppressionV5 as re,NotEqual as se,OneHot as ue,OnesLike as oe,Pack as ie,PadV2 as ce,Pow as de,Prelu as le,Prod as pe,Range as me,RealDiv as fe,Relu as he,Relu6 as be,ResizeBilinear as ye,Reverse as ge,RotateWithOffset as _e,Round as we,Rsqrt as ke,ScatterNd as Ie,scatter_util as ve,Select as Ae,Sigmoid as Me,Sin as xe,Slice as Se,Softmax as Fe,SplitV as Ne,Sqrt as Ee,Square as Te,SquaredDifference as Ce,Step as Oe,StridedSlice as De,Sub as Re,Sum as Pe,Tan as We,Tanh as He,Tile as ze,TopK as Ue,Transform as Le,Unpack as Be,ZerosLike as je,registerKernel as qe,env as Ve,KernelBackend as Ge,DataStorage as $e,engine as Ke,deprecationWarn as Qe,registerBackend as Xe}from"@tensorflow/tfjs-core";import Ye from"path";import Ze from"fs";import Je from"worker_threads";import en from"perf_hooks";import nn from"os";var tn,an;let rn;!function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(tn||(tn={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu",e[e.leakyrelu=4]="leakyrelu",e[e.sigmoid=5]="sigmoid"}(an||(an={}));const sn={kernelName:e,backendName:"wasm",setupFunc:function(n){rn=n.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{a:r,b:s,bias:u,preluActivationWeights:o}=n;if("float32"!==r.dtype||"float32"!==s.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");const{transposeA:i,transposeB:c,activation:d,leakyreluAlpha:l}=a,p=t.dataIdMap.get(r.dataId).id,m=t.dataIdMap.get(s.dataId).id;let f=0;if(null!=u){const e=t.dataIdMap.get(u.dataId);if(1!==e.shape.length)throw new Error(`_FusedMatMul only supports rank-1 bias but got rank ${e.shape.length}.`);f=e.id}const h=null==o?0:t.dataIdMap.get(o.dataId).id,b=an[d];if(null==b)throw new Error(`${d} activation not yet supported for FusedConv2D in the wasm backend.`);const y=i?r.shape[2]:r.shape[1],g=c?s.shape[1]:s.shape[2],_=r.shape[0],w=t.makeOutput([_,y,g],r.dtype),k=t.dataIdMap.get(w.dataId).id,I=new Uint8Array(new Int32Array(r.shape).buffer),v=new Uint8Array(new Int32Array(s.shape).buffer);return rn(p,I,r.shape.length,m,v,s.shape.length,i,c,b,f,h,l||0,k),w}};function un(e){let t;return{kernelName:e,backendName:"wasm",setupFunc:function(n){t=n.wasm.cwrap(e,null,["number","number"])},kernelFunc:function(e){const{backend:a,inputs:{x:r}}=e,s=a.dataIdMap.get(r.dataId).id,u=a.makeOutput(r.shape,r.dtype),o=a.dataIdMap.get(u.dataId).id;return 0===n.sizeFromShape(u.shape)||t(s,o),u}}}const on=un(t);function cn(e,t,r){let s;return{kernelName:e,backendName:"wasm",setupFunc:function(n){s=n.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(u){const{backend:o,inputs:i}=u,{a:c,b:d}=i,l=o.dataIdMap.get(c.dataId).id,p=o.dataIdMap.get(d.dataId).id,m=null!=r?r:c.dtype,f=a.assertAndGetBroadcastShape(c.shape,d.shape),h=o.makeOutput(f,m);if(0===n.sizeFromShape(f))return h;const b=new Uint8Array(new Int32Array(c.shape).buffer),y=new Uint8Array(new Int32Array(d.shape).buffer),g=o.dataIdMap.get(h.dataId).id,_=()=>s(l,b,c.shape.length,p,y,d.shape.length,tn[c.dtype],g);if(t&&"float32"===c.dtype)return _(),h;const w=a.getBroadcastDims(c.shape,f),k=a.getBroadcastDims(d.shape,f),I=w.every(((e,n)=>e===n)),v=k.every(((e,n)=>e===n));if(I&&v)return _(),h;throw new Error(`Broadcasting along outer dims is not yet supported for ${c.dtype} ${e}.`)}}}const dn=cn(r,!0);let ln;const pn={kernelName:s,backendName:"wasm",setupFunc:function(e){ln=e.wasm.cwrap(s,null,["array","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a}=e,r=a.makeOutput(t[0].shape,t[0].dtype);if(0===n.sizeFromShape(r.shape))return r;const s=t.map((e=>a.dataIdMap.get(e.dataId).id)),u=new Uint8Array(new Int32Array(s).buffer),o=a.dataIdMap.get(r.dataId).id;return ln(u,s.length,tn[r.dtype],o),r}};function mn(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype),r=t.typedArrayFromHeap(n);return t.typedArrayFromHeap(a).set(r),a}const fn={kernelName:u,backendName:"wasm",kernelFunc:mn};let hn;function bn(e){const{inputs:n,backend:t,attrs:a}=e,[r,s]=function(e,n){const t=[],a=[];for(let r=0;r<e.length;++r)1!==e[r]&&t.push(e[r]),1!==e[n[r]]&&a.push(n[r]);for(let e=0;e<a.length;++e){let n=-1;for(let t=0;t<a.length;++t)a[t]>=e&&(-1===n||a[n]>a[t])&&(n=t);a[n]=e}return[t,a]}(n.x.shape,a.perm);let u=!0;for(let e=0;e<s.length;e++)s[e]!==e&&(u=!1);const o=function(e,n){const t=new Array(e.length);for(let a=0;a<t.length;a++)t[a]=e[n[a]];return t}(n.x.shape,a.perm),i={dataId:n.x.dataId,shape:r,dtype:n.x.dtype};if(u){const e=mn({inputs:n,backend:t});return e.shape=o,e}const c=t.makeOutput(o,i.dtype),d=t.dataIdMap.get(i.dataId).id,l=t.dataIdMap.get(c.dataId).id,p=new Uint8Array(new Int32Array(s).buffer),m=new Uint8Array(new Int32Array(i.shape).buffer);return hn(d,m,i.shape.length,tn[i.dtype],l,p,s.length),c}const yn={kernelName:o,backendName:"wasm",kernelFunc:bn,setupFunc:function(e){hn=e.wasm.cwrap(o,null,["number","array","number","number","number","array","number"])}};function gn(e,t,r){const s=e.shape,u=e.shape.length,o=n.parseAxisParam(t,s);let i=o;const c=a.getAxesPermutation(i,u);let d=null,l=!1;if(null!=c){const n=new Array(u);for(let e=0;e<n.length;e++)n[e]=s[c[e]];i=a.getInnerMostAxes(i.length,u),d=bn({inputs:{x:e},attrs:{perm:c},backend:r});const t=r.dataIdMap.get(e.dataId).id;r.dataIdMap.get(d.dataId).id!==t&&(l=!0)}return{transposed:d,originalAxes:o,axes:i,inputWasTransposed:l}}let _n;const wn={kernelName:i,backendName:"wasm",setupFunc:function(e){_n=e.wasm.cwrap(i,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{axis:u,keepDims:o}=s,{x:i}=r;let c=t.dataIdMap.get(i.dataId).id,d=i;const{transposed:l,axes:p,originalAxes:m,inputWasTransposed:f}=gn(i,u,t);if(f){d=l,c=t.dataIdMap.get(l.dataId).id}const h=d.shape.length;a.assertAxesAreInnerMostDims("all",p,h);const[b,y]=a.computeOutAndReduceShapes(d.shape,p),g=n.sizeFromShape(y),_=t.makeOutput(b,i.dtype);if(0!==n.sizeFromShape(d.shape)){const e=t.dataIdMap.get(_.dataId).id;_n(c,g,e)}if(f&&t.disposeData(l.dataId),o){const e=a.expandShapeToKeepDim(_.shape,m);_.shape=e}return _}};let kn;const In={kernelName:c,backendName:"wasm",setupFunc:function(e){kn=e.wasm.cwrap(c,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{axis:u,keepDims:o}=s,{x:i}=r;let c=t.dataIdMap.get(i.dataId).id,d=i;const{transposed:l,axes:p,originalAxes:m,inputWasTransposed:f}=gn(i,u,t);if(f){d=l,c=t.dataIdMap.get(l.dataId).id}const h=d.shape.length;a.assertAxesAreInnerMostDims("any",p,h);const[b,y]=a.computeOutAndReduceShapes(d.shape,p),g=n.sizeFromShape(y),_=t.makeOutput(b,i.dtype);if(0!==n.sizeFromShape(d.shape)){const e=t.dataIdMap.get(_.dataId).id;kn(c,g,e)}if(f&&t.disposeData(l.dataId),o){const e=a.expandShapeToKeepDim(_.shape,m);_.shape=e}return _}};let vn;const An={kernelName:d,backendName:"wasm",kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:s}=r,{x:u}=a,o=t.dataIdMap.get(u.dataId).id;let i=o,c=u;const{transposed:d,axes:l,inputWasTransposed:p}=gn(u,s,t);if(p){const e=t.dataIdMap.get(d.dataId).id;e!==o&&(c=d,i=e)}const m=c.shape.slice(0,-1),f=t.makeOutput(m,"int32"),h=t.dataIdMap.get(f.dataId).id,b=n.sizeFromShape(f.shape),y=c.shape[l[0]];return vn(i,tn[c.dtype],b,y,h),p&&t.disposeData(d.dataId),f},setupFunc:function(e){vn=e.wasm.cwrap(d,null,["number","number","number","number","number"])}};let Mn;const xn={kernelName:l,backendName:"wasm",setupFunc:function(e){Mn=e.wasm.cwrap(l,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:r}=e,s=n.x,u=r.dataIdMap.get(s.dataId).id,{filterSize:o,strides:i,pad:c,dimRoundingMode:d}=t,l=a.computePool2DInfo(s.shape,o,i,1,c,d),p=l.filterHeight,m=l.filterWidth,f=l.padInfo.top,h=l.padInfo.right,b=l.padInfo.bottom,y=l.padInfo.left,g=l.strideHeight,_=l.strideWidth,w=l.inChannels;if("channelsLast"!==l.dataFormat)throw new Error(`wasm backend does not support dataFormat:'${l.dataFormat}'. Please use 'channelsLast'.`);if(1!==l.dilationWidth||1!==l.dilationHeight)throw new Error(`was backend only supports average pooling with dilation = [1, 1], got [${l.dilationHeight}, ${l.dilationWidth}].`);const k=r.makeOutput(l.outShape,"float32"),I=r.dataIdMap.get(k.dataId).id;return Mn(u,s.shape[0],s.shape[1],s.shape[2],p,m,f,h,b,y,g,_,w,I),k}};function Sn(e){const{inputs:t,attrs:a}=e,{x:r}=t,{shape:s}=a,u=n.sizeFromShape(r.shape),o=n.inferFromImplicitShape(s,u);return n.assert(u===n.sizeFromShape(o),(()=>`new shape: ${o}, old shape: ${r.shape}. New shape and old shape must have the same number of elements.`)),e.backend.incRef(r.dataId),{dataId:r.dataId,shape:o,dtype:r.dtype}}const Fn={kernelName:p,backendName:"wasm",kernelFunc:Sn};let Nn;const En={kernelName:m,backendName:"wasm",setupFunc:function(e){Nn=e.wasm.cwrap(m,null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{a:s,b:u}=t,{transposeA:o,transposeB:i}=r;if("float32"!==s.dtype||"float32"!==u.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");const c=s.shape.length,d=u.shape.length,l=o?s.shape[c-2]:s.shape[c-1],p=i?u.shape[d-1]:u.shape[d-2],m=o?s.shape[c-1]:s.shape[c-2],f=i?u.shape[d-2]:u.shape[d-1],h=s.shape.slice(0,-2),b=u.shape.slice(0,-2),y=n.sizeFromShape(h),g=n.sizeFromShape(b),_=y===g||1===y||1===g;n.assert(c>=2&&d>=2&&_,(()=>`Error in matMul: the input batch dimensions must either be the same or at least one input batch dimension must be 1. Got input batch dimensions of (${h}) and (${b}).`));const w=(y>g?s.shape.slice(0,-2):u.shape.slice(0,-2)).concat([m,f]);n.assert(l===p,(()=>`Error in matMul: inner shapes (${l}) and (${p}) of Tensors with shapes ${s.shape} and ${u.shape} and transposeA=${o} and transposeB=${i} must match.`));const k=i?[g,f,p]:[g,p,f],I=Sn({inputs:{x:s},backend:a,attrs:{shape:o?[y,l,m]:[y,m,l]}}),v=Sn({inputs:{x:u},backend:a,attrs:{shape:k}}),A=a.dataIdMap.get(I.dataId).id,M=a.dataIdMap.get(v.dataId).id,x=o?I.shape[2]:I.shape[1],S=i?v.shape[1]:v.shape[2],F=Math.max(y,g),N=a.makeOutput([F,x,S],I.dtype),E=a.dataIdMap.get(N.dataId).id,T=new Uint8Array(new Int32Array(I.shape).buffer),C=new Uint8Array(new Int32Array(v.shape).buffer);return Nn(A,T,I.shape.length,M,C,v.shape.length,o,i,E),a.disposeData(I.dataId),a.disposeData(v.dataId),N.shape=w,N}};function Tn(e){const{inputs:{x:n},attrs:{dtype:t},backend:a}=e,r=a.makeOutput(n.shape,t),s=a.typedArrayFromHeap(n);return a.typedArrayFromHeap(r).set(s),r}const Cn={kernelName:f,backendName:"wasm",kernelFunc:Tn},On=un(h);let Dn;const Rn={kernelName:b,backendName:"wasm",setupFunc:function(e){Dn=e.wasm.cwrap(b,null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:r}=n,{clipValueMin:s,clipValueMax:u}=a,o=t.dataIdMap.get(r.dataId).id,i=t.makeOutput(r.shape,r.dtype),c=t.dataIdMap.get(i.dataId).id;return Dn(o,s,u,c),i}};function Pn(e,t,r,s,u){const o=y.isSliceContinous(s,t,r),i=n.sizeFromShape(r),c=n.computeStrides(s);if(o){const n=y.computeFlatOffset(t,c);return"string"===u?e.slice(n,n+i):e.subarray(n,n+i)}const d="string"===u?a.fromUint8ToStringArray(e):e,l=g(s,u,d),p=g(r,u);for(let e=0;e<p.size;++e){const n=p.indexToLoc(e),a=n.map(((e,n)=>e+t[n]));p.set(l.get(...a),...n)}return"string"===u?a.fromStringArrayToUint8(p.values):p.values}function Wn(e){const{inputs:t,backend:r}=e,s=n.parseAxisParam(e.attrs.axis,t[0].shape)[0];let u=a.computeOutShape(t.map((e=>e.shape)),s);const o=t.filter((e=>n.sizeFromShape(e.shape)>0));if(1===o.length)return mn({inputs:{x:o[0]},backend:r});const i=r.makeOutput(u,t[0].dtype);if(0===n.sizeFromShape(u))return i;const c=o.map((e=>e.shape));if(a.assertParamsConsistent(c,s),"string"===o[0].dtype){const e=o.map((e=>{const t=n.sizeFromShape(e.shape.slice(s));return Sn({inputs:{x:e},backend:r,attrs:{shape:[-1,t]}})})),c=e.map((e=>({vals:r.readSync(e.dataId),shape:e.shape})));u=a.computeOutShape(e.map((e=>e.shape)),1);const d=1===e[0].shape[0],l=function(e,t,r,s){const u=n.getArrayFromDType(r,n.sizeFromShape(t));if(s&&"string"!==r){let t=0;e.forEach((e=>{const a=n.sizeFromShape(e.shape);u.set(e.vals,t),t+=a}))}else{let n=0;e.forEach((e=>{const s="string"===r?a.fromUint8ToStringArray(e.vals):e.vals;let o=0;for(let a=0;a<e.shape[0];++a){const r=a*t[1]+n;for(let n=0;n<e.shape[1];++n)u[r+n]=s[o++]}n+=e.shape[1]}))}return u}(c,u,t[0].dtype,d),p=a.computeOutShape(o.map((e=>e.shape)),s);i.shape=p;return r.dataIdMap.get(i.dataId).stringBytes=a.fromStringArrayToUint8(l),e.forEach((e=>r.disposeData(e.dataId))),i}const d=n.sizeFromShape(o[0].shape.slice(0,s));let l=0;const p=o.map((e=>{const t=n.sizeFromShape(e.shape.slice(s));return l+=t,t})),m=o.map((e=>r.typedArrayFromHeap(e))),f=r.typedArrayFromHeap(i);for(let e=0;e<d;e++){let n=e*l;for(let t=0;t<m.length;t++){const a=p[t],r=e*a,s=m[t].subarray(r,r+a);f.set(s,n),n+=a}}return i}const Hn={kernelName:_,backendName:"wasm",kernelFunc:Wn};let zn;const Un={kernelName:w,backendName:"wasm",setupFunc:function(e){zn=e.wasm.cwrap(w,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:r}=e,{x:s,filter:u}=n,o=r.dataIdMap.get(s.dataId).id,i=r.dataIdMap.get(u.dataId).id,{strides:c,dilations:d,pad:l,dimRoundingMode:p,dataFormat:m}=t,f=a.convertConv2DDataFormat(m),h=a.computeConv2DInfo(s.shape,u.shape,c,d,l,p,!1,f),b=h.filterHeight,y=h.filterWidth,g=h.padInfo.top,_=h.padInfo.right,w=h.padInfo.bottom,k=h.padInfo.left,I=h.dilationHeight,v=h.dilationWidth,A=h.strideHeight,M=h.strideWidth,x=h.inChannels,S=h.outChannels,F="SAME"===h.padInfo.type?1:0;if("channelsLast"!==h.dataFormat)throw new Error(`wasm backend Conv2D does not support dataFormat:'${h.dataFormat}'. Please use 'channelsLast'.`);const N=r.makeOutput(h.outShape,"float32"),E=r.dataIdMap.get(N.dataId).id;return zn(o,s.shape[0],s.shape[1],s.shape[2],i,b,y,g,_,w,k,F,I,v,A,M,x,S,E),N}};let Ln;const Bn={kernelName:k,backendName:"wasm",setupFunc:function(e){Ln=e.wasm.cwrap(k,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{dy:u,filter:o}=r,{strides:i,pad:c,dataFormat:d,dimRoundingMode:l,inputShape:p}=s,m=a.convertConv2DDataFormat(d),f=a.computeConv2DInfo(p,o.shape,i,1,c,l,!1,m),{batchSize:h,filterHeight:b,filterWidth:y,inChannels:g,inHeight:_,inWidth:w,outChannels:k,outHeight:I,outWidth:v,strideHeight:A,strideWidth:M}=f,x=b-1-f.padInfo.top,S=y-1-f.padInfo.left,F="channelsLast"===f.dataFormat,N=n.computeStrides(f.inShape),E=n.computeStrides(u.shape),[T,C,O]=n.computeStrides(o.shape),D=N[0],R=F?N[1]:N[2],P=F?N[2]:1,W=F?1:N[1],H=E[0],z=F?E[1]:E[2],U=F?E[2]:1,L=F?1:E[1],B=t.makeOutput(f.inShape,"float32"),j=t.dataIdMap.get(B.dataId).id,q=t.dataIdMap.get(u.dataId).id,V=t.dataIdMap.get(o.dataId).id;return Ln(q,V,h,b,y,_,w,g,I,v,k,A,M,x,S,T,C,O,D,R,P,W,H,z,U,L,j),B}},jn=un(I);var qn;let Vn;!function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(qn||(qn={}));const Gn={kernelName:v,backendName:"wasm",setupFunc:function(e){Vn=e.wasm.cwrap(v,null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{method:r,extrapolationValue:s,cropSize:u}=a,{image:o,boxes:i,boxInd:c}=t,d=i.shape[0],[l,p]=u,m=[d,l,p,o.shape[3]];let f,h=n.dataIdMap.get(o.dataId);"float32"!==o.dtype&&(f=Tn({backend:n,inputs:{x:o},attrs:{dtype:"float32"}}),h=n.dataIdMap.get(f.dataId));const b=h.id,y=n.dataIdMap.get(i.dataId).id,g=n.dataIdMap.get(c.dataId).id,_=n.makeOutput(m,"float32"),w=n.dataIdMap.get(_.dataId).id,k=new Uint8Array(new Int32Array(o.shape).buffer);return Vn(b,y,g,d,k,l,p,qn[r],s,w),null!=f&&n.disposeData(f.dataId),_}};let $n;const Kn={kernelName:A,backendName:"wasm",setupFunc:function(e){$n=e.wasm.cwrap(A,null,["number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:u}=t,{axis:o,exclusive:i,reverse:c}=s,d=u.shape.length;n.assert("float32"===u.dtype||"int32"===u.dtype,(()=>`cumsum does not support ${u.dtype} tensors in the WASM backend`));const l=a.getAxesPermutation([o],d);let p=u;null!==l&&(p=bn({inputs:{x:u},attrs:{perm:l},backend:r}));const m=a.getInnerMostAxes(1,d)[0];a.assertAxesAreInnerMostDims("cumsum",[m],d);const f=r.makeOutput(p.shape,p.dtype),h=p.shape[m],b=r.dataIdMap.get(p.dataId).id,y=r.dataIdMap.get(f.dataId).id;$n(b,i?1:0,c?1:0,h,y,tn[u.dtype]);let g=f;if(null!==l){g=bn({inputs:{x:f},attrs:{perm:a.getUndoAxesPermutation(l)},backend:r}),r.disposeData(p.dataId),r.disposeData(f.dataId)}return g}};let Qn;const Xn={kernelName:M,backendName:"wasm",setupFunc:function(e){Qn=e.wasm.cwrap(M,null,["number","number","number","array","number","array","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:s}=a,{blockSize:u,dataFormat:o}=r;n.assert(u>1,(()=>`blockSize should be > 1 for depthToSpace, but was: ${u}`));const i=s.shape[0],c="NHWC"===o?s.shape[1]:s.shape[2],d="NHWC"===o?s.shape[2]:s.shape[3],l="NHWC"===o?s.shape[3]:s.shape[1],p=c*u,m=d*u,f=l/(u*u),h="NHWC"===o?[i,p,m,f]:[i,f,p,m],b=t.makeOutput(h,"float32"),y=t.dataIdMap.get(s.dataId).id,g=new Uint8Array(new Int32Array(n.computeStrides(s.shape)).buffer),_=new Uint8Array(new Int32Array(h).buffer),w=new Uint8Array(new Int32Array(n.computeStrides(h)).buffer),k=t.dataIdMap.get(b.dataId).id;return Qn(y,u,"NHWC"===o?1:0,g,s.shape.length-1,_,w,h.length,k),b}};let Yn;const Zn={kernelName:x,backendName:"wasm",setupFunc:function(e){Yn=e.wasm.cwrap(x,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:r}=e,{x:s,filter:u}=n,o=r.dataIdMap.get(s.dataId).id,i=r.dataIdMap.get(u.dataId).id,{strides:c,dilations:d,pad:l,dimRoundingMode:p}=t,m=null==d?[1,1]:d,f=a.computeConv2DInfo(s.shape,u.shape,c,m,l,p,!0),h=f.filterHeight,b=f.filterWidth,y=f.padInfo.top,g=f.padInfo.right,_=f.padInfo.bottom,w=f.padInfo.left,k=f.dilationHeight,I=f.dilationWidth,v=f.strideHeight,A=f.strideWidth,M=f.inChannels,x=f.outChannels,S="SAME"===f.padInfo.type?1:0;if("channelsLast"!==f.dataFormat)throw new Error(`wasm backend DepthwiseConv2dNative does not support dataFormat:'${f.dataFormat}'. Please use 'channelsLast'.`);const F=r.makeOutput(f.outShape,"float32"),N=r.dataIdMap.get(F.dataId).id;return Yn(o,s.shape[0],s.shape[1],s.shape[2],i,h,b,y,g,_,w,S,k,I,v,A,M,x,N),F}},Jn=cn(S,!1,"bool"),et=un(F);function nt(e){const{inputs:t,attrs:a,backend:r}=e,{input:s}=t,{dim:u}=a,o=s.shape.length,i=s.shape.slice();let c=u;return u<0&&(n.assert(-(o+1)<=u,(()=>`Axis must be in the interval [${-(o+1)}, ${o}]`)),c=o+u+1),i.splice(c,0,1),Sn({inputs:{x:s},backend:r,attrs:{shape:i}})}const tt={kernelName:N,backendName:"wasm",kernelFunc:nt};const at={kernelName:E,backendName:"wasm",kernelFunc:function(e){const{attrs:{shape:n,value:t,dtype:a},backend:r}=e,s=r.makeOutput(n,a);return r.typedArrayFromHeap(s).fill(t),s}};let rt;const st={kernelName:T,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:t}=e,{image:a}=n,r=t.makeOutput(a.shape,a.dtype),s=t.dataIdMap.get(a.dataId).id,u=t.dataIdMap.get(r.dataId).id,[o,i,c,d]=a.shape;return rt(s,o,i,c,d,u),r},setupFunc:function(e){rt=e.wasm.cwrap(T,null,["number","number","number","number","number","number"])}},ut=un(C),ot=cn(O,!1);let it;const ct={kernelName:D,backendName:"wasm",setupFunc:function(e){it=e.wasm.cwrap(D,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{varianceEpsilon:s}=r,{x:u,mean:o,variance:i,offset:c,scale:d}=a,l=t.dataIdMap.get(u.dataId).id,p=t.dataIdMap.get(o.dataId).id,m=t.dataIdMap.get(i.dataId).id,f=null!=c?t.dataIdMap.get(c.dataId).id:0,h=null!=d?t.dataIdMap.get(d.dataId).id:0,b=t.makeOutput(u.shape,u.dtype);if(0===n.sizeFromShape(u.shape))return b;const y=t.dataIdMap.get(b.dataId).id;return it(l,p,m,f,h,s,y),b}};let dt;const lt={kernelName:R,backendName:"wasm",setupFunc:function(e){dt=e.wasm.cwrap(R,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:r}=e,{x:s,filter:u,bias:o,preluActivationWeights:i}=n,{strides:c,pad:d,dilations:l,dataFormat:p,dimRoundingMode:m,activation:f,leakyreluAlpha:h}=t,b=a.computeConv2DInfo(s.shape,u.shape,c,l,d,m),y=an[f];if(null==y)throw new Error(`${f} activation not yet supported for FusedConv2D in the wasm backend.`);const g=r.dataIdMap.get(s.dataId).id,_=r.dataIdMap.get(u.dataId).id,w=b.outChannels;let k=0;if(null!=o){const e=r.dataIdMap.get(o.dataId);if(1!==e.shape.length)throw new Error(`FusedConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==w)throw new Error(`FusedConv2D bias shape (${e.shape}) does not match the number of output channels (${w})`);k=e.id}const I=b.filterHeight,v=b.filterWidth,A=b.padInfo.top,M=b.padInfo.right,x=b.padInfo.bottom,S=b.padInfo.left,F=b.dilationHeight,N=b.dilationWidth,E=b.strideHeight,T=b.strideWidth,C=b.inChannels,O="SAME"===b.padInfo.type?1:0,D=b.batchSize,R=b.inHeight,P=b.inWidth;if("NHWC"!==p)throw new Error(`wasm backend FusedConv2D does not support dataFormat:'${p}'. Please use 'NHWC'.`);const W=r.makeOutput(b.outShape,"float32"),H=r.dataIdMap.get(W.dataId).id,z=null==i?0:r.dataIdMap.get(i.dataId).id;return dt(g,D,R,P,_,I,v,k,A,M,x,S,O,F,N,E,T,C,w,y,z,h||0,H),W}};let pt;const mt={kernelName:P,backendName:"wasm",setupFunc:function(e){pt=e.wasm.cwrap(P,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:r}=e,{x:s,filter:u,bias:o,preluActivationWeights:i}=n,{strides:c,pad:d,dilations:l,dataFormat:p,dimRoundingMode:m,activation:f,leakyreluAlpha:h}=t,b=a.computeConv2DInfo(s.shape,u.shape,c,l,d,m,!0),y=an[f];if(null==y)throw new Error(`${f} activation not yet supported for FusedDepthwiseConv2D in the wasm backend.`);const g=r.dataIdMap.get(s.dataId).id,_=r.dataIdMap.get(u.dataId).id,w=b.outChannels;let k=0;if(null!=o){const e=r.dataIdMap.get(o.dataId);if(1!==e.shape.length)throw new Error(`FusedDepthwiseConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==w)throw new Error(`FusedDepthwiseConv2D bias shape (${e.shape}) does not match the number of output channels (${w})`);k=e.id}const I=b.filterHeight,v=b.filterWidth,A=b.padInfo.top,M=b.padInfo.right,x=b.padInfo.bottom,S=b.padInfo.left,F=b.dilationHeight,N=b.dilationWidth,E=b.strideHeight,T=b.strideWidth,C=b.inChannels,O="SAME"===b.padInfo.type?1:0,D=b.batchSize,R=b.inHeight,P=b.inWidth;if("NHWC"!==p)throw new Error(`wasm backend FusedDepthwiseConv2D does not support dataFormat:'${p}'. Please use 'NHWC'.`);const W=r.makeOutput(b.outShape,"float32"),H=r.dataIdMap.get(W.dataId).id,z=null==i?0:r.dataIdMap.get(i.dataId).id;return pt(g,D,R,P,_,I,v,k,A,M,x,S,O,F,N,E,T,C,w,y,z,h||0,H),W}};let ft;const ht={kernelName:W,backendName:"wasm",setupFunc:function(e){ft=e.wasm.cwrap(W,null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){const{backend:n,inputs:t}=e,{params:a,indices:r}=t,[s,u,o,i]=H.prepareAndValidate(a,r),c=n.makeOutput(s,a.dtype);if(0===u)return c;const d=r.shape,l=d[d.length-1],p=n.dataIdMap.get(a.dataId).id,m=n.dataIdMap.get(r.dataId).id,f=new Uint8Array(new Int32Array(i).buffer),h=n.dataIdMap.get(c.dataId).id;return ft(p,tn[a.dtype],m,u,l,o,f,h),c}};let bt;const yt={kernelName:z,backendName:"wasm",setupFunc:function(e){bt=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{x:u,indices:o}=r,{axis:i,batchDims:c}=s,d=n.parseAxisParam(i,u.shape)[0],l=a.segment_util.collectGatherOpShapeInfo(u,o,d,c),p=Sn({inputs:{x:u},attrs:{shape:[l.batchSize,l.outerSize,l.dimSize,l.sliceSize]},backend:t}),m=n.sizeFromShape(o.shape),f=Sn({inputs:{x:o},attrs:{shape:[l.batchSize,m/l.batchSize]},backend:t}),h=[l.batchSize,l.outerSize,m/l.batchSize,l.sliceSize],b=t.makeOutput(h,u.dtype);if(0===n.sizeFromShape(u.shape))return b;const y=p.shape.length-1,g=t.dataIdMap.get(p.dataId).id,_=t.dataIdMap.get(f.dataId).id,w=t.dataIdMap.get(b.dataId).id,k=new Uint8Array(new Int32Array(n.computeStrides(p.shape)).buffer),I=new Uint8Array(new Int32Array(n.computeStrides(h)).buffer);return bt(g,tn[u.dtype],k,y,_,l.batchSize,I,w),t.disposeData(p.dataId),t.disposeData(f.dataId),b.shape=l.outputShape,b}},gt=cn(U,!1,"bool"),_t=cn(L,!1,"bool");let wt;const kt={kernelName:B,backendName:"wasm",setupFunc:function(e){wt=e.wasm.cwrap(B,null,["number","number","number"])},kernelFunc:function(e){const{inputs:{x:t},attrs:{alpha:a},backend:r}=e,s=r.dataIdMap.get(t.dataId).id,u=r.makeOutput(t.shape,t.dtype);if(0!==n.sizeFromShape(t.shape)){const e=r.dataIdMap.get(u.dataId).id;wt(s,a,e)}return u}},It=cn(j,!1,"bool"),vt=cn(q,!1,"bool"),At=un(V),Mt=cn(G,!1,"bool");let xt;const St={kernelName:$,backendName:"wasm",setupFunc:function(e){xt=e.wasm.cwrap($,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{reductionIndices:u,keepDims:o}=s,{x:i}=r;let c=t.dataIdMap.get(i.dataId).id,d=i;const{transposed:l,axes:p,originalAxes:m,inputWasTransposed:f}=gn(i,u,t);if(f){d=l,c=t.dataIdMap.get(l.dataId).id}const h=d.shape.length;a.assertAxesAreInnerMostDims("max",p,h);const[b,y]=a.computeOutAndReduceShapes(d.shape,p),g=n.sizeFromShape(y),_=t.makeOutput(b,i.dtype);if(0!==n.sizeFromShape(d.shape)){const e=t.dataIdMap.get(_.dataId).id;xt(c,g,e)}if(f&&t.disposeData(l.dataId),o){const e=a.expandShapeToKeepDim(_.shape,m);_.shape=e}return _}},Ft=cn(K,!1);let Nt;const Et={kernelName:Q,backendName:"wasm",setupFunc:function(e){Nt=e.wasm.cwrap(Q,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:r}=e,s=n.x,u=r.dataIdMap.get(s.dataId).id,{filterSize:o,strides:i,pad:c,dimRoundingMode:d}=t,l=a.computePool2DInfo(s.shape,o,i,1,c,d),p=l.filterHeight,m=l.filterWidth,f=l.padInfo.top,h=l.padInfo.right,b=l.padInfo.bottom,y=l.padInfo.left,g=l.dilationHeight,_=l.dilationWidth,w=l.strideHeight,k=l.strideWidth,I=l.inChannels,v=l.outChannels;if("channelsLast"!==l.dataFormat)throw new Error(`wasm backend does not support dataFormat:'${l.dataFormat}'. Please use 'channelsLast'.`);const A=r.makeOutput(l.outShape,"float32"),M=r.dataIdMap.get(A.dataId).id;return Nt(u,s.shape[0],s.shape[1],s.shape[2],p,m,f,h,b,y,g,_,w,k,I,v,M),A}};let Tt;const Ct={kernelName:X,backendName:"wasm",setupFunc:function(e){Tt=e.wasm.cwrap(X,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{axis:u,keepDims:o}=s,{x:i}=r,c=t.dataIdMap.get(i.dataId).id;let d=c,l=i;const{transposed:p,axes:m,originalAxes:f,inputWasTransposed:h}=gn(i,u,t);let b=m;if(h){const e=t.dataIdMap.get(p.dataId).id;e!==c&&(l=p,d=e,b=a.getInnerMostAxes(b.length,l.shape.length))}a.assertAxesAreInnerMostDims("mean",b,l.shape.length);const[y,g]=a.computeOutAndReduceShapes(l.shape,b),_=n.sizeFromShape(g);let w=l;"float32"!==l.dtype&&(w=Tn({backend:t,inputs:{x:l},attrs:{dtype:"float32"}}),d=t.dataIdMap.get(w.dataId).id);const k=t.makeOutput(y,"float32");if(0!==n.sizeFromShape(l.shape)){const e=t.dataIdMap.get(k.dataId).id;Tt(d,_,e)}if(h&&t.disposeData(p.dataId),o){const e=a.expandShapeToKeepDim(k.shape,f);k.shape=e}return"float32"!==l.dtype&&t.disposeData(w.dataId),k}};let Ot;const Dt={kernelName:Y,backendName:"wasm",setupFunc:function(e){Ot=e.wasm.cwrap(Y,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{axis:u,keepDims:o}=s,{x:i}=r,c=t.dataIdMap.get(i.dataId).id;let d=c,l=i;const{transposed:p,axes:m,originalAxes:f,inputWasTransposed:h}=gn(i,u,t);if(h){const e=t.dataIdMap.get(p.dataId).id;e!==c&&(l=p,d=e)}const b=l.shape.length;a.assertAxesAreInnerMostDims("min",m,b);const[y,g]=a.computeOutAndReduceShapes(l.shape,m),_=n.sizeFromShape(g),w=t.makeOutput(y,l.dtype);if(0!==n.sizeFromShape(l.shape)){const e=t.dataIdMap.get(w.dataId).id;Ot(d,_,e)}if(h&&t.disposeData(p.dataId),o){const e=a.expandShapeToKeepDim(w.shape,f);w.shape=e}return w}},Rt=cn(Z,!1);var Pt;let Wt;!function(e){e[e.reflect=0]="reflect",e[e.symmetric=1]="symmetric"}(Pt||(Pt={}));const Ht={kernelName:J,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t,attrs:{paddings:a,mode:r}}=e,s=a.map(((e,t)=>e[0]+n.shape[t]+e[1])),u=t.dataIdMap.get(n.dataId).id,o=t.makeOutput(s,n.dtype),i=t.dataIdMap.get(o.dataId).id,c=new Uint8Array(new Int32Array(n.shape).buffer),d=a.map((e=>e[0])),l=a.map((e=>e[1])),p=new Uint8Array(new Int32Array(d).buffer),m=new Uint8Array(new Int32Array(l).buffer);return Wt(u,c,n.shape.length,tn[n.dtype],p,m,Pt[r],i),o},setupFunc:function(e){Wt=e.wasm.cwrap(J,null,["number","array","number","number","array","array","number","number"])}},zt=cn(ee,!0),Ut=un(ne);function Lt(e,n){const t=new Int32Array(e.wasm.HEAPU8.buffer,n,4),a=t[0],r=t[1],s=t[2],u=t[3];return e.wasm._free(n),{pSelectedIndices:a,selectedSize:r,pSelectedScores:s,pValidOutputs:u}}let Bt;const jt={kernelName:te,backendName:"wasm",setupFunc:function(e){Bt=e.wasm.cwrap(te,"number",["number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u}=a,{boxes:o,scores:i}=t,c=n.dataIdMap.get(o.dataId).id,d=n.dataIdMap.get(i.dataId).id,l=Bt(c,d,s,r,u),{pSelectedIndices:p,selectedSize:m,pSelectedScores:f,pValidOutputs:h}=Lt(n,l);return n.wasm._free(f),n.wasm._free(h),n.makeOutput([m],"int32",p)}};let qt;const Vt={kernelName:ae,backendName:"wasm",setupFunc:function(e){qt=e.wasm.cwrap(ae,"number",["number","number","number","number","number","bool"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,padToMaxOutputSize:o}=a,{boxes:i,scores:c}=t,d=n.dataIdMap.get(i.dataId).id,l=n.dataIdMap.get(c.dataId).id,p=qt(d,l,s,r,u,o),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=Lt(n,p);return n.wasm._free(h),[n.makeOutput([f],"int32",m),n.makeOutput([],"int32",b)]}};let Gt;const $t={kernelName:re,backendName:"wasm",setupFunc:function(e){Gt=e.wasm.cwrap(re,"number",["number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,softNmsSigma:o}=a,{boxes:i,scores:c}=t,d=n.dataIdMap.get(i.dataId).id,l=n.dataIdMap.get(c.dataId).id,p=Gt(d,l,s,r,u,o),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=Lt(n,p);return n.wasm._free(b),[n.makeOutput([f],"int32",m),n.makeOutput([f],"float32",h)]}},Kt=cn(se,!1,"bool");let Qt;const Xt={kernelName:ue,backendName:"wasm",setupFunc:function(e){Qt=e.wasm.cwrap(ue,null,["number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{indices:r}=n,{depth:s,onValue:u,offValue:o}=a,i=t.makeOutput([...r.shape,s],"int32"),c=t.dataIdMap.get(i.dataId).id,d=t.dataIdMap.get(r.dataId).id;return Qt(d,s,u,o,c),i}};const Yt={kernelName:oe,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(1),a}};const Zt={kernelName:ie,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{axis:s}=r;if(1===t.length)return nt({inputs:{input:t[0]},backend:a,attrs:{dim:s}});const u=t[0].shape,o=t[0].dtype;t.forEach((e=>{n.assertShapesMatch(u,e.shape,"All tensors passed to stack must have matching shapes"),n.assert(o===e.dtype,(()=>"All tensors passed to stack must have matching dtypes"))}));const i=[],c=Wn({inputs:t.map((e=>{const n=nt({inputs:{input:e},backend:a,attrs:{dim:s}});return i.push(n),n})),backend:a,attrs:{axis:s}});return i.forEach((e=>a.disposeData(e.dataId))),c}};let Jt;const ea={kernelName:ce,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t,attrs:{paddings:a,constantValue:r}}=e,s=a.map(((e,t)=>e[0]+n.shape[t]+e[1])),u=t.dataIdMap.get(n.dataId).id,o=t.makeOutput(s,n.dtype),i=t.dataIdMap.get(o.dataId).id,c=new Uint8Array(new Int32Array(n.shape).buffer),d=a.map((e=>e[0])),l=a.map((e=>e[1])),p=new Uint8Array(new Int32Array(d).buffer),m=new Uint8Array(new Int32Array(l).buffer);return Jt(u,c,n.shape.length,tn[n.dtype],p,m,r,i),o},setupFunc:function(e){Jt=e.wasm.cwrap(ce,null,["number","array","number","number","array","array","number","number"])}},na=cn(de,!1);let ta;const aa={kernelName:le,backendName:"wasm",setupFunc:function(e){ta=e.wasm.cwrap(le,null,["number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t}=e,{x:a,alpha:r}=n,s=t.dataIdMap.get(a.dataId).id,u=t.dataIdMap.get(r.dataId).id,o=t.makeOutput(a.shape,"float32"),i=t.dataIdMap.get(o.dataId).id;return ta(s,u,i),o}};let ra;const sa={kernelName:pe,backendName:"wasm",setupFunc:function(e){ra=e.wasm.cwrap(pe,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{axis:u,keepDims:o}=s,{x:i}=r,c=t.dataIdMap.get(i.dataId).id;let d=c,l=i;const{transposed:p,axes:m,originalAxes:f,inputWasTransposed:h}=gn(i,u,t);let b=m;if(h){const e=t.dataIdMap.get(p.dataId).id;e!==c&&(l=p,d=e,b=a.getInnerMostAxes(b.length,l.shape.length))}a.assertAxesAreInnerMostDims("prod",b,l.shape.length);const[y,g]=a.computeOutAndReduceShapes(l.shape,b),_=n.sizeFromShape(g),w=t.makeOutput(y,l.dtype);if(0!==n.sizeFromShape(l.shape)){const e=t.dataIdMap.get(w.dataId).id;ra(d,_,tn[w.dtype],e)}if(h&&t.disposeData(p.dataId),o){const e=a.expandShapeToKeepDim(w.shape,f);w.shape=e}return w}},ua={kernelName:me,backendName:"wasm",kernelFunc:e=>{const{backend:t,attrs:a}=e,{start:r,stop:s,step:u,dtype:o}=a,i=function(e,t,a,r){if(e===t||e<t&&a<0||t<e&&a>1)return n.makeZerosTypedArray(0,r);const s=Math.abs(Math.ceil((t-e)/a)),u=n.makeZerosTypedArray(s,r);t<e&&1===a&&(a=-1),u[0]=e;for(let e=1;e<u.length;e++)u[e]=u[e-1]+a;return u}(r,s,u,o),c=t.makeOutput([i.length],o);return t.typedArrayFromHeap(c).set(i),c}},oa=cn(fe,!0),ia=un(he),ca=un(be);let da;const la={kernelName:ye,backendName:"wasm",setupFunc:function(e){da=e.wasm.cwrap(ye,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{images:s}=a,{alignCorners:u,halfPixelCenters:o,size:i}=r,[c,d]=i,[l,p,m,f]=s.shape,h=[l,c,d,f];let b,y=t.dataIdMap.get(s.dataId);"float32"!==y.dtype&&(b=Tn({backend:t,inputs:{x:s},attrs:{dtype:"float32"}}),y=t.dataIdMap.get(b.dataId));const g=y.id,_=t.makeOutput(h,"float32");if(0===n.sizeFromShape(s.shape))return _;const w=t.dataIdMap.get(_.dataId).id;return da(g,l,p,m,f,c,d,u?1:0,o?1:0,w),null!=b&&t.disposeData(b.dataId),_}};let pa;const ma={kernelName:ge,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{x:s}=t,{dims:u}=r,o=n.parseAxisParam(u,s.shape);if(0===s.shape.length)return mn({inputs:{x:s},backend:a});const i=a.makeOutput(s.shape,s.dtype),c=a.dataIdMap.get(s.dataId).id,d=a.dataIdMap.get(i.dataId).id,l=new Uint8Array(new Int32Array(o).buffer),p=new Uint8Array(new Int32Array(s.shape).buffer);pa(c,l,o.length,p,s.shape.length,d);const m=Sn({inputs:{x:i},attrs:{shape:s.shape},backend:a});return a.disposeData(i.dataId),m},setupFunc:function(e){pa=e.wasm.cwrap(ge,null,["number","array","number","array","number","number"])}};let fa;const ha={kernelName:_e,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:t,attrs:r}=e,{image:s}=n,{radians:u,fillValue:o,center:i}=r,c=t.makeOutput(s.shape,s.dtype),d=t.dataIdMap.get(s.dataId).id,l=t.dataIdMap.get(c.dataId).id,[p,m,f,h]=s.shape,[b,y]=a.getImageCenter(i,m,f),g="number"==typeof o?[o,o,o,0===o?0:255]:[...o,255],_=new Uint8Array(new Int32Array(g).buffer);return fa(d,p,m,f,h,u,b,y,_,g.length,l),c},setupFunc:function(e){fa=e.wasm.cwrap(_e,null,["number","number","number","number","number","number","number","number","array","number","number"])}},ba=un(we);let ya;let ga;let _a;function wa(e){const{inputs:{x:t},attrs:{begin:a,size:r},backend:s}=e,[u,o]=y.parseSliceParams(t,a,r),i=y.isSliceContinous(t.shape,u,o),c=s.readSync(t.dataId),d=s.makeOutput(o,t.dtype),l=n.computeStrides(t.shape),p=s.dataIdMap.get(d.dataId);if(i){const e=y.computeFlatOffset(u,l);if("string"===t.dtype)p.stringBytes=c.slice(e,e+n.sizeFromShape(o));else{s.typedArrayFromHeap(d).set(c.subarray(e,e+n.sizeFromShape(o)))}return d}if("string"===t.dtype){const e=Pn(c,u,o,t.shape,t.dtype);return p.stringBytes=e,d}const m=s.typedArrayFromHeap(d),f=t.shape.length;if(2===f)!function(e,n,t,a,r){let s=0;const u=a[0],o=a[1],i=u+r[0];for(let a=u;a<i;a++){const u=a*n+o;t.set(e.subarray(u,u+r[1]),s),s+=r[1]}}(c,l[0],m,u,o);else if(3===f)!function(e,n,t,a,r,s){let u=0;const o=r[0],i=r[1],c=r[2],d=o+s[0],l=i+s[1];for(let r=o;r<d;r++)for(let o=i;o<l;o++){const i=r*n+o*t+c;a.set(e.subarray(i,i+s[2]),u),u+=s[2]}}(c,l[0],l[1],m,u,o);else if(4===f)!function(e,n,t,a,r,s,u){let o=0;const i=s[0],c=s[1],d=s[2],l=i+u[0],p=c+u[1],m=d+u[2],f=s[3];for(let s=i;s<l;s++)for(let i=c;i<p;i++)for(let c=d;c<m;c++){const d=s*n+i*t+c*a+f;r.set(e.subarray(d,d+u[3]),o),o+=u[3]}}(c,l[0],l[1],l[2],m,u,o);else{const e=Pn(c,u,o,t.shape,t.dtype);m.set(e)}return d}let ka;let Ia;let va;let Aa;let Ma;let xa;let Sa;const Fa=[on,dn,pn,wn,In,An,xn,En,Cn,On,Rn,Hn,Un,Bn,jn,Gn,Kn,Xn,Zn,Jn,et,tt,at,st,ut,ot,sn,ct,lt,mt,ht,yt,gt,_t,fn,kt,It,vt,At,Mt,St,Ft,Et,Ct,Dt,Rt,Ht,zt,Ut,jt,Vt,$t,Kt,Xt,Yt,Zt,ea,na,aa,sa,ua,oa,ia,ca,Fn,la,ma,ha,un(ke),ba,{kernelName:Ie,backendName:"wasm",setupFunc:function(e){ya=e.wasm.cwrap(Ie,null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{indices:s,updates:u}=a,{shape:o}=r,i=t.makeOutput(o,u.dtype);if(0===n.sizeFromShape(o))return i;const{sliceRank:c,numUpdates:d,sliceSize:l,strides:p,outputSize:m}=ve.calculateShapes(u,s,o),f=t.dataIdMap.get(s.dataId).id,h=t.dataIdMap.get(u.dataId).id,b=new Uint8Array(new Int32Array(p).buffer),y=t.dataIdMap.get(i.dataId).id;return ya(f,h,tn[u.dtype],c,d,l,b,m,y),i}},{kernelName:Ae,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a}=e,{condition:r,t:s,e:u}=t,o=a.dataIdMap.get(r.dataId).id,i=a.dataIdMap.get(s.dataId).id,c=a.dataIdMap.get(u.dataId).id,d=a.makeOutput(s.shape,s.dtype),l=a.dataIdMap.get(d.dataId).id,p=r.shape.length,m=s.shape.length,f=0===p||p>1||1===m?1:n.sizeFromShape(s.shape.slice(1));return ga(o,i,c,f,l),d},setupFunc:function(e){ga=e.wasm.cwrap("SelectV2",null,["number","number","number","number","number"])}},{kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){_a=e.wasm.cwrap(Me,null,["number","number"])},kernelFunc:function(e){const{backend:t,inputs:{x:a}}=e,r=t.dataIdMap.get(a.dataId).id,s=t.makeOutput(a.shape,a.dtype),u=t.dataIdMap.get(s.dataId).id;return 0===n.sizeFromShape(s.shape)||_a(r,u),s}},un(xe),{kernelName:Se,backendName:"wasm",kernelFunc:wa},{kernelName:Fe,backendName:"wasm",setupFunc:function(e){ka=e.wasm.cwrap(Fe,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:{logits:a},attrs:{dim:r}}=e,s=t.dataIdMap.get(a.dataId).id,u=t.makeOutput(a.shape,a.dtype),o=t.dataIdMap.get(u.dataId).id,i=a.shape[r],c=n.sizeFromShape(a.shape)/i;return 0===n.sizeFromShape(u.shape)||ka(s,o,i,c),u}},{kernelName:Ne,backendName:"wasm",kernelFunc:function(e){const{inputs:t,attrs:r,backend:s}=e,{x:u}=t,{numOrSizeSplits:o,axis:i}=r,c=n.parseAxisParam(i,u.shape)[0],d=a.prepareSplitSize(u,o,c),l=new Array(u.shape.length).fill(0),p=u.shape.slice();return d.map((e=>{const n=[...p];n[c]=e;const t=wa({inputs:{x:u},attrs:{begin:l,size:n},backend:s});return l[c]+=e,t}))}},un(Ee),un(Te),cn(Ce,!0),{kernelName:Oe,backendName:"wasm",setupFunc:function(e){Ia=e.wasm.cwrap(Oe,null,["number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{alpha:r}=a,{x:s}=t,u=n.dataIdMap.get(s.dataId).id,o=n.makeOutput(s.shape,s.dtype),i=n.dataIdMap.get(o.dataId).id;return Ia(u,r,i),o}},{kernelName:De,backendName:"wasm",setupFunc:function(e){va=e.wasm.cwrap(De,null,["number","array","number","array","array","array","array","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{x:u}=r;let{begin:o,end:i,strides:c}=s;null==c&&(c=new Array(o.length));const{beginMask:d,endMask:l,ellipsisMask:p,newAxisMask:m,shrinkAxisMask:f}=s,h=a.slice_util.maskToAxes(p);if(h.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==p&&0!==m)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==p&&0!==f)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");const b=u.shape.length-o.length,y=a.slice_util.maskToAxes(m),g=u.shape.slice();y.forEach((e=>{o[e]=0,i[e]=1,g.splice(e,0,1)}));const _=Sn({inputs:{x:u},attrs:{shape:g},backend:t}),{begin:w,end:k,strides:I}=a.slice_util.getNormalizedAxes(_.shape,h,b,o,i,c,d,l,p);o=w,i=k,c=I;const v=a.slice_util.maskToAxes(f);v.forEach((e=>{i[e]=o[e]+1,c[e]=1}));const A=a.slice_util.computeOutShape(o,i,c),M=A.filter(((e,n)=>-1===v.indexOf(n)));if(c.every((e=>1===e))){const e=wa({inputs:{x:_},attrs:{begin:o,size:A},backend:t});t.disposeData(_.dataId);const n=Sn({inputs:{x:e},attrs:{shape:M},backend:t});return t.disposeData(e.dataId),n}const x=t.makeOutput(M,"float32");if(!M.some((e=>0===e))){const e=t.dataIdMap.get(_.dataId).id,a=new Uint8Array(new Int32Array(n.computeStrides(_.shape)).buffer),r=new Uint8Array(new Int32Array(o).buffer),s=new Uint8Array(new Int32Array(i).buffer),u=new Uint8Array(new Int32Array(c).buffer),d=new Uint8Array(new Int32Array(M).buffer),l=new Uint8Array(new Int32Array(n.computeStrides(M)).buffer),p=t.dataIdMap.get(x.dataId).id;va(e,a,_.shape.length,r,s,u,d,l,M.length,p)}t.disposeData(_.dataId);const S=Sn({inputs:{x:x},attrs:{shape:M},backend:t});return t.disposeData(x.dataId),S}},cn(Re,!0),{kernelName:Pe,backendName:"wasm",setupFunc:function(e){Aa=e.wasm.cwrap(Pe,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:r,attrs:s}=e,{axis:u,keepDims:o}=s,{x:i}=r,c=t.dataIdMap.get(i.dataId).id;let d=c,l=i;const{transposed:p,axes:m,originalAxes:f,inputWasTransposed:h}=gn(i,u,t);let b=m;if(h){const e=t.dataIdMap.get(p.dataId).id;e!==c&&(l=p,d=e,b=a.getInnerMostAxes(b.length,l.shape.length))}a.assertAxesAreInnerMostDims("sum",b,l.shape.length);const[y,g]=a.computeOutAndReduceShapes(l.shape,b),_=n.sizeFromShape(g),w=t.makeOutput(y,l.dtype);if(0!==n.sizeFromShape(l.shape)){const e=t.dataIdMap.get(w.dataId).id;Aa(d,_,e)}if(h&&t.disposeData(p.dataId),o){const e=a.expandShapeToKeepDim(w.shape,f);w.shape=e}return w}},un(We),un(He),{kernelName:ze,backendName:"wasm",setupFunc:function(e){Ma=e.wasm.cwrap(ze,null,["number","array","number","array","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:r}=n,s=t.dataIdMap.get(r.dataId).id,{reps:u}=a,o=new Array(r.shape.length);for(let e=0;e<o.length;e++)o[e]=r.shape[e]*u[e];const i=new Uint8Array(new Int32Array(r.shape).buffer),c=new Uint8Array(new Int32Array(o).buffer),d=t.makeOutput(o,r.dtype),l=t.dataIdMap.get(d.dataId).id;return Ma(s,i,r.shape.length,c,o.length,tn[d.dtype],l),d}},{kernelName:Ue,backendName:"wasm",setupFunc:function(e){xa=e.wasm.cwrap(Ue,null,["number","array","number","number","number","bool","number","number"])},kernelFunc:({inputs:e,backend:n,attrs:t})=>{const{x:a}=e,{k:r,sorted:s}=t,u=n.dataIdMap.get(a.dataId).id,o=new Uint8Array(new Int32Array(a.shape).buffer),i=a.shape.slice();i[i.length-1]=r;const c=n.makeOutput(i,a.dtype),d=n.dataIdMap.get(c.dataId).id,l=n.makeOutput(i,"int32"),p=n.dataIdMap.get(l.dataId).id;return xa(u,o,a.shape.length,tn[a.dtype],r,s,d,p),[c,l]}},{kernelName:Le,backendName:"wasm",setupFunc:function(e){Sa=e.wasm.cwrap(Le,null,["number","number","bool","number","number","number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{image:s,transforms:u}=a,{interpolation:o,fillMode:i,fillValue:c,outputShape:d}=r,[l,p,m,f]=s.shape,[h,b]=null!=d?d:[p,m],y=[l,h,b,f],g=new Uint8Array(new Int32Array(n.computeStrides(s.shape)).buffer),_=t.makeOutput(y,s.dtype),w=t.dataIdMap.get(_.dataId).id,k=t.dataIdMap.get(s.dataId).id,I=t.dataIdMap.get(u.dataId).id,v="nearest"===o?1:2;let A;switch(i){case"constant":A=1;break;case"reflect":A=2;break;case"wrap":A=3;break;case"nearest":A=4;break;default:A=1}return Sa(k,I,u.shape[0]>1,l,h,b,f,m,p,g,s.shape.length-1,v,A,c,w),_}},yn,{kernelName:Be,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{value:r}=n;let{axis:s}=a;s<0&&(s+=r.shape.length);const u=r.shape[s],o=r.shape.length,i=new Array(o-1);let c=0;for(let e=0;e<o;e++)e!==s&&(i[c++]=r.shape[e]);const d=new Array(u),l=new Array(o).fill(0),p=r.shape.slice();p[s]=1;for(let e=0;e<d.length;e++)l[s]=e,d[e]=wa({inputs:{x:r},attrs:{begin:l,size:p},backend:t});return d.map((({dataId:e,dtype:n})=>({dataId:e,dtype:n,shape:i})))}},{kernelName:je,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(0),a}}];for(const e of Fa)qe(e);const Na=Ve();Na.registerFlag("WASM_HAS_SIMD_SUPPORT",(async()=>WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11])))),Na.registerFlag("WASM_HAS_MULTITHREAD_SUPPORT",(async()=>{if(Na.get("IS_NODE"))return!1;try{return(new MessageChannel).port1.postMessage(new SharedArrayBuffer(1)),WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,5,4,1,3,1,1,10,11,1,9,0,65,0,254,16,2,0,26,11]))}catch(e){return!1}}));var Ea="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Ta(e,n){return e(n={exports:{}},n.exports),n.exports}var Ca=Ta((function(e,n){var t,a=(t="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(t=t||__filename),function(e){function n(){return N.buffer!=C&&X(N.buffer),O}function a(){return N.buffer!=C&&X(N.buffer),D}function r(){return N.buffer!=C&&X(N.buffer),R}function s(){return N.buffer!=C&&X(N.buffer),P}function u(){return N.buffer!=C&&X(N.buffer),W}var o,i,c="undefined"!=typeof(e=e||{})?e:{};c.ready=new Promise((function(e,n){o=e,i=n}));var d,l={};for(d in c)c.hasOwnProperty(d)&&(l[d]=c[d]);var p=function(e,n){throw n},m=!1,f=!1,h=!1,b=!1;m="object"==typeof window,f="function"==typeof importScripts,h="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,b=!m&&!h&&!f;var y=c.ENVIRONMENT_IS_PTHREAD||!1;y&&(C=c.buffer);var g,_,w,k,I,v="";function A(e){return c.locateFile?c.locateFile(e,v):v+e}if(h){var M;v=f?Ye.dirname(v)+"/":__dirname+"/",g=function(e,n){return k||(k=Ze),I||(I=Ye),e=I.normalize(e),k.readFileSync(e,n?null:"utf8")},w=function(e){var n=g(e,!0);return n.buffer||(n=new Uint8Array(n)),z(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof ot))throw e})),process.on("unhandledRejection",me),p=function(e){process.exit(e)},c.inspect=function(){return"[Emscripten Module object]"};try{M=Je}catch(e){throw console.error('The "worker_threads" module is not supported in this node.js build - perhaps a newer version is needed?'),e}Ea.Worker=M.Worker}else b?("undefined"!=typeof read&&(g=function(e){return read(e)}),w=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(z("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"function"==typeof quit&&(p=function(e){quit(e)}),"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(m||f)&&(f?v=self.location.href:"undefined"!=typeof document&&document.currentScript&&(v=document.currentScript.src),"undefined"!=typeof t&&t&&(v=t),v=0!==v.indexOf("blob:")?v.substr(0,v.lastIndexOf("/")+1):"",h?(g=function(e,n){return k||(k=Ze),I||(I=Ye),e=I.normalize(e),k.readFileSync(e,n?null:"utf8")},w=function(e){var n=g(e,!0);return n.buffer||(n=new Uint8Array(n)),z(n.buffer),n}):(g=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},f&&(w=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)}),_=function(e,n,t){var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=function(){200==a.status||0==a.status&&a.response?n(a.response):t()},a.onerror=t,a.send(null)}));h&&"undefined"==typeof performance&&(Ea.performance=en.performance);var x,S=c.print||console.log.bind(console),F=c.printErr||console.warn.bind(console);for(d in l)l.hasOwnProperty(d)&&(c[d]=l[d]);l=null,c.arguments&&c.arguments,c.thisProgram&&c.thisProgram,c.quit&&(p=c.quit),c.wasmBinary&&(x=c.wasmBinary);var N,E,T=c.noExitRuntime||!0;"object"!=typeof WebAssembly&&me("no native wasm support detected");var C,O,D,R,P,W,H=!1;function z(e,n){e||me("Assertion failed: "+n)}function U(e){var n=c["_"+e];return z(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function L(e,n,t,a,r){var s={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);G(e,n=tt(t),t)}return n},array:function(e){var n=tt(e.length);return K(e,n),n}},u=U(e),o=[],i=0;if(a)for(var c=0;c<a.length;c++){var d=s[t[c]];d?(0===i&&(i=et()),o[c]=d(a[c])):o[c]=a[c]}var l=u.apply(null,o);return l=function(e){return"string"===n?q(e):"boolean"===n?Boolean(e):e}(l),0!==i&&nt(i),l}function B(e,n,t,a){var r=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!a?U(e):function(){return L(e,n,t,arguments)}}function j(e,n,t){for(var a=n+t,r="";!(n>=a);){var s=e[n++];if(!s)return r;if(128&s){var u=63&e[n++];if(192!=(224&s)){var o=63&e[n++];if((s=224==(240&s)?(15&s)<<12|u<<6|o:(7&s)<<18|u<<12|o<<6|63&e[n++])<65536)r+=String.fromCharCode(s);else{var i=s-65536;r+=String.fromCharCode(55296|i>>10,56320|1023&i)}}else r+=String.fromCharCode((31&s)<<6|u)}else r+=String.fromCharCode(s)}return r}function q(e,n){return e?j(a(),e,n):""}function V(e,n,t,a){if(!(a>0))return 0;for(var r=t,s=t+a-1,u=0;u<e.length;++u){var o=e.charCodeAt(u);if(o>=55296&&o<=57343&&(o=65536+((1023&o)<<10)|1023&e.charCodeAt(++u)),o<=127){if(t>=s)break;n[t++]=o}else if(o<=2047){if(t+1>=s)break;n[t++]=192|o>>6,n[t++]=128|63&o}else if(o<=65535){if(t+2>=s)break;n[t++]=224|o>>12,n[t++]=128|o>>6&63,n[t++]=128|63&o}else{if(t+3>=s)break;n[t++]=240|o>>18,n[t++]=128|o>>12&63,n[t++]=128|o>>6&63,n[t++]=128|63&o}}return n[t]=0,t-r}function G(e,n,t){return V(e,a(),n,t)}function $(e){for(var n=0,t=0;t<e.length;++t){var a=e.charCodeAt(t);a>=55296&&a<=57343&&(a=65536+((1023&a)<<10)|1023&e.charCodeAt(++t)),a<=127?++n:n+=a<=2047?2:a<=65535?3:4}return n}function K(e,t){n().set(e,t)}function Q(e,n){return e%n>0&&(e+=n-e%n),e}function X(e){C=e,c.HEAP8=O=new Int8Array(e),c.HEAP16=new Int16Array(e),c.HEAP32=R=new Int32Array(e),c.HEAPU8=D=new Uint8Array(e),c.HEAPU16=new Uint16Array(e),c.HEAPU32=P=new Uint32Array(e),c.HEAPF32=new Float32Array(e),c.HEAPF64=W=new Float64Array(e)}var Y,Z=c.INITIAL_MEMORY||16777216;if(y)N=c.wasmMemory,C=c.buffer;else if(c.wasmMemory)N=c.wasmMemory;else if(!((N=new WebAssembly.Memory({initial:Z/65536,maximum:32768,shared:!0})).buffer instanceof SharedArrayBuffer))throw F("requested a shared WebAssembly.Memory but the returned buffer is not a SharedArrayBuffer, indicating that while the browser has SharedArrayBuffer it does not have WebAssembly threads support - you may need to set a flag"),h&&console.log("(on node you may need: --experimental-wasm-threads --experimental-wasm-bulk-memory and also use a recent version)"),Error("bad memory");N&&(C=N.buffer),Z=C.byteLength,X(C);var J=[],ee=[],ne=[],te=[];function ae(){if(!y){if(c.preRun)for("function"==typeof c.preRun&&(c.preRun=[c.preRun]);c.preRun.length;)oe(c.preRun.shift());Me(J)}}function re(){y||Me(ee)}function se(){y||Me(ne)}function ue(){if(!y){if(c.postRun)for("function"==typeof c.postRun&&(c.postRun=[c.postRun]);c.postRun.length;)ie(c.postRun.shift());Me(te)}}function oe(e){J.unshift(e)}function ie(e){te.unshift(e)}y||ee.push({func:function(){Un()}});var ce=0,de=null;function le(e){z(!y,"addRunDependency cannot be used in a pthread worker"),ce++,c.monitorRunDependencies&&c.monitorRunDependencies(ce)}function pe(e){if(ce--,c.monitorRunDependencies&&c.monitorRunDependencies(ce),0==ce&&de){var n=de;de=null,n()}}function me(e){c.onAbort&&c.onAbort(e),y&&console.error("Pthread aborting at "+(new Error).stack),F(e+=""),H=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.";var n=new WebAssembly.RuntimeError(e);throw i(n),n}function fe(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}c.preloadedImages={},c.preloadedAudios={};var he="data:application/octet-stream;base64,";function be(e){return fe(e,he)}var ye="file://";function ge(e){return fe(e,ye)}var _e="tfjs-backend-wasm-threaded-simd.wasm";function we(e){try{if(e==_e&&x)return new Uint8Array(x);if(w)return w(e);throw"both async and sync fetching of the wasm failed"}catch(e){me(e)}}function ke(){if(!x&&(m||f)){if("function"==typeof fetch&&!ge(_e))return fetch(_e,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+_e+"'";return e.arrayBuffer()})).catch((function(){return we(_e)}));if(_)return new Promise((function(e,n){_(_e,(function(n){e(new Uint8Array(n))}),n)}))}return Promise.resolve().then((function(){return we(_e)}))}function Ie(){var e={a:zn};function n(e,n){var t=e.exports;if(c.asm=t,Y=c.asm.F,E=n,!y){var a=Te.unusedWorkers.length;Te.unusedWorkers.forEach((function(e){Te.loadWasmModuleToWorker(e,(function(){--a||pe()}))}))}}function t(e){n(e.instance,e.module)}function a(n){return ke().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){F("failed to asynchronously prepare wasm: "+e),me(e)}))}if(y||le(),c.instantiateWasm)try{return c.instantiateWasm(e,n)}catch(e){return F("Module.instantiateWasm callback failed with error: "+e),!1}return(x||"function"!=typeof WebAssembly.instantiateStreaming||be(_e)||ge(_e)||"function"!=typeof fetch?a(t):fetch(_e,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){return F("wasm streaming compile failed: "+e),F("falling back to ArrayBuffer instantiation"),a(t)}))}))).catch(i),{}}be(_e)||(_e=A(_e));var ve={9816:function(){throw"Canceled!"},9834:function(e,n){setTimeout((function(){Qn(e,n)}),0)}};function Ae(){Te.initRuntime()}function Me(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?Y.get(t)():Y.get(t)(n.arg):t(void 0===n.arg?null:n.arg)}else n(c)}}function xe(e,t){if(e<=0||e>n().length||!0&e||t<0)return-28;if(0==t)return 0;t>=2147483647&&(t=1/0);var a=Atomics.load(r(),ut>>2),s=0;if(a==e&&Atomics.compareExchange(r(),ut>>2,a,0)==a&&(s=1,--t<=0))return 1;var u=Atomics.notify(r(),e>>2,t);if(u>=0)return u+s;throw"Atomics.notify returned an unexpected value "+u}function Se(e){if(y)throw"Internal Error! killThread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in killThread!";r()[e+12>>2]=0;var n=Te.pthreads[e];n.worker.terminate(),Te.freeThreadData(n),Te.runningWorkers.splice(Te.runningWorkers.indexOf(n.worker),1),n.worker.pthread=void 0}function Fe(e){if(y)throw"Internal Error! cancelThread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in cancelThread!";Te.pthreads[e].worker.postMessage({cmd:"cancel"})}function Ne(e){if(y)throw"Internal Error! cleanupThread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in cleanupThread!";var n=Te.pthreads[e];if(n){r()[e+12>>2]=0;var t=n.worker;Te.returnWorkerToPool(t)}}c._emscripten_futex_wake=xe;var Ee,Te={unusedWorkers:[],runningWorkers:[],initMainThreadBlock:function(){for(var e=Math.min(4,Math.max(1,(navigator.hardwareConcurrency||1)/2)),n=0;n<e;++n)Te.allocateUnusedWorker()},initRuntime:function(){for(var e=Ln(228),n=0;n<57;++n)s()[e/4+n]=0;r()[e+12>>2]=e;var t=e+152;r()[t>>2]=t;var a=Ln(512);for(n=0;n<128;++n)s()[a/4+n]=0;Atomics.store(s(),e+100>>2,a),Atomics.store(s(),e+40>>2,e),Jn(e,!f,1),Kn(e)},initWorker:function(){},pthreads:{},threadExitHandlers:[],setThreadStatus:function(){},runExitHandlers:function(){for(;Te.threadExitHandlers.length>0;)Te.threadExitHandlers.pop()();y&&Vn()&&Gn()},runExitHandlersAndDeinitThread:function(e,n){Atomics.store(s(),e+56>>2,1),Atomics.store(s(),e+60>>2,0),Te.runExitHandlers(),Atomics.store(s(),e+4>>2,n),Atomics.store(s(),e+0>>2,1),xe(e+0,2147483647),Jn(0,0,0)},threadExit:function(e){var n=Vn();n&&(Te.runExitHandlersAndDeinitThread(n,e),y&&postMessage({cmd:"exit"}))},threadCancel:function(){Te.runExitHandlersAndDeinitThread(Vn(),-1),postMessage({cmd:"cancelDone"})},terminateAllThreads:function(){for(var e in Te.pthreads)(a=Te.pthreads[e])&&a.worker&&Te.returnWorkerToPool(a.worker);Te.pthreads={};for(var n=0;n<Te.unusedWorkers.length;++n)(t=Te.unusedWorkers[n]).terminate();for(Te.unusedWorkers=[],n=0;n<Te.runningWorkers.length;++n){var t,a=(t=Te.runningWorkers[n]).pthread;Te.freeThreadData(a),t.terminate()}Te.runningWorkers=[]},freeThreadData:function(e){if(e){if(e.threadInfoStruct){var n=r()[e.threadInfoStruct+100>>2];r()[e.threadInfoStruct+100>>2]=0,Bn(n),Bn(e.threadInfoStruct)}e.threadInfoStruct=0,e.allocatedOwnStack&&e.stackBase&&Bn(e.stackBase),e.stackBase=0,e.worker&&(e.worker.pthread=null)}},returnWorkerToPool:function(e){Te.runWithoutMainThreadQueuedCalls((function(){delete Te.pthreads[e.pthread.threadInfoStruct],Te.unusedWorkers.push(e),Te.runningWorkers.splice(Te.runningWorkers.indexOf(e),1),Te.freeThreadData(e.pthread),e.pthread=void 0}))},runWithoutMainThreadQueuedCalls:function(e){r()[st>>2]=0;try{e()}finally{r()[st>>2]=1}},receiveObjectTransfer:function(e){},loadWasmModuleToWorker:function(e,n){e.onmessage=function(t){var a=t.data,r=a.cmd;if(e.pthread&&(Te.currentProxiedOperationCallerThread=e.pthread.threadInfoStruct),a.targetThread&&a.targetThread!=Vn()){var u=Te.pthreads[a.targetThread];return u?u.worker.postMessage(t.data,a.transferList):console.error('Internal error! Worker sent a message "'+r+'" to target pthread '+a.targetThread+", but that thread no longer exists!"),void(Te.currentProxiedOperationCallerThread=void 0)}if("processQueuedMainThreadWork"===r)$n();else if("spawnThread"===r)Dn(t.data);else if("cleanupThread"===r)Ne(a.thread);else if("killThread"===r)Se(a.thread);else if("cancelThread"===r)Fe(a.thread);else if("loaded"===r)e.loaded=!0,n&&n(e),e.runPthread&&(e.runPthread(),delete e.runPthread);else if("print"===r)S("Thread "+a.threadId+": "+a.text);else if("printErr"===r)F("Thread "+a.threadId+": "+a.text);else if("alert"===r)alert("Thread "+a.threadId+": "+a.text);else if("exit"===r)e.pthread&&Atomics.load(s(),e.pthread.threadInfoStruct+64>>2)&&Te.returnWorkerToPool(e);else if("exitProcess"===r)try{ct(a.returnCode)}catch(t){if(t instanceof ot)return;throw t}else"cancelDone"===r?Te.returnWorkerToPool(e):"objectTransfer"===r?Te.receiveObjectTransfer(t.data):"setimmediate"===t.data.target?e.postMessage(t.data):F("worker sent an unknown command "+r);Te.currentProxiedOperationCallerThread=void 0},e.onerror=function(e){F("pthread sent an error! "+e.filename+":"+e.lineno+": "+e.message)},h&&(e.on("message",(function(n){e.onmessage({data:n})})),e.on("error",(function(n){e.onerror(n)})),e.on("exit",(function(e){}))),e.postMessage({cmd:"load",urlOrBlob:c.mainScriptUrlOrBlob||t,wasmMemory:N,wasmModule:E})},allocateUnusedWorker:function(){var e=A("tfjs-backend-wasm-threaded-simd.worker.js");Te.unusedWorkers.push(new Worker(e))},getNewWorker:function(){return 0==Te.unusedWorkers.length&&(Te.allocateUnusedWorker(),Te.loadWasmModuleToWorker(Te.unusedWorkers[0])),Te.unusedWorkers.length>0?Te.unusedWorkers.pop():null},busySpinWait:function(e){for(var n=performance.now()+e;performance.now()<n;);}};function Ce(e,n){at(e,n),nt(e)}function Oe(){return T}function De(e,n){return Y.get(e)(n)}function Re(e,n,t,a){me("Assertion failed: "+q(e)+", at: "+[n?q(n):"unknown filename",t,a?q(a):"unknown function"])}function Pe(e,n){_main(e,n)}function We(e){return r()[jn()>>2]=e,e}function He(e,n){if(y)return Ge(1,1,e,n)}function ze(e,n){if(e==n)postMessage({cmd:"processQueuedMainThreadWork"});else if(y)postMessage({targetThread:e,cmd:"processThreadQueue"});else{var t=Te.pthreads[e],a=t&&t.worker;if(!a)return;a.postMessage({cmd:"processThreadQueue"})}return 1}function Ue(){me()}function Le(e,n,t){var a=Qe(n,t);return ve[e].apply(null,a)}function Be(e,n){}function je(e,t,a){if(e<=0||e>n().length||!0&e)return-28;if(m){if(Atomics.load(r(),e>>2)!=t)return-6;var s=performance.now(),u=s+a;for(Atomics.exchange(r(),ut>>2,e);;){if((s=performance.now())>u)return Atomics.exchange(r(),ut>>2,0),-73;if(0==Atomics.exchange(r(),ut>>2,0))break;if($n(),Atomics.load(r(),e>>2)!=t)return-6;Atomics.exchange(r(),ut>>2,e)}return 0}var o=Atomics.wait(r(),e>>2,t,a);if("timed-out"===o)return-73;if("not-equal"===o)return-6;if("ok"===o)return 0;throw"Atomics.wait returned an unexpected value "+o}function qe(e,n,t){a().copyWithin(e,n,n+t)}function Ve(){return h?nn.cpus().length:navigator.hardwareConcurrency}function Ge(e,n){for(var t=arguments.length-2,a=et(),r=t,s=tt(8*r),o=s>>3,i=0;i<t;i++){var c=arguments[2+i];u()[o+i]=c}var d=Yn(e,r,s,n);return nt(a),d}c.establishStackSpace=Ce,c.getNoExitRuntime=Oe,c.invokeEntryPoint=De,Ee=h?function(){var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:y?function(){return performance.now()-c.__performance_now_clock_drift}:"undefined"!=typeof dateNow?dateNow:function(){return performance.now()};var $e=[],Ke=[];function Qe(e,n){var t;for(Ke.length=0,n>>=2;t=a()[e++];){var s=t<105;s&&1&n&&n++,Ke.push(s?u()[n++>>1]:r()[n]),++n}return Ke}function Xe(e,n,t){$e.length=n;for(var a=t>>3,r=0;r<n;r++)$e[r]=u()[a+r];return(e<0?ve[-e-1]:Hn[e]).apply(null,$e)}function tn(){return a().length}function an(e){try{return N.grow(e-C.byteLength+65535>>>16),X(N.buffer),1}catch(e){}}function rn(e){var n=tn();if(e<=n)return!1;var t=2147483648;if(e>t)return!1;for(var a=1;a<=4;a*=2){var r=n*(1+.2/a);if(r=Math.min(r,e+100663296),an(Math.min(t,Q(Math.max(e,r),65536))))return!0}return!1}var sn={inEventHandler:0,removeAllEventListeners:function(){for(var e=sn.eventHandlers.length-1;e>=0;--e)sn._removeHandler(e);sn.eventHandlers=[],sn.deferredCalls=[]},registerRemoveEventListeners:function(){sn.removeEventListenersRegistered||(sn.removeEventListenersRegistered=!0)},deferredCalls:[],deferCall:function(e,n,t){function a(e,n){if(e.length!=n.length)return!1;for(var t in e)if(e[t]!=n[t])return!1;return!0}for(var r in sn.deferredCalls){var s=sn.deferredCalls[r];if(s.targetFunction==e&&a(s.argsList,t))return}sn.deferredCalls.push({targetFunction:e,precedence:n,argsList:t}),sn.deferredCalls.sort((function(e,n){return e.precedence<n.precedence}))},removeDeferredCalls:function(e){for(var n=0;n<sn.deferredCalls.length;++n)sn.deferredCalls[n].targetFunction==e&&(sn.deferredCalls.splice(n,1),--n)},canPerformEventHandlerRequests:function(){return sn.inEventHandler&&sn.currentEventHandler.allowsDeferredCalls},runDeferredCalls:function(){if(sn.canPerformEventHandlerRequests())for(var e=0;e<sn.deferredCalls.length;++e){var n=sn.deferredCalls[e];sn.deferredCalls.splice(e,1),--e,n.targetFunction.apply(null,n.argsList)}},eventHandlers:[],removeAllHandlersOnTarget:function(e,n){for(var t=0;t<sn.eventHandlers.length;++t)sn.eventHandlers[t].target!=e||n&&n!=sn.eventHandlers[t].eventTypeString||sn._removeHandler(t--)},_removeHandler:function(e){var n=sn.eventHandlers[e];n.target.removeEventListener(n.eventTypeString,n.eventListenerFunc,n.useCapture),sn.eventHandlers.splice(e,1)},registerOrRemoveHandler:function(e){var n=function(n){++sn.inEventHandler,sn.currentEventHandler=e,sn.runDeferredCalls(),e.handlerFunc(n),sn.runDeferredCalls(),--sn.inEventHandler};if(e.callbackfunc)e.eventListenerFunc=n,e.target.addEventListener(e.eventTypeString,n,e.useCapture),sn.eventHandlers.push(e),sn.registerRemoveEventListeners();else for(var t=0;t<sn.eventHandlers.length;++t)sn.eventHandlers[t].target==e.target&&sn.eventHandlers[t].eventTypeString==e.eventTypeString&&sn._removeHandler(t--)},queueEventHandlerOnThread_iiii:function(e,n,t,a,s){var u=et(),o=tt(12);r()[o>>2]=t,r()[o+4>>2]=a,r()[o+8>>2]=s,Zn(0,e,637534208,n,a,o),nt(u)},getTargetThreadForEventCallback:function(e){switch(e){case 1:return 0;case 2:return Te.currentProxiedOperationCallerThread;default:return e}},getNodeNameForTarget:function(e){return e?e==window?"#window":e==screen?"#screen":e&&e.nodeName?e.nodeName:"":""},fullscreenEnabled:function(){return document.fullscreenEnabled||document.webkitFullscreenEnabled}};function un(e){var n=$(e)+1,t=Ln(n);return G(e,t,n),t}function on(e,n,t,a){var s=et(),u=tt(12),o=0;n&&(o=un(n)),r()[u>>2]=o,r()[u+4>>2]=t,r()[u+8>>2]=a,Zn(0,e,657457152,0,o,u),nt(s)}function cn(e,n,t,a){on(e,n=n?q(n):"",t,a)}function dn(e){return e>2?q(e):e}var ln=[0,"undefined"!=typeof document?document:0,"undefined"!=typeof window?window:0];function pn(e){return e=dn(e),ln[e]||("undefined"!=typeof document?document.querySelector(e):void 0)}function mn(e){return pn(e)}function fn(e,n,t){var a=mn(e);if(!a)return-4;if(a.canvasSharedPtr&&(r()[a.canvasSharedPtr>>2]=n,r()[a.canvasSharedPtr+4>>2]=t),!a.offscreenCanvas&&a.controlTransferredOffscreen)return a.canvasSharedPtr?(cn(r()[a.canvasSharedPtr+8>>2],e,n,t),1):-4;a.offscreenCanvas&&(a=a.offscreenCanvas);var s=!1;if(a.GLctxObject&&a.GLctxObject.GLctx){var u=a.GLctxObject.GLctx.getParameter(2978);s=0===u[0]&&0===u[1]&&u[2]===a.width&&u[3]===a.height}return a.width=n,a.height=t,s&&a.GLctxObject.GLctx.viewport(0,0,n,t),0}function hn(e,n,t){return y?Ge(2,1,e,n,t):fn(e,n,t)}function bn(e,n,t){return mn(e)?fn(e,n,t):hn(e,n,t)}function yn(e){}function gn(e,n){}function _n(e){var n=e.getExtension("ANGLE_instanced_arrays");if(n)return e.vertexAttribDivisor=function(e,t){n.vertexAttribDivisorANGLE(e,t)},e.drawArraysInstanced=function(e,t,a,r){n.drawArraysInstancedANGLE(e,t,a,r)},e.drawElementsInstanced=function(e,t,a,r,s){n.drawElementsInstancedANGLE(e,t,a,r,s)},1}function wn(e){var n=e.getExtension("OES_vertex_array_object");if(n)return e.createVertexArray=function(){return n.createVertexArrayOES()},e.deleteVertexArray=function(e){n.deleteVertexArrayOES(e)},e.bindVertexArray=function(e){n.bindVertexArrayOES(e)},e.isVertexArray=function(e){return n.isVertexArrayOES(e)},1}function kn(e){var n=e.getExtension("WEBGL_draw_buffers");if(n)return e.drawBuffers=function(e,t){n.drawBuffersWEBGL(e,t)},1}function In(e){return!!(e.multiDrawWebgl=e.getExtension("WEBGL_multi_draw"))}var vn={counter:1,buffers:[],programs:[],framebuffers:[],renderbuffers:[],textures:[],uniforms:[],shaders:[],vaos:[],contexts:{},offscreenCanvases:{},timerQueriesEXT:[],programInfos:{},stringCache:{},unpackAlignment:4,recordError:function(e){vn.lastError||(vn.lastError=e)},getNewId:function(e){for(var n=vn.counter++,t=e.length;t<n;t++)e[t]=null;return n},getSource:function(e,n,t,a){for(var s="",u=0;u<n;++u){var o=a?r()[a+4*u>>2]:-1;s+=q(r()[t+4*u>>2],o<0?void 0:o)}return s},createContext:function(e,n){var t=e.getContext("webgl",n);return t?vn.registerContext(t,n):0},registerContext:function(e,n){var t=Ln(8);r()[t+4>>2]=Vn();var a={handle:t,attributes:n,version:n.majorVersion,GLctx:e};return e.canvas&&(e.canvas.GLctxObject=a),vn.contexts[t]=a,("undefined"==typeof n.enableExtensionsByDefault||n.enableExtensionsByDefault)&&vn.initExtensions(a),t},makeContextCurrent:function(e){return vn.currentContext=vn.contexts[e],c.ctx=Sn=vn.currentContext&&vn.currentContext.GLctx,!(e&&!Sn)},getContext:function(e){return vn.contexts[e]},deleteContext:function(e){vn.currentContext===vn.contexts[e]&&(vn.currentContext=null),"object"==typeof sn&&sn.removeAllHandlersOnTarget(vn.contexts[e].GLctx.canvas),vn.contexts[e]&&vn.contexts[e].GLctx.canvas&&(vn.contexts[e].GLctx.canvas.GLctxObject=void 0),Bn(vn.contexts[e].handle),vn.contexts[e]=null},initExtensions:function(e){if(e||(e=vn.currentContext),!e.initExtensionsDone){e.initExtensionsDone=!0;var n=e.GLctx;_n(n),wn(n),kn(n),n.disjointTimerQueryExt=n.getExtension("EXT_disjoint_timer_query"),In(n),(n.getSupportedExtensions()||[]).forEach((function(e){e.indexOf("lose_context")<0&&e.indexOf("debug")<0&&n.getExtension(e)}))}},populateUniformTable:function(e){for(var n=vn.programs[e],t=vn.programInfos[e]={uniforms:{},maxUniformLength:0,maxAttributeLength:-1,maxUniformBlockNameLength:-1},a=t.uniforms,r=Sn.getProgramParameter(n,35718),s=0;s<r;++s){var u=Sn.getActiveUniform(n,s),o=u.name;t.maxUniformLength=Math.max(t.maxUniformLength,o.length+1),"]"==o.slice(-1)&&(o=o.slice(0,o.lastIndexOf("[")));var i=Sn.getUniformLocation(n,o);if(i){var c=vn.getNewId(vn.uniforms);a[o]=[u.size,c],vn.uniforms[c]=i;for(var d=1;d<u.size;++d){var l=o+"["+d+"]";i=Sn.getUniformLocation(n,l),c=vn.getNewId(vn.uniforms),vn.uniforms[c]=i}}}}},An=["default","low-power","high-performance"];function Mn(e,n){var t=n>>2,a=r()[t+6],s={alpha:!!r()[t+0],depth:!!r()[t+1],stencil:!!r()[t+2],antialias:!!r()[t+3],premultipliedAlpha:!!r()[t+4],preserveDrawingBuffer:!!r()[t+5],powerPreference:An[a],failIfMajorPerformanceCaveat:!!r()[t+7],majorVersion:r()[t+8],minorVersion:r()[t+9],enableExtensionsByDefault:r()[t+10],explicitSwapControl:r()[t+11],proxyContextToMainThread:r()[t+12],renderViaOffscreenBackBuffer:r()[t+13]},u=mn(e);return u?s.explicitSwapControl?0:vn.createContext(u,s):0}function xn(e,n){return Mn(e,n)}var Sn,Fn={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var t=Fn.buffers[e];0===n||10===n?((1===e?S:F)(j(t,0)),t.length=0):t.push(n)},varargs:void 0,get:function(){return Fn.varargs+=4,r()[Fn.varargs-4>>2]},getStr:function(e){return q(e)},get64:function(e,n){return e}};function Nn(e){return y?Ge(3,1,e):0}function En(e,n,t,a,r){if(y)return Ge(4,1,e,n,t,a,r)}function Tn(e,n,t,s){if(y)return Ge(5,1,e,n,t,s);for(var u=0,o=0;o<t;o++){for(var i=r()[n+8*o>>2],c=r()[n+(8*o+4)>>2],d=0;d<c;d++)Fn.printChar(e,a()[i+d]);u+=c}return r()[s>>2]=u,0}function Cn(e){var n=Te.threadExitHandlers.pop();e&&n()}function On(e,n){Te.threadExitHandlers.push((function(){Y.get(e)(n)}))}function Dn(e){if(y)throw"Internal Error! spawnThread() can only ever be called from main application thread!";var n=Te.getNewWorker();if(void 0!==n.pthread)throw"Internal error!";if(!e.pthread_ptr)throw"Internal error, no pthread ptr!";Te.runningWorkers.push(n);for(var t=Ln(512),a=0;a<128;++a)r()[t+4*a>>2]=0;var u=e.stackBase+e.stackSize,o=Te.pthreads[e.pthread_ptr]={worker:n,stackBase:e.stackBase,stackSize:e.stackSize,allocatedOwnStack:e.allocatedOwnStack,threadInfoStruct:e.pthread_ptr},i=o.threadInfoStruct>>2;Atomics.store(s(),i+16,e.detached),Atomics.store(s(),i+25,t),Atomics.store(s(),i+10,o.threadInfoStruct),Atomics.store(s(),i+20,e.stackSize),Atomics.store(s(),i+19,u),Atomics.store(s(),i+26,e.stackSize),Atomics.store(s(),i+28,u),Atomics.store(s(),i+29,e.detached);var c=qn()+40;Atomics.store(s(),i+43,c),n.pthread=o;var d={cmd:"run",start_routine:e.startRoutine,arg:e.arg,threadInfoStruct:e.pthread_ptr,stackBase:e.stackBase,stackSize:e.stackSize};n.runPthread=function(){d.time=performance.now(),n.postMessage(d,e.transferList)},n.loaded&&(n.runPthread(),delete n.runPthread)}function Rn(e,n,t,a){if("undefined"==typeof SharedArrayBuffer)return F("Current environment does not support SharedArrayBuffer, pthreads are not available!"),6;if(!e)return F("pthread_create called with a null thread pointer!"),28;var u=[];if(y&&0===u.length)return Xn(687865856,e,n,t,a);var o=0,i=0,c=0;n&&-1!=n?(o=r()[n>>2],o+=81920,i=r()[n+8>>2],c=0!==r()[n+12>>2]):o=2097152;var d=0==i;d?i=rt(16,o):z((i-=o)>0);for(var l=Ln(228),p=0;p<57;++p)s()[(l>>2)+p]=0;r()[e>>2]=l,r()[l+12>>2]=l;var m=l+152;r()[m>>2]=m;var f={stackBase:i,stackSize:o,allocatedOwnStack:d,detached:c,startRoutine:t,pthread_ptr:l,arg:a,transferList:u};return y?(f.cmd="spawnThread",postMessage(f,u)):Dn(f),0}function Pn(e){if(y)return Ge(6,1,e);switch(e){case 30:return 16384;case 85:return 131072;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:case 80:case 81:case 79:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator&&navigator.hardwareConcurrency||1}return We(28),-1}y||Te.initMainThreadBlock();var Wn,Hn=[null,He,hn,Nn,En,Tn,Pn],zn={e:Re,r:Pe,x:ze,b:Ue,y:Le,j:Be,c:je,d:xe,f:Ee,p:qe,z:Ve,u:Xe,q:rn,v:bn,i:yn,t:gn,w:xn,m:Nn,n:En,g:Tn,o:Ae,a:N||c.wasmMemory,k:Cn,l:On,h:Rn,s:Pn},Un=(Ie(),c.___wasm_call_ctors=function(){return(Un=c.___wasm_call_ctors=c.asm.A).apply(null,arguments)}),Ln=(c._init=function(){return(c._init=c.asm.B).apply(null,arguments)},c._register_tensor=function(){return(c._register_tensor=c.asm.C).apply(null,arguments)},c._dispose_data=function(){return(c._dispose_data=c.asm.D).apply(null,arguments)},c._dispose=function(){return(c._dispose=c.asm.E).apply(null,arguments)},c._Abs=function(){return(c._Abs=c.asm.G).apply(null,arguments)},c._Add=function(){return(c._Add=c.asm.H).apply(null,arguments)},c._AddN=function(){return(c._AddN=c.asm.I).apply(null,arguments)},c._All=function(){return(c._All=c.asm.J).apply(null,arguments)},c._Any=function(){return(c._Any=c.asm.K).apply(null,arguments)},c._ArgMax=function(){return(c._ArgMax=c.asm.L).apply(null,arguments)},c._AvgPool=function(){return(c._AvgPool=c.asm.M).apply(null,arguments)},c._BatchMatMul=function(){return(c._BatchMatMul=c.asm.N).apply(null,arguments)},c._Ceil=function(){return(c._Ceil=c.asm.O).apply(null,arguments)},c._ClipByValue=function(){return(c._ClipByValue=c.asm.P).apply(null,arguments)},c._Conv2D=function(){return(c._Conv2D=c.asm.Q).apply(null,arguments)},c._Conv2DBackpropInput=function(){return(c._Conv2DBackpropInput=c.asm.R).apply(null,arguments)},c._Cos=function(){return(c._Cos=c.asm.S).apply(null,arguments)},c._CropAndResize=function(){return(c._CropAndResize=c.asm.T).apply(null,arguments)},c._Cumsum=function(){return(c._Cumsum=c.asm.U).apply(null,arguments)},c._DepthToSpace=function(){return(c._DepthToSpace=c.asm.V).apply(null,arguments)},c._DepthwiseConv2dNative=function(){return(c._DepthwiseConv2dNative=c.asm.W).apply(null,arguments)},c._Equal=function(){return(c._Equal=c.asm.X).apply(null,arguments)},c._Exp=function(){return(c._Exp=c.asm.Y).apply(null,arguments)},c._FlipLeftRight=function(){return(c._FlipLeftRight=c.asm.Z).apply(null,arguments)},c._Floor=function(){return(c._Floor=c.asm._).apply(null,arguments)},c._FloorDiv=function(){return(c._FloorDiv=c.asm.$).apply(null,arguments)},c._FusedBatchNorm=function(){return(c._FusedBatchNorm=c.asm.aa).apply(null,arguments)},c._FusedConv2D=function(){return(c._FusedConv2D=c.asm.ba).apply(null,arguments)},c._FusedDepthwiseConv2D=function(){return(c._FusedDepthwiseConv2D=c.asm.ca).apply(null,arguments)},c._Gather=function(){return(c._Gather=c.asm.da).apply(null,arguments)},c._GatherNd=function(){return(c._GatherNd=c.asm.ea).apply(null,arguments)},c._Greater=function(){return(c._Greater=c.asm.fa).apply(null,arguments)},c._GreaterEqual=function(){return(c._GreaterEqual=c.asm.ga).apply(null,arguments)},c._LeakyRelu=function(){return(c._LeakyRelu=c.asm.ha).apply(null,arguments)},c._Less=function(){return(c._Less=c.asm.ia).apply(null,arguments)},c._LessEqual=function(){return(c._LessEqual=c.asm.ja).apply(null,arguments)},c._Log=function(){return(c._Log=c.asm.ka).apply(null,arguments)},c._LogicalAnd=function(){return(c._LogicalAnd=c.asm.la).apply(null,arguments)},c._Max=function(){return(c._Max=c.asm.ma).apply(null,arguments)},c._MaxPool=function(){return(c._MaxPool=c.asm.na).apply(null,arguments)},c._Maximum=function(){return(c._Maximum=c.asm.oa).apply(null,arguments)},c._Mean=function(){return(c._Mean=c.asm.pa).apply(null,arguments)},c._Min=function(){return(c._Min=c.asm.qa).apply(null,arguments)},c._Minimum=function(){return(c._Minimum=c.asm.ra).apply(null,arguments)},c._MirrorPad=function(){return(c._MirrorPad=c.asm.sa).apply(null,arguments)},c._Multiply=function(){return(c._Multiply=c.asm.ta).apply(null,arguments)},c._Neg=function(){return(c._Neg=c.asm.ua).apply(null,arguments)},c._NonMaxSuppressionV3=function(){return(c._NonMaxSuppressionV3=c.asm.va).apply(null,arguments)},c._NonMaxSuppressionV4=function(){return(c._NonMaxSuppressionV4=c.asm.wa).apply(null,arguments)},c._NonMaxSuppressionV5=function(){return(c._NonMaxSuppressionV5=c.asm.xa).apply(null,arguments)},c._NotEqual=function(){return(c._NotEqual=c.asm.ya).apply(null,arguments)},c._OneHot=function(){return(c._OneHot=c.asm.za).apply(null,arguments)},c._PadV2=function(){return(c._PadV2=c.asm.Aa).apply(null,arguments)},c._Pow=function(){return(c._Pow=c.asm.Ba).apply(null,arguments)},c._Prelu=function(){return(c._Prelu=c.asm.Ca).apply(null,arguments)},c._Prod=function(){return(c._Prod=c.asm.Da).apply(null,arguments)},c._RealDiv=function(){return(c._RealDiv=c.asm.Ea).apply(null,arguments)},c._Relu=function(){return(c._Relu=c.asm.Fa).apply(null,arguments)},c._Relu6=function(){return(c._Relu6=c.asm.Ga).apply(null,arguments)},c._ResizeBilinear=function(){return(c._ResizeBilinear=c.asm.Ha).apply(null,arguments)},c._Reverse=function(){return(c._Reverse=c.asm.Ia).apply(null,arguments)},c._RotateWithOffset=function(){return(c._RotateWithOffset=c.asm.Ja).apply(null,arguments)},c._Round=function(){return(c._Round=c.asm.Ka).apply(null,arguments)},c._Rsqrt=function(){return(c._Rsqrt=c.asm.La).apply(null,arguments)},c._ScatterNd=function(){return(c._ScatterNd=c.asm.Ma).apply(null,arguments)},c._SelectV2=function(){return(c._SelectV2=c.asm.Na).apply(null,arguments)},c._Sigmoid=function(){return(c._Sigmoid=c.asm.Oa).apply(null,arguments)},c._Sin=function(){return(c._Sin=c.asm.Pa).apply(null,arguments)},c._Softmax=function(){return(c._Softmax=c.asm.Qa).apply(null,arguments)},c._Sqrt=function(){return(c._Sqrt=c.asm.Ra).apply(null,arguments)},c._Square=function(){return(c._Square=c.asm.Sa).apply(null,arguments)},c._SquaredDifference=function(){return(c._SquaredDifference=c.asm.Ta).apply(null,arguments)},c._Step=function(){return(c._Step=c.asm.Ua).apply(null,arguments)},c._StridedSlice=function(){return(c._StridedSlice=c.asm.Va).apply(null,arguments)},c._Sub=function(){return(c._Sub=c.asm.Wa).apply(null,arguments)},c._Sum=function(){return(c._Sum=c.asm.Xa).apply(null,arguments)},c._Tan=function(){return(c._Tan=c.asm.Ya).apply(null,arguments)},c._Tanh=function(){return(c._Tanh=c.asm.Za).apply(null,arguments)},c._Tile=function(){return(c._Tile=c.asm._a).apply(null,arguments)},c._TopK=function(){return(c._TopK=c.asm.$a).apply(null,arguments)},c._Transform=function(){return(c._Transform=c.asm.ab).apply(null,arguments)},c._Transpose=function(){return(c._Transpose=c.asm.bb).apply(null,arguments)},c.__FusedMatMul=function(){return(c.__FusedMatMul=c.asm.cb).apply(null,arguments)},c._malloc=function(){return(Ln=c._malloc=c.asm.db).apply(null,arguments)}),Bn=c._free=function(){return(Bn=c._free=c.asm.eb).apply(null,arguments)},jn=c.___errno_location=function(){return(jn=c.___errno_location=c.asm.fb).apply(null,arguments)},qn=c._emscripten_get_global_libc=function(){return(qn=c._emscripten_get_global_libc=c.asm.gb).apply(null,arguments)},Vn=c._pthread_self=function(){return(Vn=c._pthread_self=c.asm.hb).apply(null,arguments)},Gn=c.___pthread_tsd_run_dtors=function(){return(Gn=c.___pthread_tsd_run_dtors=c.asm.ib).apply(null,arguments)},$n=c._emscripten_main_thread_process_queued_calls=function(){return($n=c._emscripten_main_thread_process_queued_calls=c.asm.jb).apply(null,arguments)},Kn=(c._emscripten_current_thread_process_queued_calls=function(){return(c._emscripten_current_thread_process_queued_calls=c.asm.kb).apply(null,arguments)},c._emscripten_register_main_browser_thread_id=function(){return(Kn=c._emscripten_register_main_browser_thread_id=c.asm.lb).apply(null,arguments)}),Qn=c.__emscripten_do_dispatch_to_thread=function(){return(Qn=c.__emscripten_do_dispatch_to_thread=c.asm.mb).apply(null,arguments)},Xn=c._emscripten_sync_run_in_main_thread_4=function(){return(Xn=c._emscripten_sync_run_in_main_thread_4=c.asm.nb).apply(null,arguments)},Yn=c._emscripten_run_in_main_runtime_thread_js=function(){return(Yn=c._emscripten_run_in_main_runtime_thread_js=c.asm.ob).apply(null,arguments)},Zn=c.__emscripten_call_on_thread=function(){return(Zn=c.__emscripten_call_on_thread=c.asm.pb).apply(null,arguments)},Jn=(c._emscripten_tls_init=function(){return(c._emscripten_tls_init=c.asm.qb).apply(null,arguments)},c.__emscripten_thread_init=function(){return(Jn=c.__emscripten_thread_init=c.asm.rb).apply(null,arguments)}),et=c.stackSave=function(){return(et=c.stackSave=c.asm.sb).apply(null,arguments)},nt=c.stackRestore=function(){return(nt=c.stackRestore=c.asm.tb).apply(null,arguments)},tt=c.stackAlloc=function(){return(tt=c.stackAlloc=c.asm.ub).apply(null,arguments)},at=c._emscripten_stack_set_limits=function(){return(at=c._emscripten_stack_set_limits=c.asm.vb).apply(null,arguments)},rt=c._memalign=function(){return(rt=c._memalign=c.asm.wb).apply(null,arguments)},st=c.__emscripten_allow_main_runtime_queued_calls=9808,ut=c.__emscripten_main_thread_futex=11432;function ot(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function it(e){if(!(ce>0)){if(y)return o(c),re(),void postMessage({cmd:"loaded"});ae(),ce>0||(c.setStatus?(c.setStatus("Running..."),setTimeout((function(){setTimeout((function(){c.setStatus("")}),1),n()}),1)):n())}function n(){Wn||(Wn=!0,c.calledRun=!0,H||(re(),se(),o(c),c.onRuntimeInitialized&&c.onRuntimeInitialized(),ue()))}}function ct(e,n){if(!n||!T||0!==e){if(!n&&y)throw postMessage({cmd:"exitProcess",returnCode:e}),new ot(e);T||(Te.terminateAllThreads(),c.onExit&&c.onExit(e),H=!0),p(e,new ot(e))}}if(c.cwrap=B,c.PThread=Te,c.PThread=Te,c.wasmMemory=N,c.ExitStatus=ot,de=function e(){Wn||it(),Wn||(de=e)},c.run=it,c.preInit)for("function"==typeof c.preInit&&(c.preInit=[c.preInit]);c.preInit.length>0;)c.preInit.pop()();return y&&(T=!1,Te.initWorker()),it(),e.ready});e.exports=a}));var Oa=Ta((function(e,n){var t,a=(t="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(t=t||__filename),function(e){var n,a,r="undefined"!=typeof(e=e||{})?e:{};r.ready=new Promise((function(e,t){n=e,a=t}));var s,u={};for(s in r)r.hasOwnProperty(s)&&(u[s]=r[s]);var o=!1,i=!1,c=!1,d=!1;o="object"==typeof window,i="function"==typeof importScripts,c="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,d=!o&&!c&&!i;var l,p,m,f,h,b="";function y(e){return r.locateFile?r.locateFile(e,b):b+e}c?(b=i?Ye.dirname(b)+"/":__dirname+"/",l=function(e,n){return f||(f=Ze),h||(h=Ye),e=h.normalize(e),f.readFileSync(e,n?null:"utf8")},m=function(e){var n=l(e,!0);return n.buffer||(n=new Uint8Array(n)),v(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof Ee))throw e})),process.on("unhandledRejection",ee),r.inspect=function(){return"[Emscripten Module object]"}):d?("undefined"!=typeof read&&(l=function(e){return read(e)}),m=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(v("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(o||i)&&(i?b=self.location.href:"undefined"!=typeof document&&document.currentScript&&(b=document.currentScript.src),t&&(b=t),b=0!==b.indexOf("blob:")?b.substr(0,b.lastIndexOf("/")+1):"",l=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},i&&(m=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)}),p=function(e,n,t){var a=new XMLHttpRequest;a.open("GET",e,!0),a.responseType="arraybuffer",a.onload=function(){200==a.status||0==a.status&&a.response?n(a.response):t()},a.onerror=t,a.send(null)});var g,_,w=r.print||console.log.bind(console),k=r.printErr||console.warn.bind(console);for(s in u)u.hasOwnProperty(s)&&(r[s]=u[s]);u=null,r.arguments&&r.arguments,r.thisProgram&&r.thisProgram,r.quit&&r.quit,r.wasmBinary&&(g=r.wasmBinary),r.noExitRuntime,"object"!=typeof WebAssembly&&ee("no native wasm support detected");var I=!1;function v(e,n){e||ee("Assertion failed: "+n)}function A(e){var n=r["_"+e];return v(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function M(e,n,t,a,r){var s={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);R(e,n=Ne(t),t)}return n},array:function(e){var n=Ne(e.length);return P(e,n),n}},u=A(e),o=[],i=0;if(a)for(var c=0;c<a.length;c++){var d=s[t[c]];d?(0===i&&(i=Se()),o[c]=d(a[c])):o[c]=a[c]}var l=u.apply(null,o);return l=function(e){return"string"===n?O(e):"boolean"===n?Boolean(e):e}(l),0!==i&&Fe(i),l}function x(e,n,t,a){var r=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!a?A(e):function(){return M(e,n,t,arguments)}}var S,F,N,E,T="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function C(e,n,t){for(var a=n+t,r=n;e[r]&&!(r>=a);)++r;if(r-n>16&&e.subarray&&T)return T.decode(e.subarray(n,r));for(var s="";n<r;){var u=e[n++];if(128&u){var o=63&e[n++];if(192!=(224&u)){var i=63&e[n++];if((u=224==(240&u)?(15&u)<<12|o<<6|i:(7&u)<<18|o<<12|i<<6|63&e[n++])<65536)s+=String.fromCharCode(u);else{var c=u-65536;s+=String.fromCharCode(55296|c>>10,56320|1023&c)}}else s+=String.fromCharCode((31&u)<<6|o)}else s+=String.fromCharCode(u)}return s}function O(e,n){return e?C(N,e,n):""}function D(e,n,t,a){if(!(a>0))return 0;for(var r=t,s=t+a-1,u=0;u<e.length;++u){var o=e.charCodeAt(u);if(o>=55296&&o<=57343&&(o=65536+((1023&o)<<10)|1023&e.charCodeAt(++u)),o<=127){if(t>=s)break;n[t++]=o}else if(o<=2047){if(t+1>=s)break;n[t++]=192|o>>6,n[t++]=128|63&o}else if(o<=65535){if(t+2>=s)break;n[t++]=224|o>>12,n[t++]=128|o>>6&63,n[t++]=128|63&o}else{if(t+3>=s)break;n[t++]=240|o>>18,n[t++]=128|o>>12&63,n[t++]=128|o>>6&63,n[t++]=128|63&o}}return n[t]=0,t-r}function R(e,n,t){return D(e,N,n,t)}function P(e,n){F.set(e,n)}function W(e,n){return e%n>0&&(e+=n-e%n),e}function H(e){S=e,r.HEAP8=F=new Int8Array(e),r.HEAP16=new Int16Array(e),r.HEAP32=E=new Int32Array(e),r.HEAPU8=N=new Uint8Array(e),r.HEAPU16=new Uint16Array(e),r.HEAPU32=new Uint32Array(e),r.HEAPF32=new Float32Array(e),r.HEAPF64=new Float64Array(e)}r.INITIAL_MEMORY;var z,U=[],L=[],B=[],j=[];function q(){if(r.preRun)for("function"==typeof r.preRun&&(r.preRun=[r.preRun]);r.preRun.length;)K(r.preRun.shift());de(U)}function V(){de(L)}function G(){de(B)}function $(){if(r.postRun)for("function"==typeof r.postRun&&(r.postRun=[r.postRun]);r.postRun.length;)Q(r.postRun.shift());de(j)}function K(e){U.unshift(e)}function Q(e){j.unshift(e)}L.push({func:function(){Me()}});var X=0,Y=null;function Z(e){X++,r.monitorRunDependencies&&r.monitorRunDependencies(X)}function J(e){if(X--,r.monitorRunDependencies&&r.monitorRunDependencies(X),0==X&&Y){var n=Y;Y=null,n()}}function ee(e){r.onAbort&&r.onAbort(e),k(e+=""),I=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.";var n=new WebAssembly.RuntimeError(e);throw a(n),n}function ne(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}r.preloadedImages={},r.preloadedAudios={};var te="data:application/octet-stream;base64,";function ae(e){return ne(e,te)}var re="file://";function se(e){return ne(e,re)}var ue="tfjs-backend-wasm.wasm";function oe(e){try{if(e==ue&&g)return new Uint8Array(g);if(m)return m(e);throw"both async and sync fetching of the wasm failed"}catch(e){ee(e)}}function ie(){if(!g&&(o||i)){if("function"==typeof fetch&&!se(ue))return fetch(ue,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+ue+"'";return e.arrayBuffer()})).catch((function(){return oe(ue)}));if(p)return new Promise((function(e,n){p(ue,(function(n){e(new Uint8Array(n))}),n)}))}return Promise.resolve().then((function(){return oe(ue)}))}function ce(){var e={a:Ae};function n(e,n){var t=e.exports;r.asm=t,H((_=r.asm.i).buffer),z=r.asm.o,J()}function t(e){n(e.instance)}function s(n){return ie().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){k("failed to asynchronously prepare wasm: "+e),ee(e)}))}if(Z(),r.instantiateWasm)try{return r.instantiateWasm(e,n)}catch(e){return k("Module.instantiateWasm callback failed with error: "+e),!1}return(g||"function"!=typeof WebAssembly.instantiateStreaming||ae(ue)||se(ue)||"function"!=typeof fetch?s(t):fetch(ue,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){return k("wasm streaming compile failed: "+e),k("falling back to ArrayBuffer instantiation"),s(t)}))}))).catch(a),{}}function de(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?z.get(t)():z.get(t)(n.arg):t(void 0===n.arg?null:n.arg)}else n(r)}}function le(){ee()}function pe(e,n,t){N.copyWithin(e,n,n+t)}function me(){return N.length}function fe(e){try{return _.grow(e-S.byteLength+65535>>>16),H(_.buffer),1}catch(e){}}function he(e){var n=me(),t=2147483648;if(e>t)return!1;for(var a=1;a<=4;a*=2){var r=n*(1+.2/a);if(r=Math.min(r,e+100663296),fe(Math.min(t,W(Math.max(e,r),65536))))return!0}return!1}ae(ue)||(ue=y(ue));var be={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var t=be.buffers[e];0===n||10===n?((1===e?w:k)(C(t,0)),t.length=0):t.push(n)},varargs:void 0,get:function(){return be.varargs+=4,E[be.varargs-4>>2]},getStr:function(e){return O(e)},get64:function(e,n){return e}};function ye(e){return 0}function ge(e,n,t,a,r){}function _e(e,n,t,a){for(var r=0,s=0;s<t;s++){for(var u=E[n+8*s>>2],o=E[n+(8*s+4)>>2],i=0;i<o;i++)be.printChar(e,N[u+i]);r+=o}return E[a>>2]=r,0}function we(){return 6}function ke(e){return E[xe()>>2]=e,e}function Ie(e){switch(e){case 30:return 16384;case 85:return 131072;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:case 80:case 81:case 79:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator&&navigator.hardwareConcurrency||1}return ke(28),-1}var ve,Ae={a:le,d:pe,e:he,f:ye,c:ge,b:_e,g:we,h:Ie},Me=(ce(),r.___wasm_call_ctors=function(){return(Me=r.___wasm_call_ctors=r.asm.j).apply(null,arguments)}),xe=(r._init=function(){return(r._init=r.asm.k).apply(null,arguments)},r._register_tensor=function(){return(r._register_tensor=r.asm.l).apply(null,arguments)},r._dispose_data=function(){return(r._dispose_data=r.asm.m).apply(null,arguments)},r._dispose=function(){return(r._dispose=r.asm.n).apply(null,arguments)},r._Abs=function(){return(r._Abs=r.asm.p).apply(null,arguments)},r._Add=function(){return(r._Add=r.asm.q).apply(null,arguments)},r._AddN=function(){return(r._AddN=r.asm.r).apply(null,arguments)},r._All=function(){return(r._All=r.asm.s).apply(null,arguments)},r._Any=function(){return(r._Any=r.asm.t).apply(null,arguments)},r._ArgMax=function(){return(r._ArgMax=r.asm.u).apply(null,arguments)},r._AvgPool=function(){return(r._AvgPool=r.asm.v).apply(null,arguments)},r._BatchMatMul=function(){return(r._BatchMatMul=r.asm.w).apply(null,arguments)},r._Ceil=function(){return(r._Ceil=r.asm.x).apply(null,arguments)},r._ClipByValue=function(){return(r._ClipByValue=r.asm.y).apply(null,arguments)},r._Conv2D=function(){return(r._Conv2D=r.asm.z).apply(null,arguments)},r._Conv2DBackpropInput=function(){return(r._Conv2DBackpropInput=r.asm.A).apply(null,arguments)},r._Cos=function(){return(r._Cos=r.asm.B).apply(null,arguments)},r._CropAndResize=function(){return(r._CropAndResize=r.asm.C).apply(null,arguments)},r._Cumsum=function(){return(r._Cumsum=r.asm.D).apply(null,arguments)},r._DepthToSpace=function(){return(r._DepthToSpace=r.asm.E).apply(null,arguments)},r._DepthwiseConv2dNative=function(){return(r._DepthwiseConv2dNative=r.asm.F).apply(null,arguments)},r._Equal=function(){return(r._Equal=r.asm.G).apply(null,arguments)},r._Exp=function(){return(r._Exp=r.asm.H).apply(null,arguments)},r._FlipLeftRight=function(){return(r._FlipLeftRight=r.asm.I).apply(null,arguments)},r._Floor=function(){return(r._Floor=r.asm.J).apply(null,arguments)},r._FloorDiv=function(){return(r._FloorDiv=r.asm.K).apply(null,arguments)},r._FusedBatchNorm=function(){return(r._FusedBatchNorm=r.asm.L).apply(null,arguments)},r._FusedConv2D=function(){return(r._FusedConv2D=r.asm.M).apply(null,arguments)},r._FusedDepthwiseConv2D=function(){return(r._FusedDepthwiseConv2D=r.asm.N).apply(null,arguments)},r._Gather=function(){return(r._Gather=r.asm.O).apply(null,arguments)},r._GatherNd=function(){return(r._GatherNd=r.asm.P).apply(null,arguments)},r._Greater=function(){return(r._Greater=r.asm.Q).apply(null,arguments)},r._GreaterEqual=function(){return(r._GreaterEqual=r.asm.R).apply(null,arguments)},r._LeakyRelu=function(){return(r._LeakyRelu=r.asm.S).apply(null,arguments)},r._Less=function(){return(r._Less=r.asm.T).apply(null,arguments)},r._LessEqual=function(){return(r._LessEqual=r.asm.U).apply(null,arguments)},r._Log=function(){return(r._Log=r.asm.V).apply(null,arguments)},r._LogicalAnd=function(){return(r._LogicalAnd=r.asm.W).apply(null,arguments)},r._Max=function(){return(r._Max=r.asm.X).apply(null,arguments)},r._MaxPool=function(){return(r._MaxPool=r.asm.Y).apply(null,arguments)},r._Maximum=function(){return(r._Maximum=r.asm.Z).apply(null,arguments)},r._Mean=function(){return(r._Mean=r.asm._).apply(null,arguments)},r._Min=function(){return(r._Min=r.asm.$).apply(null,arguments)},r._Minimum=function(){return(r._Minimum=r.asm.aa).apply(null,arguments)},r._MirrorPad=function(){return(r._MirrorPad=r.asm.ba).apply(null,arguments)},r._Multiply=function(){return(r._Multiply=r.asm.ca).apply(null,arguments)},r._Neg=function(){return(r._Neg=r.asm.da).apply(null,arguments)},r._NonMaxSuppressionV3=function(){return(r._NonMaxSuppressionV3=r.asm.ea).apply(null,arguments)},r._NonMaxSuppressionV4=function(){return(r._NonMaxSuppressionV4=r.asm.fa).apply(null,arguments)},r._NonMaxSuppressionV5=function(){return(r._NonMaxSuppressionV5=r.asm.ga).apply(null,arguments)},r._NotEqual=function(){return(r._NotEqual=r.asm.ha).apply(null,arguments)},r._OneHot=function(){return(r._OneHot=r.asm.ia).apply(null,arguments)},r._PadV2=function(){return(r._PadV2=r.asm.ja).apply(null,arguments)},r._Pow=function(){return(r._Pow=r.asm.ka).apply(null,arguments)},r._Prelu=function(){return(r._Prelu=r.asm.la).apply(null,arguments)},r._Prod=function(){return(r._Prod=r.asm.ma).apply(null,arguments)},r._RealDiv=function(){return(r._RealDiv=r.asm.na).apply(null,arguments)},r._Relu=function(){return(r._Relu=r.asm.oa).apply(null,arguments)},r._Relu6=function(){return(r._Relu6=r.asm.pa).apply(null,arguments)},r._ResizeBilinear=function(){return(r._ResizeBilinear=r.asm.qa).apply(null,arguments)},r._Reverse=function(){return(r._Reverse=r.asm.ra).apply(null,arguments)},r._RotateWithOffset=function(){return(r._RotateWithOffset=r.asm.sa).apply(null,arguments)},r._Round=function(){return(r._Round=r.asm.ta).apply(null,arguments)},r._Rsqrt=function(){return(r._Rsqrt=r.asm.ua).apply(null,arguments)},r._ScatterNd=function(){return(r._ScatterNd=r.asm.va).apply(null,arguments)},r._SelectV2=function(){return(r._SelectV2=r.asm.wa).apply(null,arguments)},r._Sigmoid=function(){return(r._Sigmoid=r.asm.xa).apply(null,arguments)},r._Sin=function(){return(r._Sin=r.asm.ya).apply(null,arguments)},r._Softmax=function(){return(r._Softmax=r.asm.za).apply(null,arguments)},r._Sqrt=function(){return(r._Sqrt=r.asm.Aa).apply(null,arguments)},r._Square=function(){return(r._Square=r.asm.Ba).apply(null,arguments)},r._SquaredDifference=function(){return(r._SquaredDifference=r.asm.Ca).apply(null,arguments)},r._Step=function(){return(r._Step=r.asm.Da).apply(null,arguments)},r._StridedSlice=function(){return(r._StridedSlice=r.asm.Ea).apply(null,arguments)},r._Sub=function(){return(r._Sub=r.asm.Fa).apply(null,arguments)},r._Sum=function(){return(r._Sum=r.asm.Ga).apply(null,arguments)},r._Tan=function(){return(r._Tan=r.asm.Ha).apply(null,arguments)},r._Tanh=function(){return(r._Tanh=r.asm.Ia).apply(null,arguments)},r._Tile=function(){return(r._Tile=r.asm.Ja).apply(null,arguments)},r._TopK=function(){return(r._TopK=r.asm.Ka).apply(null,arguments)},r._Transform=function(){return(r._Transform=r.asm.La).apply(null,arguments)},r._Transpose=function(){return(r._Transpose=r.asm.Ma).apply(null,arguments)},r.__FusedMatMul=function(){return(r.__FusedMatMul=r.asm.Na).apply(null,arguments)},r._malloc=function(){return(r._malloc=r.asm.Oa).apply(null,arguments)},r._free=function(){return(r._free=r.asm.Pa).apply(null,arguments)},r.___errno_location=function(){return(xe=r.___errno_location=r.asm.Qa).apply(null,arguments)}),Se=r.stackSave=function(){return(Se=r.stackSave=r.asm.Ra).apply(null,arguments)},Fe=r.stackRestore=function(){return(Fe=r.stackRestore=r.asm.Sa).apply(null,arguments)},Ne=r.stackAlloc=function(){return(Ne=r.stackAlloc=r.asm.Ta).apply(null,arguments)};function Ee(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function Te(e){function t(){ve||(ve=!0,r.calledRun=!0,I||(V(),G(),n(r),r.onRuntimeInitialized&&r.onRuntimeInitialized(),$()))}X>0||(q(),X>0||(r.setStatus?(r.setStatus("Running..."),setTimeout((function(){setTimeout((function(){r.setStatus("")}),1),t()}),1)):t()))}if(r.cwrap=x,Y=function e(){ve||Te(),ve||(Y=e)},r.run=Te,r.preInit)for("function"==typeof r.preInit&&(r.preInit=[r.preInit]);r.preInit.length>0;)r.preInit.pop()();return Te(),e.ready});e.exports=a}));class Da extends Ge{constructor(e){super(),this.wasm=e,this.dataIdNextNumber=1,this.wasm.tfjs.init(),this.dataIdMap=new $e(this,Ke())}write(e,n,t){const a={id:this.dataIdNextNumber++};return this.move(a,e,n,t,1),a}numDataIds(){return this.dataIdMap.numDataIds()}async time(e){const t=n.now();e();return{kernelMs:n.now()-t}}move(e,t,a,r,s){const u=this.dataIdNextNumber++;if("string"===r){const n=t;return void this.dataIdMap.set(e,{id:u,stringBytes:n,shape:a,dtype:r,memoryOffset:null,refCount:s})}const o=n.sizeFromShape(a),i=o*n.bytesPerElement(r),c=this.wasm._malloc(i);this.dataIdMap.set(e,{id:u,memoryOffset:c,shape:a,dtype:r,refCount:s}),this.wasm.tfjs.registerTensor(u,o,c),null!=t&&this.wasm.HEAPU8.set(new Uint8Array(t.buffer,t.byteOffset,i),c)}async read(e){return this.readSync(e)}readSync(e){const{memoryOffset:t,dtype:a,shape:r,stringBytes:s}=this.dataIdMap.get(e);if("string"===a)return s;return function(e,n){switch(n){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error(`Unknown dtype ${n}`)}}(this.wasm.HEAPU8.slice(t,t+n.sizeFromShape(r)*n.bytesPerElement(a)).buffer,a)}disposeData(e,n=!1){if(this.dataIdMap.has(e)){const t=this.dataIdMap.get(e);if(t.refCount--,!n&&t.refCount>0)return!1;this.wasm._free(t.memoryOffset),this.wasm.tfjs.disposeData(t.id),this.dataIdMap.delete(e)}return!0}refCount(e){if(this.dataIdMap.has(e)){return this.dataIdMap.get(e).refCount}return 0}incRef(e){const n=this.dataIdMap.get(e);null!=n&&n.refCount++}floatPrecision(){return 32}getMemoryOffset(e){return this.dataIdMap.get(e).memoryOffset}dispose(){this.wasm.tfjs.dispose(),"PThread"in this.wasm&&this.wasm.PThread.terminateAllThreads(),this.wasm=null}memory(){return{unreliable:!1}}makeOutput(e,t,a){let r;if(null==a)r=this.write(null,e,t);else{const s=this.dataIdNextNumber++;r={id:s},this.dataIdMap.set(r,{id:s,memoryOffset:a,shape:e,dtype:t,refCount:1});const u=n.sizeFromShape(e);this.wasm.tfjs.registerTensor(s,u,a)}return{dataId:r,shape:e,dtype:t}}typedArrayFromHeap({shape:e,dtype:t,dataId:a}){const r=this.wasm.HEAPU8.buffer,{memoryOffset:s}=this.dataIdMap.get(a),u=n.sizeFromShape(e);switch(t){case"float32":return new Float32Array(r,s,u);case"int32":return new Int32Array(r,s,u);case"bool":return new Uint8Array(r,s,u);default:throw new Error(`Unknown dtype ${t}`)}}}function Ra(e,n,t){if(null!=Ha)return Ha;let a="tfjs-backend-wasm.wasm";return e&&n?a="tfjs-backend-wasm-threaded-simd.wasm":e&&(a="tfjs-backend-wasm-simd.wasm"),null!=Ua&&null!=Ua[a]?Ua[a]:t+a}async function Pa(){const[e,t]=await Promise.all([Ve().getAsync("WASM_HAS_SIMD_SUPPORT"),Ve().getAsync("WASM_HAS_MULTITHREAD_SUPPORT")]);return new Promise(((a,r)=>{const s={locateFile:(n,a)=>{if(n.endsWith(".worker.js")){const e=new Blob(['var Module={};function threadPrintErr(){var text=Array.prototype.slice.call(arguments).join(" ");console.error(text)}function threadAlert(){var text=Array.prototype.slice.call(arguments).join(" ");postMessage({cmd:"alert",text:text,threadId:Module["_pthread_self"]()})}var err=threadPrintErr;this.alert=threadAlert;Module["instantiateWasm"]=function(info,receiveInstance){var instance=new WebAssembly.Instance(Module["wasmModule"],info);Module["wasmModule"]=null;receiveInstance(instance);return instance.exports};function moduleLoaded(){}this.onmessage=function(e){try{if(e.data.cmd==="load"){Module["wasmModule"]=e.data.wasmModule;Module["wasmMemory"]=e.data.wasmMemory;Module["buffer"]=Module["wasmMemory"].buffer;Module["ENVIRONMENT_IS_PTHREAD"]=true;if(typeof e.data.urlOrBlob==="string"){importScripts(e.data.urlOrBlob)}else{var objectUrl=URL.createObjectURL(e.data.urlOrBlob);importScripts(objectUrl);URL.revokeObjectURL(objectUrl)}WasmBackendModuleThreadedSimd(Module).then(function(instance){Module=instance;moduleLoaded()})}else if(e.data.cmd==="objectTransfer"){Module["PThread"].receiveObjectTransfer(e.data)}else if(e.data.cmd==="run"){Module["__performance_now_clock_drift"]=performance.now()-e.data.time;Module["__emscripten_thread_init"](e.data.threadInfoStruct,0,0);var max=e.data.stackBase;var top=e.data.stackBase+e.data.stackSize;Module["establishStackSpace"](top,max);Module["_emscripten_tls_init"]();Module["PThread"].receiveObjectTransfer(e.data);Module["PThread"].setThreadStatus(Module["_pthread_self"](),1);try{var result=Module["invokeEntryPoint"](e.data.start_routine,e.data.arg);if(!Module["getNoExitRuntime"]())Module["PThread"].threadExit(result)}catch(ex){if(ex==="Canceled!"){Module["PThread"].threadCancel()}else if(ex!="unwind"){if(ex instanceof Module["ExitStatus"]){if(Module["getNoExitRuntime"]()){}else{Module["PThread"].threadExit(ex.status)}}else{Module["PThread"].threadExit(-2);throw ex}}}}else if(e.data.cmd==="cancel"){if(Module["_pthread_self"]()){Module["PThread"].threadCancel()}}else if(e.data.target==="setimmediate"){}else if(e.data.cmd==="processThreadQueue"){if(Module["_pthread_self"]()){Module["_emscripten_current_thread_process_queued_calls"]()}}else{err("worker.js received unknown command "+e.data.cmd);err(e.data)}}catch(ex){err("worker.js onmessage() captured an uncaught exception: "+ex);if(ex&&ex.stack)err(ex.stack);throw ex}};if(typeof process==="object"&&typeof process.versions==="object"&&typeof process.versions.node==="string"){self={location:{href:__filename}};var onmessage=this.onmessage;var nodeWorkerThreads=require("worker_threads");global.Worker=nodeWorkerThreads.Worker;var parentPort=nodeWorkerThreads.parentPort;parentPort.on("message",function(data){onmessage({data:data})});var nodeFS=require("fs");var nodeRead=function(filename){return nodeFS.readFileSync(filename,"utf8")};function globalEval(x){global.require=require;global.Module=Module;eval.call(null,x)}importScripts=function(f){globalEval(nodeRead(f))};postMessage=function(msg){parentPort.postMessage(msg)};if(typeof performance==="undefined"){performance={now:function(){return Date.now()}}}}'],{type:"application/javascript"});return URL.createObjectURL(e)}return n.endsWith(".wasm")?Ra(e,t,null!=za?za:a):a+n}};Ba&&(s.instantiateWasm=function(e){return(t,a)=>(n.fetch(e,{credentials:"same-origin"}).then((n=>{n.ok||t.env.a(`failed to load wasm binary file at '${e}'`),n.arrayBuffer().then((e=>{WebAssembly.instantiate(e,t).then((e=>{a(e.instance,e.module)}))}))})),{})}(Ra(e,t,null!=za?za:"")));let u,o=!1;s.onAbort=()=>{if(o)return;if(La)return;La=!0;r({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})},t&&e&&null==Ha?(s.mainScriptUrlOrBlob=new Blob(["var WasmBackendModuleThreadedSimd = "+Ca.toString()],{type:"text/javascript"}),u=Ca(s)):u=Oa(s),u.then((e=>{o=!0,La=!1;e.tfjs={init:e.cwrap("init",null,[]),registerTensor:e.cwrap("register_tensor",null,["number","number","number"]),disposeData:e.cwrap("dispose_data",null,["number"]),dispose:e.cwrap("dispose",null,[])},a({wasm:e})}))}))}const Wa=["tfjs-backend-wasm.wasm","tfjs-backend-wasm-simd.wasm","tfjs-backend-wasm-threaded-simd.wasm"];let Ha=null,za=null,Ua={},La=!1,Ba=!1;function ja(e,n=!1){if(Qe("setWasmPath has been deprecated in favor of setWasmPaths and will be removed in a future release."),La)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");Ha=e,Ba=n}function qa(e,n=!1){if(La)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPaths()` before you call `tf.setBackend()` or `tf.ready()`");if("string"==typeof e)za=e;else{Ua=e;const n=Wa.filter((e=>null==Ua[e]));if(n.length>0)throw new Error(`There were no entries found for the following binaries: ${n.join(",")}. Please either call setWasmPaths with a map providing a path for each binary, or with a string indicating the directory where all the binaries can be found.`)}Ba=n}const Va="3.7.0";Xe("wasm",(async()=>{const{wasm:e}=await Pa();return new Da(e)}),2);export{Da as BackendWasm,ja as setWasmPath,qa as setWasmPaths,Va as version_wasm};
//# sourceMappingURL=tf-backend-wasm.fesm.min.js.map
