/**
 * @license
 * Copyright 2021 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports,require("@tensorflow/tfjs-core"),require("path"),require("fs"),require("worker_threads"),require("perf_hooks"),require("os")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","path","fs","worker_threads","perf_hooks","os"],n):n(((e=e||self).tf=e.tf||{},e.tf.wasm=e.tf.wasm||{}),e.tf,e.path,e.fs,e.worker_threads,e.perf_hooks,e.os)}(this,(function(e,n,a,t,r,u,s){"use strict";var i,o,d;a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a,t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r,u=u&&Object.prototype.hasOwnProperty.call(u,"default")?u.default:u,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s,function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(i||(i={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu",e[e.leakyrelu=4]="leakyrelu",e[e.sigmoid=5]="sigmoid"}(o||(o={}));var l={kernelName:n._FusedMatMul,backendName:"wasm",setupFunc:function(e){d=e.wasm.cwrap(n._FusedMatMul,null,["number","array","number","number","array","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,t=e.attrs,r=n.a,u=n.b,s=n.bias,i=n.preluActivationWeights;if("float32"!==r.dtype||"float32"!==u.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");var l=t.transposeA,c=t.transposeB,p=t.activation,f=t.leakyreluAlpha,m=a.dataIdMap.get(r.dataId).id,h=a.dataIdMap.get(u.dataId).id,b=0;if(null!=s){var y=a.dataIdMap.get(s.dataId);if(1!==y.shape.length)throw new Error("_FusedMatMul only supports rank-1 bias but got rank "+y.shape.length+".");b=y.id}var v=null==i?0:a.dataIdMap.get(i.dataId).id,_=o[p];if(null==_)throw new Error(p+" activation not yet supported for FusedConv2D in the wasm backend.");var g=l?r.shape[2]:r.shape[1],w=c?u.shape[1]:u.shape[2],k=r.shape[0],I=a.makeOutput([k,g,w],r.dtype),M=a.dataIdMap.get(I.dataId).id,A=new Uint8Array(new Int32Array(r.shape).buffer),x=new Uint8Array(new Int32Array(u.shape).buffer);return d(m,A,r.shape.length,h,x,u.shape.length,l,c,_,b,v,f||0,M),I}};function c(e){var a;return{kernelName:e,backendName:"wasm",setupFunc:function(n){a=n.wasm.cwrap(e,null,["number","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs.x,u=t.dataIdMap.get(r.dataId).id,s=t.makeOutput(r.shape,r.dtype),i=t.dataIdMap.get(s.dataId).id;return 0===n.util.sizeFromShape(s.shape)||a(u,i),s}}}var p=c(n.Abs);function f(e,a,t){var r;return{kernelName:e,backendName:"wasm",setupFunc:function(n){r=n.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(u){var s=u.backend,o=u.inputs,d=o.a,l=o.b,c=s.dataIdMap.get(d.dataId).id,p=s.dataIdMap.get(l.dataId).id,f=null!=t?t:d.dtype,m=n.backend_util.assertAndGetBroadcastShape(d.shape,l.shape),h=s.makeOutput(m,f);if(0===n.util.sizeFromShape(m))return h;var b=new Uint8Array(new Int32Array(d.shape).buffer),y=new Uint8Array(new Int32Array(l.shape).buffer),v=s.dataIdMap.get(h.dataId).id,_=function(){return r(c,b,d.shape.length,p,y,l.shape.length,i[d.dtype],v)};if(a&&"float32"===d.dtype)return _(),h;var g=n.backend_util.getBroadcastDims(d.shape,m),w=n.backend_util.getBroadcastDims(l.shape,m),k=g.every((function(e,n){return e===n})),I=w.every((function(e,n){return e===n}));if(k&&I)return _(),h;throw new Error("Broadcasting along outer dims is not yet supported for "+d.dtype+" "+e+".")}}}var m,h=f(n.Add,!0);var b={kernelName:n.AddN,backendName:"wasm",setupFunc:function(e){m=e.wasm.cwrap(n.AddN,null,["array","number","number","number"])},kernelFunc:function(e){var a=e.inputs,t=e.backend,r=t.makeOutput(a[0].shape,a[0].dtype);if(0===n.util.sizeFromShape(r.shape))return r;var u=a.map((function(e){return t.dataIdMap.get(e.dataId).id})),s=new Uint8Array(new Int32Array(u).buffer),o=t.dataIdMap.get(r.dataId).id;return m(s,u.length,i[r.dtype],o),r}};function y(e){var n=e.inputs.x,a=e.backend,t=a.makeOutput(n.shape,n.dtype),r=a.typedArrayFromHeap(n);return a.typedArrayFromHeap(t).set(r),t}var v,_={kernelName:n.Identity,backendName:"wasm",kernelFunc:y};function g(e){for(var n=e.inputs,a=e.backend,t=e.attrs,r=function(e,n){for(var a=[],t=[],r=0;r<e.length;++r)1!==e[r]&&a.push(e[r]),1!==e[n[r]]&&t.push(n[r]);for(r=0;r<t.length;++r){for(var u=-1,s=0;s<t.length;++s)t[s]>=r&&(-1===u||t[u]>t[s])&&(u=s);t[u]=r}return[a,t]}(n.x.shape,t.perm),u=r[0],s=r[1],o=!0,d=0;d<s.length;d++)s[d]!==d&&(o=!1);var l=function(e,n){for(var a=new Array(e.length),t=0;t<a.length;t++)a[t]=e[n[t]];return a}(n.x.shape,t.perm),c={dataId:n.x.dataId,shape:u,dtype:n.x.dtype};if(o){var p=y({inputs:n,backend:a});return p.shape=l,p}var f=a.makeOutput(l,c.dtype),m=a.dataIdMap.get(c.dataId).id,h=a.dataIdMap.get(f.dataId).id,b=new Uint8Array(new Int32Array(s).buffer),_=new Uint8Array(new Int32Array(c.shape).buffer);return v(m,_,c.shape.length,i[c.dtype],h,b,s.length),f}var w,k={kernelName:n.Transpose,backendName:"wasm",kernelFunc:g,setupFunc:function(e){v=e.wasm.cwrap(n.Transpose,null,["number","array","number","number","number","array","number"])}};function I(e,a,t){var r=e.shape,u=e.shape.length,s=n.util.parseAxisParam(a,r),i=s,o=n.backend_util.getAxesPermutation(i,u),d=null,l=!1;if(null!=o){for(var c=new Array(u),p=0;p<c.length;p++)c[p]=r[o[p]];i=n.backend_util.getInnerMostAxes(i.length,u),d=g({inputs:{x:e},attrs:{perm:o},backend:t});var f=t.dataIdMap.get(e.dataId).id;t.dataIdMap.get(d.dataId).id!==f&&(l=!0)}return{transposed:d,originalAxes:s,axes:i,inputWasTransposed:l}}var M,A={kernelName:n.All,backendName:"wasm",setupFunc:function(e){w=e.wasm.cwrap(n.All,null,["number, number, number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=r.axis,s=r.keepDims,i=t.x,o=a.dataIdMap.get(i.dataId).id,d=i,l=I(i,u,a),c=l.transposed,p=l.axes,f=l.originalAxes,m=l.inputWasTransposed;m&&(d=c,o=a.dataIdMap.get(c.dataId).id);var h=d.shape.length;n.backend_util.assertAxesAreInnerMostDims("all",p,h);var b=n.backend_util.computeOutAndReduceShapes(d.shape,p),y=b[0],v=b[1],_=n.util.sizeFromShape(v),g=a.makeOutput(y,i.dtype);if(0!==n.util.sizeFromShape(d.shape)){var k=a.dataIdMap.get(g.dataId).id;w(o,_,k)}if(m&&a.disposeData(c.dataId),s){var M=n.backend_util.expandShapeToKeepDim(g.shape,f);g.shape=M}return g}};var x,S={kernelName:n.Any,backendName:"wasm",setupFunc:function(e){M=e.wasm.cwrap(n.Any,null,["number, number, number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=r.axis,s=r.keepDims,i=t.x,o=a.dataIdMap.get(i.dataId).id,d=i,l=I(i,u,a),c=l.transposed,p=l.axes,f=l.originalAxes,m=l.inputWasTransposed;m&&(d=c,o=a.dataIdMap.get(c.dataId).id);var h=d.shape.length;n.backend_util.assertAxesAreInnerMostDims("any",p,h);var b=n.backend_util.computeOutAndReduceShapes(d.shape,p),y=b[0],v=b[1],_=n.util.sizeFromShape(v),g=a.makeOutput(y,i.dtype);if(0!==n.util.sizeFromShape(d.shape)){var w=a.dataIdMap.get(g.dataId).id;M(o,_,w)}if(m&&a.disposeData(c.dataId),s){var k=n.backend_util.expandShapeToKeepDim(g.shape,f);g.shape=k}return g}};var F,N={kernelName:n.ArgMax,backendName:"wasm",kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs.axis,u=t.x,s=a.dataIdMap.get(u.dataId).id,o=s,d=u,l=I(u,r,a),c=l.transposed,p=l.axes,f=l.inputWasTransposed;if(f){var m=a.dataIdMap.get(c.dataId).id;m!==s&&(d=c,o=m)}var h=d.shape.slice(0,-1),b=a.makeOutput(h,"int32"),y=a.dataIdMap.get(b.dataId).id,v=n.util.sizeFromShape(b.shape),_=d.shape[p[0]];return x(o,i[d.dtype],v,_,y),f&&a.disposeData(c.dataId),b},setupFunc:function(e){x=e.wasm.cwrap(n.ArgMax,null,["number","number","number","number","number"])}};var E={kernelName:n.AvgPool,backendName:"wasm",setupFunc:function(e){F=e.wasm.cwrap(n.AvgPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var a=e.inputs,t=e.attrs,r=e.backend,u=a.x,s=r.dataIdMap.get(u.dataId).id,i=t.filterSize,o=t.strides,d=t.pad,l=t.dimRoundingMode,c=n.backend_util.computePool2DInfo(u.shape,i,o,1,d,l),p=c.filterHeight,f=c.filterWidth,m=c.padInfo.top,h=c.padInfo.right,b=c.padInfo.bottom,y=c.padInfo.left,v=c.strideHeight,_=c.strideWidth,g=c.inChannels;if("channelsLast"!==c.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+c.dataFormat+"'. Please use 'channelsLast'.");if(1!==c.dilationWidth||1!==c.dilationHeight)throw new Error("was backend only supports average pooling with dilation = [1, 1], got ["+c.dilationHeight+", "+c.dilationWidth+"].");var w=r.makeOutput(c.outShape,"float32"),k=r.dataIdMap.get(w.dataId).id;return F(s,u.shape[0],u.shape[1],u.shape[2],p,f,m,h,b,y,v,_,g,k),w}};function T(e){var a=e.inputs,t=e.attrs,r=a.x,u=t.shape,s=n.util.sizeFromShape(r.shape),i=n.util.inferFromImplicitShape(u,s);return n.util.assert(s===n.util.sizeFromShape(i),(function(){return"new shape: "+i+", old shape: "+r.shape+". New shape and old shape must have the same number of elements."})),e.backend.incRef(r.dataId),{dataId:r.dataId,shape:i,dtype:r.dtype}}var C,O={kernelName:n.Reshape,backendName:"wasm",kernelFunc:T};var D={kernelName:n.BatchMatMul,backendName:"wasm",setupFunc:function(e){C=e.wasm.cwrap(n.BatchMatMul,null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){var a=e.inputs,t=e.backend,r=e.attrs,u=a.a,s=a.b,i=r.transposeA,o=r.transposeB;if("float32"!==u.dtype||"float32"!==s.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");var d=u.shape.length,l=s.shape.length,c=i?u.shape[d-2]:u.shape[d-1],p=o?s.shape[l-1]:s.shape[l-2],f=i?u.shape[d-1]:u.shape[d-2],m=o?s.shape[l-2]:s.shape[l-1],h=u.shape.slice(0,-2),b=s.shape.slice(0,-2),y=n.util.sizeFromShape(h),v=n.util.sizeFromShape(b),_=y===v||1===y||1===v;n.util.assert(d>=2&&l>=2&&_,(function(){return"Error in matMul: the input batch dimensions must either be the same or at least one input batch dimension must be 1. Got input batch dimensions of ("+h+") and ("+b+")."}));var g=(y>v?u.shape.slice(0,-2):s.shape.slice(0,-2)).concat([f,m]);n.util.assert(c===p,(function(){return"Error in matMul: inner shapes ("+c+") and ("+p+") of Tensors with shapes "+u.shape+" and "+s.shape+" and transposeA="+i+" and transposeB="+o+" must match."}));var w=o?[v,m,p]:[v,p,m],k=T({inputs:{x:u},backend:t,attrs:{shape:i?[y,c,f]:[y,f,c]}}),I=T({inputs:{x:s},backend:t,attrs:{shape:w}}),M=t.dataIdMap.get(k.dataId).id,A=t.dataIdMap.get(I.dataId).id,x=i?k.shape[2]:k.shape[1],S=o?I.shape[1]:I.shape[2],F=Math.max(y,v),N=t.makeOutput([F,x,S],k.dtype),E=t.dataIdMap.get(N.dataId).id,O=new Uint8Array(new Int32Array(k.shape).buffer),D=new Uint8Array(new Int32Array(I.shape).buffer);return C(M,O,k.shape.length,A,D,I.shape.length,i,o,E),t.disposeData(k.dataId),t.disposeData(I.dataId),N.shape=g,N}};function P(e){var n=e.inputs.x,a=e.attrs.dtype,t=e.backend,r=t.makeOutput(n.shape,a),u=t.typedArrayFromHeap(n);return t.typedArrayFromHeap(r).set(u),r}var R,W={kernelName:n.Cast,backendName:"wasm",kernelFunc:P},H=c(n.Ceil);var z={kernelName:n.ClipByValue,backendName:"wasm",setupFunc:function(e){R=e.wasm.cwrap(n.ClipByValue,null,["number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,t=e.attrs,r=n.x,u=t.clipValueMin,s=t.clipValueMax,i=a.dataIdMap.get(r.dataId).id,o=a.makeOutput(r.shape,r.dtype),d=a.dataIdMap.get(o.dataId).id;return R(i,u,s,d),o}};function L(e,a,t,r,u){const s=n.slice_util.isSliceContinous(r,a,t),i=n.util.sizeFromShape(t),o=n.util.computeStrides(r);if(s){const t=n.slice_util.computeFlatOffset(a,o);return"string"===u?e.slice(t,t+i):e.subarray(t,t+i)}const d="string"===u?n.backend_util.fromUint8ToStringArray(e):e,l=n.buffer(r,u,d),c=n.buffer(t,u);for(let e=0;e<c.size;++e){const n=c.indexToLoc(e),t=n.map(((e,n)=>e+a[n]));c.set(l.get(...t),...n)}return"string"===u?n.backend_util.fromStringArrayToUint8(c.values):c.values}function U(e){var a=e.inputs,t=e.backend,r=n.util.parseAxisParam(e.attrs.axis,a[0].shape)[0],u=n.backend_util.computeOutShape(a.map((function(e){return e.shape})),r),s=a.filter((function(e){return n.util.sizeFromShape(e.shape)>0}));if(1===s.length)return y({inputs:{x:s[0]},backend:t});var i=t.makeOutput(u,a[0].dtype);if(0===n.util.sizeFromShape(u))return i;var o=s.map((function(e){return e.shape}));if(n.backend_util.assertParamsConsistent(o,r),"string"===s[0].dtype){var d=s.map((function(e){var a=n.util.sizeFromShape(e.shape.slice(r));return T({inputs:{x:e},backend:t,attrs:{shape:[-1,a]}})})),l=d.map((function(e){return{vals:t.readSync(e.dataId),shape:e.shape}}));u=n.backend_util.computeOutShape(d.map((function(e){return e.shape})),1);var c=1===d[0].shape[0],p=function(e,a,t,r){const u=n.util.getArrayFromDType(t,n.util.sizeFromShape(a));if(r&&"string"!==t){let a=0;e.forEach((e=>{const t=n.util.sizeFromShape(e.shape);u.set(e.vals,a),a+=t}))}else{let r=0;e.forEach((e=>{const s="string"===t?n.backend_util.fromUint8ToStringArray(e.vals):e.vals;let i=0;for(let n=0;n<e.shape[0];++n){const t=n*a[1]+r;for(let n=0;n<e.shape[1];++n)u[t+n]=s[i++]}r+=e.shape[1]}))}return u}(l,u,a[0].dtype,c),f=n.backend_util.computeOutShape(s.map((function(e){return e.shape})),r);return i.shape=f,t.dataIdMap.get(i.dataId).stringBytes=n.backend_util.fromStringArrayToUint8(p),d.forEach((function(e){return t.disposeData(e.dataId)})),i}for(var m=n.util.sizeFromShape(s[0].shape.slice(0,r)),h=0,b=s.map((function(e){var a=n.util.sizeFromShape(e.shape.slice(r));return h+=a,a})),v=s.map((function(e){return t.typedArrayFromHeap(e)})),_=t.typedArrayFromHeap(i),g=0;g<m;g++)for(var w=g*h,k=0;k<v.length;k++){var I=b[k],M=g*I,A=v[k].subarray(M,M+I);_.set(A,w),w+=I}return i}var B,j={kernelName:n.Concat,backendName:"wasm",kernelFunc:U};var q,V={kernelName:n.Conv2D,backendName:"wasm",setupFunc:function(e){B=e.wasm.cwrap(n.Conv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var a=e.inputs,t=e.attrs,r=e.backend,u=a.x,s=a.filter,i=r.dataIdMap.get(u.dataId).id,o=r.dataIdMap.get(s.dataId).id,d=t.strides,l=t.dilations,c=t.pad,p=t.dimRoundingMode,f=t.dataFormat,m=n.backend_util.convertConv2DDataFormat(f),h=n.backend_util.computeConv2DInfo(u.shape,s.shape,d,l,c,p,!1,m),b=h.filterHeight,y=h.filterWidth,v=h.padInfo.top,_=h.padInfo.right,g=h.padInfo.bottom,w=h.padInfo.left,k=h.dilationHeight,I=h.dilationWidth,M=h.strideHeight,A=h.strideWidth,x=h.inChannels,S=h.outChannels,F="SAME"===h.padInfo.type?1:0;if("channelsLast"!==h.dataFormat)throw new Error("wasm backend Conv2D does not support dataFormat:'"+h.dataFormat+"'. Please use 'channelsLast'.");var N=r.makeOutput(h.outShape,"float32"),E=r.dataIdMap.get(N.dataId).id;return B(i,u.shape[0],u.shape[1],u.shape[2],o,b,y,v,_,g,w,F,k,I,M,A,x,S,E),N}};var G,K,Q={kernelName:n.Conv2DBackpropInput,backendName:"wasm",setupFunc:function(e){q=e.wasm.cwrap(n.Conv2DBackpropInput,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=t.dy,s=t.filter,i=r.strides,o=r.pad,d=r.dataFormat,l=r.dimRoundingMode,c=r.inputShape,p=n.backend_util.convertConv2DDataFormat(d),f=n.backend_util.computeConv2DInfo(c,s.shape,i,1,o,l,!1,p),m=f.batchSize,h=f.filterHeight,b=f.filterWidth,y=f.inChannels,v=f.inHeight,_=f.inWidth,g=f.outChannels,w=f.outHeight,k=f.outWidth,I=f.strideHeight,M=f.strideWidth,A=h-1-f.padInfo.top,x=b-1-f.padInfo.left,S="channelsLast"===f.dataFormat,F=n.util.computeStrides(f.inShape),N=n.util.computeStrides(u.shape),E=n.util.computeStrides(s.shape),T=E[0],C=E[1],O=E[2],D=F[0],P=S?F[1]:F[2],R=S?F[2]:1,W=S?1:F[1],H=N[0],z=S?N[1]:N[2],L=S?N[2]:1,U=S?1:N[1],B=a.makeOutput(f.inShape,"float32"),j=a.dataIdMap.get(B.dataId).id,V=a.dataIdMap.get(u.dataId).id,G=a.dataIdMap.get(s.dataId).id;return q(V,G,m,h,b,v,_,y,w,k,g,I,M,A,x,T,C,O,D,P,R,W,H,z,L,U,j),B}},X=c(n.Cos);!function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(G||(G={}));var Z,Y={kernelName:n.CropAndResize,backendName:"wasm",setupFunc:function(e){K=e.wasm.cwrap(n.CropAndResize,null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){var n,a=e.backend,t=e.inputs,r=e.attrs,u=r.method,s=r.extrapolationValue,i=r.cropSize,o=t.image,d=t.boxes,l=t.boxInd,c=d.shape[0],p=i,f=p[0],m=p[1],h=[c,f,m,o.shape[3]],b=a.dataIdMap.get(o.dataId);"float32"!==o.dtype&&(n=P({backend:a,inputs:{x:o},attrs:{dtype:"float32"}}),b=a.dataIdMap.get(n.dataId));var y=b.id,v=a.dataIdMap.get(d.dataId).id,_=a.dataIdMap.get(l.dataId).id,g=a.makeOutput(h,"float32"),w=a.dataIdMap.get(g.dataId).id,k=new Uint8Array(new Int32Array(o.shape).buffer);return K(y,v,_,c,k,f,m,G[u],s,w),null!=n&&a.disposeData(n.dataId),g}};var J,$={kernelName:n.Cumsum,backendName:"wasm",setupFunc:function(e){Z=e.wasm.cwrap(n.Cumsum,null,["number","number","number","number","number","number"])},kernelFunc:function(e){var a=e.inputs,t=e.backend,r=e.attrs,u=a.x,s=r.axis,o=r.exclusive,d=r.reverse,l=u.shape.length;n.util.assert("float32"===u.dtype||"int32"===u.dtype,(function(){return"cumsum does not support "+u.dtype+" tensors in the WASM backend"}));var c=n.backend_util.getAxesPermutation([s],l),p=u;null!==c&&(p=g({inputs:{x:u},attrs:{perm:c},backend:t}));var f=n.backend_util.getInnerMostAxes(1,l)[0];n.backend_util.assertAxesAreInnerMostDims("cumsum",[f],l);var m=t.makeOutput(p.shape,p.dtype),h=p.shape[f],b=t.dataIdMap.get(p.dataId).id,y=t.dataIdMap.get(m.dataId).id;Z(b,o?1:0,d?1:0,h,y,i[u.dtype]);var v=m;return null!==c&&(v=g({inputs:{x:m},attrs:{perm:n.backend_util.getUndoAxesPermutation(c)},backend:t}),t.disposeData(p.dataId),t.disposeData(m.dataId)),v}};var ee,ne={kernelName:n.DepthToSpace,backendName:"wasm",setupFunc:function(e){J=e.wasm.cwrap(n.DepthToSpace,null,["number","number","number","array","number","array","array","number","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=t.x,s=r.blockSize,i=r.dataFormat;n.util.assert(s>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+s}));var o=u.shape[0],d="NHWC"===i?u.shape[1]:u.shape[2],l="NHWC"===i?u.shape[2]:u.shape[3],c="NHWC"===i?u.shape[3]:u.shape[1],p=d*s,f=l*s,m=c/(s*s),h="NHWC"===i?[o,p,f,m]:[o,m,p,f],b=a.makeOutput(h,"float32"),y=a.dataIdMap.get(u.dataId).id,v=new Uint8Array(new Int32Array(n.util.computeStrides(u.shape)).buffer),_=new Uint8Array(new Int32Array(h).buffer),g=new Uint8Array(new Int32Array(n.util.computeStrides(h)).buffer),w=a.dataIdMap.get(b.dataId).id;return J(y,s,"NHWC"===i?1:0,v,u.shape.length-1,_,g,h.length,w),b}};var ae={kernelName:n.DepthwiseConv2dNative,backendName:"wasm",setupFunc:function(e){ee=e.wasm.cwrap(n.DepthwiseConv2dNative,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var a=e.inputs,t=e.attrs,r=e.backend,u=a.x,s=a.filter,i=r.dataIdMap.get(u.dataId).id,o=r.dataIdMap.get(s.dataId).id,d=t.strides,l=t.dilations,c=t.pad,p=t.dimRoundingMode,f=null==l?[1,1]:l,m=n.backend_util.computeConv2DInfo(u.shape,s.shape,d,f,c,p,!0),h=m.filterHeight,b=m.filterWidth,y=m.padInfo.top,v=m.padInfo.right,_=m.padInfo.bottom,g=m.padInfo.left,w=m.dilationHeight,k=m.dilationWidth,I=m.strideHeight,M=m.strideWidth,A=m.inChannels,x=m.outChannels,S="SAME"===m.padInfo.type?1:0;if("channelsLast"!==m.dataFormat)throw new Error("wasm backend DepthwiseConv2dNative does not support dataFormat:'"+m.dataFormat+"'. Please use 'channelsLast'.");var F=r.makeOutput(m.outShape,"float32"),N=r.dataIdMap.get(F.dataId).id;return ee(i,u.shape[0],u.shape[1],u.shape[2],o,h,b,y,v,_,g,S,w,k,I,M,A,x,N),F}},te=f(n.Equal,!1,"bool"),re=c(n.Exp);function ue(e){var a=e.inputs,t=e.attrs,r=e.backend,u=a.input,s=t.dim,i=u.shape.length,o=u.shape.slice(),d=s;return s<0&&(n.util.assert(-(i+1)<=s,(function(){return"Axis must be in the interval ["+-(i+1)+", "+i+"]"})),d=i+s+1),o.splice(d,0,1),T({inputs:{x:u},backend:r,attrs:{shape:o}})}var se={kernelName:n.ExpandDims,backendName:"wasm",kernelFunc:ue};var ie,oe={kernelName:n.Fill,backendName:"wasm",kernelFunc:function(e){var n=e.attrs,a=n.shape,t=n.value,r=n.dtype,u=e.backend,s=u.makeOutput(a,r);return u.typedArrayFromHeap(s).fill(t),s}};var de,le={kernelName:n.FlipLeftRight,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,a=e.backend,t=n.image,r=a.makeOutput(t.shape,t.dtype),u=a.dataIdMap.get(t.dataId).id,s=a.dataIdMap.get(r.dataId).id,i=t.shape,o=i[0],d=i[1],l=i[2],c=i[3];return ie(u,o,d,l,c,s),r},setupFunc:function(e){ie=e.wasm.cwrap(n.FlipLeftRight,null,["number","number","number","number","number","number"])}},ce=c(n.Floor),pe=f(n.FloorDiv,!1);var fe,me={kernelName:n.FusedBatchNorm,backendName:"wasm",setupFunc:function(e){de=e.wasm.cwrap(n.FusedBatchNorm,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs.varianceEpsilon,u=t.x,s=t.mean,i=t.variance,o=t.offset,d=t.scale,l=a.dataIdMap.get(u.dataId).id,c=a.dataIdMap.get(s.dataId).id,p=a.dataIdMap.get(i.dataId).id,f=null!=o?a.dataIdMap.get(o.dataId).id:0,m=null!=d?a.dataIdMap.get(d.dataId).id:0,h=a.makeOutput(u.shape,u.dtype);if(0===n.util.sizeFromShape(u.shape))return h;var b=a.dataIdMap.get(h.dataId).id;return de(l,c,p,f,m,r,b),h}};var he,be={kernelName:n.FusedConv2D,backendName:"wasm",setupFunc:function(e){fe=e.wasm.cwrap(n.FusedConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var a=e.inputs,t=e.attrs,r=e.backend,u=a.x,s=a.filter,i=a.bias,d=a.preluActivationWeights,l=t.strides,c=t.pad,p=t.dilations,f=t.dataFormat,m=t.dimRoundingMode,h=t.activation,b=t.leakyreluAlpha,y=n.backend_util.computeConv2DInfo(u.shape,s.shape,l,p,c,m),v=o[h];if(null==v)throw new Error(h+" activation not yet supported for FusedConv2D in the wasm backend.");var _=r.dataIdMap.get(u.dataId).id,g=r.dataIdMap.get(s.dataId).id,w=y.outChannels,k=0;if(null!=i){var I=r.dataIdMap.get(i.dataId);if(1!==I.shape.length)throw new Error("FusedConv2D only supports rank-1 bias but got rank "+I.shape.length+".");if(I.shape[0]!==w)throw new Error("FusedConv2D bias shape ("+I.shape+") does not match the number of output channels ("+w+")");k=I.id}var M=y.filterHeight,A=y.filterWidth,x=y.padInfo.top,S=y.padInfo.right,F=y.padInfo.bottom,N=y.padInfo.left,E=y.dilationHeight,T=y.dilationWidth,C=y.strideHeight,O=y.strideWidth,D=y.inChannels,P="SAME"===y.padInfo.type?1:0,R=y.batchSize,W=y.inHeight,H=y.inWidth;if("NHWC"!==f)throw new Error("wasm backend FusedConv2D does not support dataFormat:'"+f+"'. Please use 'NHWC'.");var z=r.makeOutput(y.outShape,"float32"),L=r.dataIdMap.get(z.dataId).id,U=null==d?0:r.dataIdMap.get(d.dataId).id;return fe(_,R,W,H,g,M,A,k,x,S,F,N,P,E,T,C,O,D,w,v,U,b||0,L),z}};var ye,ve={kernelName:n.FusedDepthwiseConv2D,backendName:"wasm",setupFunc:function(e){he=e.wasm.cwrap(n.FusedDepthwiseConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var a=e.inputs,t=e.attrs,r=e.backend,u=a.x,s=a.filter,i=a.bias,d=a.preluActivationWeights,l=t.strides,c=t.pad,p=t.dilations,f=t.dataFormat,m=t.dimRoundingMode,h=t.activation,b=t.leakyreluAlpha,y=n.backend_util.computeConv2DInfo(u.shape,s.shape,l,p,c,m,!0),v=o[h];if(null==v)throw new Error(h+" activation not yet supported for FusedDepthwiseConv2D in the wasm backend.");var _=r.dataIdMap.get(u.dataId).id,g=r.dataIdMap.get(s.dataId).id,w=y.outChannels,k=0;if(null!=i){var I=r.dataIdMap.get(i.dataId);if(1!==I.shape.length)throw new Error("FusedDepthwiseConv2D only supports rank-1 bias but got rank "+I.shape.length+".");if(I.shape[0]!==w)throw new Error("FusedDepthwiseConv2D bias shape ("+I.shape+") does not match the number of output channels ("+w+")");k=I.id}var M=y.filterHeight,A=y.filterWidth,x=y.padInfo.top,S=y.padInfo.right,F=y.padInfo.bottom,N=y.padInfo.left,E=y.dilationHeight,T=y.dilationWidth,C=y.strideHeight,O=y.strideWidth,D=y.inChannels,P="SAME"===y.padInfo.type?1:0,R=y.batchSize,W=y.inHeight,H=y.inWidth;if("NHWC"!==f)throw new Error("wasm backend FusedDepthwiseConv2D does not support dataFormat:'"+f+"'. Please use 'NHWC'.");var z=r.makeOutput(y.outShape,"float32"),L=r.dataIdMap.get(z.dataId).id,U=null==d?0:r.dataIdMap.get(d.dataId).id;return he(_,R,W,H,g,M,A,k,x,S,F,N,P,E,T,C,O,D,w,v,U,b||0,L),z}};var _e,ge={kernelName:n.GatherNd,backendName:"wasm",setupFunc:function(e){ye=e.wasm.cwrap(n.GatherNd,null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=t.params,u=t.indices,s=n.gather_util.prepareAndValidate(r,u),o=s[0],d=s[1],l=s[2],c=s[3],p=a.makeOutput(o,r.dtype);if(0===d)return p;var f=u.shape,m=f[f.length-1],h=a.dataIdMap.get(r.dataId).id,b=a.dataIdMap.get(u.dataId).id,y=new Uint8Array(new Int32Array(c).buffer),v=a.dataIdMap.get(p.dataId).id;return ye(h,i[r.dtype],b,d,m,l,y,v),p}};var we,ke={kernelName:n.GatherV2,backendName:"wasm",setupFunc:function(e){_e=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=t.x,s=t.indices,o=r.axis,d=r.batchDims,l=n.util.parseAxisParam(o,u.shape)[0],c=n.backend_util.segment_util.collectGatherOpShapeInfo(u,s,l,d),p=T({inputs:{x:u},attrs:{shape:[c.batchSize,c.outerSize,c.dimSize,c.sliceSize]},backend:a}),f=n.util.sizeFromShape(s.shape),m=T({inputs:{x:s},attrs:{shape:[c.batchSize,f/c.batchSize]},backend:a}),h=[c.batchSize,c.outerSize,f/c.batchSize,c.sliceSize],b=a.makeOutput(h,u.dtype);if(0===n.util.sizeFromShape(u.shape))return b;var y=p.shape.length-1,v=a.dataIdMap.get(p.dataId).id,_=a.dataIdMap.get(m.dataId).id,g=a.dataIdMap.get(b.dataId).id,w=new Uint8Array(new Int32Array(n.util.computeStrides(p.shape)).buffer),k=new Uint8Array(new Int32Array(n.util.computeStrides(h)).buffer);return _e(v,i[u.dtype],w,y,_,c.batchSize,k,g),a.disposeData(p.dataId),a.disposeData(m.dataId),b.shape=c.outputShape,b}},Ie=f(n.Greater,!1,"bool"),Me=f(n.GreaterEqual,!1,"bool");var Ae,xe={kernelName:n.LeakyRelu,backendName:"wasm",setupFunc:function(e){we=e.wasm.cwrap(n.LeakyRelu,null,["number","number","number"])},kernelFunc:function(e){var a=e.inputs.x,t=e.attrs.alpha,r=e.backend,u=r.dataIdMap.get(a.dataId).id,s=r.makeOutput(a.shape,a.dtype);if(0!==n.util.sizeFromShape(a.shape)){var i=r.dataIdMap.get(s.dataId).id;we(u,t,i)}return s}},Se=f(n.Less,!1,"bool"),Fe=f(n.LessEqual,!1,"bool"),Ne=c(n.Log),Ee=f(n.LogicalAnd,!1,"bool");var Te,Ce={kernelName:n.Max,backendName:"wasm",setupFunc:function(e){Ae=e.wasm.cwrap(n.Max,null,["number, number, number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=r.reductionIndices,s=r.keepDims,i=t.x,o=a.dataIdMap.get(i.dataId).id,d=i,l=I(i,u,a),c=l.transposed,p=l.axes,f=l.originalAxes,m=l.inputWasTransposed;m&&(d=c,o=a.dataIdMap.get(c.dataId).id);var h=d.shape.length;n.backend_util.assertAxesAreInnerMostDims("max",p,h);var b=n.backend_util.computeOutAndReduceShapes(d.shape,p),y=b[0],v=b[1],_=n.util.sizeFromShape(v),g=a.makeOutput(y,i.dtype);if(0!==n.util.sizeFromShape(d.shape)){var w=a.dataIdMap.get(g.dataId).id;Ae(o,_,w)}if(m&&a.disposeData(c.dataId),s){var k=n.backend_util.expandShapeToKeepDim(g.shape,f);g.shape=k}return g}},Oe=f(n.Maximum,!1);var De,Pe={kernelName:n.MaxPool,backendName:"wasm",setupFunc:function(e){Te=e.wasm.cwrap(n.MaxPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var a=e.inputs,t=e.attrs,r=e.backend,u=a.x,s=r.dataIdMap.get(u.dataId).id,i=t.filterSize,o=t.strides,d=t.pad,l=t.dimRoundingMode,c=n.backend_util.computePool2DInfo(u.shape,i,o,1,d,l),p=c.filterHeight,f=c.filterWidth,m=c.padInfo.top,h=c.padInfo.right,b=c.padInfo.bottom,y=c.padInfo.left,v=c.dilationHeight,_=c.dilationWidth,g=c.strideHeight,w=c.strideWidth,k=c.inChannels,I=c.outChannels;if("channelsLast"!==c.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+c.dataFormat+"'. Please use 'channelsLast'.");var M=r.makeOutput(c.outShape,"float32"),A=r.dataIdMap.get(M.dataId).id;return Te(s,u.shape[0],u.shape[1],u.shape[2],p,f,m,h,b,y,v,_,g,w,k,I,A),M}};var Re,We={kernelName:n.Mean,backendName:"wasm",setupFunc:function(e){De=e.wasm.cwrap(n.Mean,null,["number, number, number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=r.axis,s=r.keepDims,i=t.x,o=a.dataIdMap.get(i.dataId).id,d=o,l=i,c=I(i,u,a),p=c.transposed,f=c.axes,m=c.originalAxes,h=c.inputWasTransposed,b=f;if(h){var y=a.dataIdMap.get(p.dataId).id;y!==o&&(l=p,d=y,b=n.backend_util.getInnerMostAxes(b.length,l.shape.length))}n.backend_util.assertAxesAreInnerMostDims("mean",b,l.shape.length);var v=n.backend_util.computeOutAndReduceShapes(l.shape,b),_=v[0],g=v[1],w=n.util.sizeFromShape(g),k=l;"float32"!==l.dtype&&(k=P({backend:a,inputs:{x:l},attrs:{dtype:"float32"}}),d=a.dataIdMap.get(k.dataId).id);var M=a.makeOutput(_,"float32");if(0!==n.util.sizeFromShape(l.shape)){var A=a.dataIdMap.get(M.dataId).id;De(d,w,A)}if(h&&a.disposeData(p.dataId),s){var x=n.backend_util.expandShapeToKeepDim(M.shape,m);M.shape=x}return"float32"!==l.dtype&&a.disposeData(k.dataId),M}};var He,ze,Le={kernelName:n.Min,backendName:"wasm",setupFunc:function(e){Re=e.wasm.cwrap(n.Min,null,["number, number, number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=r.axis,s=r.keepDims,i=t.x,o=a.dataIdMap.get(i.dataId).id,d=o,l=i,c=I(i,u,a),p=c.transposed,f=c.axes,m=c.originalAxes,h=c.inputWasTransposed;if(h){var b=a.dataIdMap.get(p.dataId).id;b!==o&&(l=p,d=b)}var y=l.shape.length;n.backend_util.assertAxesAreInnerMostDims("min",f,y);var v=n.backend_util.computeOutAndReduceShapes(l.shape,f),_=v[0],g=v[1],w=n.util.sizeFromShape(g),k=a.makeOutput(_,l.dtype);if(0!==n.util.sizeFromShape(l.shape)){var M=a.dataIdMap.get(k.dataId).id;Re(d,w,M)}if(h&&a.disposeData(p.dataId),s){var A=n.backend_util.expandShapeToKeepDim(k.shape,m);k.shape=A}return k}},Ue=f(n.Minimum,!1);!function(e){e[e.reflect=0]="reflect",e[e.symmetric=1]="symmetric"}(He||(He={}));var Be,je={kernelName:n.MirrorPad,backendName:"wasm",kernelFunc:function(e){var n=e.inputs.x,a=e.backend,t=e.attrs,r=t.paddings,u=t.mode,s=r.map((function(e,a){return e[0]+n.shape[a]+e[1]})),o=a.dataIdMap.get(n.dataId).id,d=a.makeOutput(s,n.dtype),l=a.dataIdMap.get(d.dataId).id,c=new Uint8Array(new Int32Array(n.shape).buffer),p=r.map((function(e){return e[0]})),f=r.map((function(e){return e[1]})),m=new Uint8Array(new Int32Array(p).buffer),h=new Uint8Array(new Int32Array(f).buffer);return ze(o,c,n.shape.length,i[n.dtype],m,h,He[u],l),d},setupFunc:function(e){ze=e.wasm.cwrap(n.MirrorPad,null,["number","array","number","number","array","array","number","number"])}},qe=f(n.Multiply,!0),Ve=c(n.Neg);function Ge(e,n){var a=new Int32Array(e.wasm.HEAPU8.buffer,n,4),t=a[0],r=a[1],u=a[2],s=a[3];return e.wasm._free(n),{pSelectedIndices:t,selectedSize:r,pSelectedScores:u,pValidOutputs:s}}var Ke,Qe={kernelName:n.NonMaxSuppressionV3,backendName:"wasm",setupFunc:function(e){Be=e.wasm.cwrap(n.NonMaxSuppressionV3,"number",["number","number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,t=e.attrs,r=t.iouThreshold,u=t.maxOutputSize,s=t.scoreThreshold,i=a.boxes,o=a.scores,d=n.dataIdMap.get(i.dataId).id,l=n.dataIdMap.get(o.dataId).id,c=Ge(n,Be(d,l,u,r,s)),p=c.pSelectedIndices,f=c.selectedSize,m=c.pSelectedScores,h=c.pValidOutputs;return n.wasm._free(m),n.wasm._free(h),n.makeOutput([f],"int32",p)}};var Xe,Ze={kernelName:n.NonMaxSuppressionV4,backendName:"wasm",setupFunc:function(e){Ke=e.wasm.cwrap(n.NonMaxSuppressionV4,"number",["number","number","number","number","number","bool"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,t=e.attrs,r=t.iouThreshold,u=t.maxOutputSize,s=t.scoreThreshold,i=t.padToMaxOutputSize,o=a.boxes,d=a.scores,l=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(d.dataId).id,p=Ge(n,Ke(l,c,u,r,s,i)),f=p.pSelectedIndices,m=p.selectedSize,h=p.pSelectedScores,b=p.pValidOutputs;return n.wasm._free(h),[n.makeOutput([m],"int32",f),n.makeOutput([],"int32",b)]}};var Ye,Je={kernelName:n.NonMaxSuppressionV5,backendName:"wasm",setupFunc:function(e){Xe=e.wasm.cwrap(n.NonMaxSuppressionV5,"number",["number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,t=e.attrs,r=t.iouThreshold,u=t.maxOutputSize,s=t.scoreThreshold,i=t.softNmsSigma,o=a.boxes,d=a.scores,l=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(d.dataId).id,p=Ge(n,Xe(l,c,u,r,s,i)),f=p.pSelectedIndices,m=p.selectedSize,h=p.pSelectedScores,b=p.pValidOutputs;return n.wasm._free(b),[n.makeOutput([m],"int32",f),n.makeOutput([m],"float32",h)]}},$e=f(n.NotEqual,!1,"bool");var en={kernelName:n.OneHot,backendName:"wasm",setupFunc:function(e){Ye=e.wasm.cwrap(n.OneHot,null,["number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,t=e.attrs,r=n.indices,u=t.depth,s=t.onValue,i=t.offValue,o=a.makeOutput(r.shape.concat([u]),"int32"),d=a.dataIdMap.get(o.dataId).id,l=a.dataIdMap.get(r.dataId).id;return Ye(l,u,s,i,d),o}};var nn={kernelName:n.OnesLike,backendName:"wasm",kernelFunc:function(e){var n=e.inputs.x,a=e.backend,t=a.makeOutput(n.shape,n.dtype);return a.typedArrayFromHeap(t).fill(1),t}};var an,tn={kernelName:n.Pack,backendName:"wasm",kernelFunc:function(e){var a=e.inputs,t=e.backend,r=e.attrs.axis;if(1===a.length)return ue({inputs:{input:a[0]},backend:t,attrs:{dim:r}});var u=a[0].shape,s=a[0].dtype;a.forEach((function(e){n.util.assertShapesMatch(u,e.shape,"All tensors passed to stack must have matching shapes"),n.util.assert(s===e.dtype,(function(){return"All tensors passed to stack must have matching dtypes"}))}));var i=[],o=U({inputs:a.map((function(e){var n=ue({inputs:{input:e},backend:t,attrs:{dim:r}});return i.push(n),n})),backend:t,attrs:{axis:r}});return i.forEach((function(e){return t.disposeData(e.dataId)})),o}};var rn,un={kernelName:n.PadV2,backendName:"wasm",kernelFunc:function(e){var n=e.inputs.x,a=e.backend,t=e.attrs,r=t.paddings,u=t.constantValue,s=r.map((function(e,a){return e[0]+n.shape[a]+e[1]})),o=a.dataIdMap.get(n.dataId).id,d=a.makeOutput(s,n.dtype),l=a.dataIdMap.get(d.dataId).id,c=new Uint8Array(new Int32Array(n.shape).buffer),p=r.map((function(e){return e[0]})),f=r.map((function(e){return e[1]})),m=new Uint8Array(new Int32Array(p).buffer),h=new Uint8Array(new Int32Array(f).buffer);return an(o,c,n.shape.length,i[n.dtype],m,h,u,l),d},setupFunc:function(e){an=e.wasm.cwrap(n.PadV2,null,["number","array","number","number","array","array","number","number"])}},sn=f(n.Pow,!1);var on,dn={kernelName:n.Prelu,backendName:"wasm",setupFunc:function(e){rn=e.wasm.cwrap(n.Prelu,null,["number","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,t=n.x,r=n.alpha,u=a.dataIdMap.get(t.dataId).id,s=a.dataIdMap.get(r.dataId).id,i=a.makeOutput(t.shape,"float32"),o=a.dataIdMap.get(i.dataId).id;return rn(u,s,o),i}};var ln,cn={kernelName:n.Prod,backendName:"wasm",setupFunc:function(e){on=e.wasm.cwrap(n.Prod,null,["number","number","number","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=r.axis,s=r.keepDims,o=t.x,d=a.dataIdMap.get(o.dataId).id,l=d,c=o,p=I(o,u,a),f=p.transposed,m=p.axes,h=p.originalAxes,b=p.inputWasTransposed,y=m;if(b){var v=a.dataIdMap.get(f.dataId).id;v!==d&&(c=f,l=v,y=n.backend_util.getInnerMostAxes(y.length,c.shape.length))}n.backend_util.assertAxesAreInnerMostDims("prod",y,c.shape.length);var _=n.backend_util.computeOutAndReduceShapes(c.shape,y),g=_[0],w=_[1],k=n.util.sizeFromShape(w),M=a.makeOutput(g,c.dtype);if(0!==n.util.sizeFromShape(c.shape)){var A=a.dataIdMap.get(M.dataId).id;on(l,k,i[M.dtype],A)}if(b&&a.disposeData(f.dataId),s){var x=n.backend_util.expandShapeToKeepDim(M.shape,h);M.shape=x}return M}},pn={kernelName:n.Range,backendName:"wasm",kernelFunc:function(e){var a=e.backend,t=e.attrs,r=t.start,u=t.stop,s=t.step,i=t.dtype,o=function(e,a,t,r){if(e===a||e<a&&t<0||a<e&&t>1)return n.util.makeZerosTypedArray(0,r);const u=Math.abs(Math.ceil((a-e)/t)),s=n.util.makeZerosTypedArray(u,r);a<e&&1===t&&(t=-1),s[0]=e;for(let e=1;e<s.length;e++)s[e]=s[e-1]+t;return s}(r,u,s,i),d=a.makeOutput([o.length],i);return a.typedArrayFromHeap(d).set(o),d}},fn=f(n.RealDiv,!0),mn=c(n.Relu),hn=c(n.Relu6);var bn,yn={kernelName:n.ResizeBilinear,backendName:"wasm",setupFunc:function(e){ln=e.wasm.cwrap(n.ResizeBilinear,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var a,t=e.backend,r=e.inputs,u=e.attrs,s=r.images,i=u.alignCorners,o=u.halfPixelCenters,d=u.size,l=d[0],c=d[1],p=s.shape,f=p[0],m=p[1],h=p[2],b=p[3],y=[f,l,c,b],v=t.dataIdMap.get(s.dataId);"float32"!==v.dtype&&(a=P({backend:t,inputs:{x:s},attrs:{dtype:"float32"}}),v=t.dataIdMap.get(a.dataId));var _=v.id,g=t.makeOutput(y,"float32");if(0===n.util.sizeFromShape(s.shape))return g;var w=t.dataIdMap.get(g.dataId).id;return ln(_,f,m,h,b,l,c,i?1:0,o?1:0,w),null!=a&&t.disposeData(a.dataId),g}};var vn,_n={kernelName:n.Reverse,backendName:"wasm",kernelFunc:function(e){var a=e.inputs,t=e.backend,r=e.attrs,u=a.x,s=r.dims,i=n.util.parseAxisParam(s,u.shape);if(0===u.shape.length)return y({inputs:{x:u},backend:t});var o=t.makeOutput(u.shape,u.dtype),d=t.dataIdMap.get(u.dataId).id,l=t.dataIdMap.get(o.dataId).id,c=new Uint8Array(new Int32Array(i).buffer),p=new Uint8Array(new Int32Array(u.shape).buffer);bn(d,c,i.length,p,u.shape.length,l);var f=T({inputs:{x:o},attrs:{shape:u.shape},backend:t});return t.disposeData(o.dataId),f},setupFunc:function(e){bn=e.wasm.cwrap(n.Reverse,null,["number","array","number","array","number","number"])}};var gn,wn,kn,In,Mn={kernelName:n.RotateWithOffset,backendName:"wasm",kernelFunc:function(e){var a=e.inputs,t=e.backend,r=e.attrs,u=a.image,s=r.radians,i=r.fillValue,o=r.center,d=t.makeOutput(u.shape,u.dtype),l=t.dataIdMap.get(u.dataId).id,c=t.dataIdMap.get(d.dataId).id,p=u.shape,f=p[0],m=p[1],h=p[2],b=p[3],y=n.backend_util.getImageCenter(o,m,h),v=y[0],_=y[1],g="number"==typeof i?[i,i,i,0===i?0:255]:i.concat([255]),w=new Uint8Array(new Int32Array(g).buffer);return vn(l,f,m,h,b,s,v,_,w,g.length,c),d},setupFunc:function(e){vn=e.wasm.cwrap(n.RotateWithOffset,null,["number","number","number","number","number","number","number","number","array","number","number"])}},An=c(n.Round);function xn(e){var a=e.inputs.x,t=e.attrs,r=t.begin,u=t.size,s=e.backend,i=n.slice_util.parseSliceParams(a,r,u),o=i[0],d=i[1],l=n.slice_util.isSliceContinous(a.shape,o,d),c=s.readSync(a.dataId),p=s.makeOutput(d,a.dtype),f=n.util.computeStrides(a.shape),m=s.dataIdMap.get(p.dataId);if(l){var h=n.slice_util.computeFlatOffset(o,f);if("string"===a.dtype)m.stringBytes=c.slice(h,h+n.util.sizeFromShape(d));else s.typedArrayFromHeap(p).set(c.subarray(h,h+n.util.sizeFromShape(d)));return p}if("string"===a.dtype){var b=L(c,o,d,a.shape,a.dtype);return m.stringBytes=b,p}var y=s.typedArrayFromHeap(p),v=a.shape.length;if(2===v)!function(e,n,a,t,r){for(var u=0,s=t[0],i=t[1],o=s+r[0],d=s;d<o;d++){var l=d*n+i;a.set(e.subarray(l,l+r[1]),u),u+=r[1]}}(c,f[0],y,o,d);else if(3===v)!function(e,n,a,t,r,u){for(var s=0,i=r[0],o=r[1],d=r[2],l=i+u[0],c=o+u[1],p=i;p<l;p++)for(var f=o;f<c;f++){var m=p*n+f*a+d;t.set(e.subarray(m,m+u[2]),s),s+=u[2]}}(c,f[0],f[1],y,o,d);else if(4===v)!function(e,n,a,t,r,u,s){for(var i=0,o=u[0],d=u[1],l=u[2],c=o+s[0],p=d+s[1],f=l+s[2],m=u[3],h=o;h<c;h++)for(var b=d;b<p;b++)for(var y=l;y<f;y++){var v=h*n+b*a+y*t+m;r.set(e.subarray(v,v+s[3]),i),i+=s[3]}}(c,f[0],f[1],f[2],y,o,d);else{b=L(c,o,d,a.shape,a.dtype);y.set(b)}return p}var Sn,Fn;var Nn,En,Tn;var Cn;for(var On=0,Dn=[p,h,b,A,S,N,E,D,W,H,z,j,V,Q,X,Y,$,ne,ae,te,re,se,oe,le,ce,pe,l,me,be,ve,ge,ke,Ie,Me,_,xe,Se,Fe,Ne,Ee,Ce,Oe,Pe,We,Le,Ue,je,qe,Ve,Qe,Ze,Je,$e,en,nn,tn,un,sn,dn,cn,pn,fn,mn,hn,O,yn,_n,Mn,c(n.Rsqrt),An,{kernelName:n.ScatterNd,backendName:"wasm",setupFunc:function(e){gn=e.wasm.cwrap(n.ScatterNd,null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=t.indices,s=t.updates,o=r.shape,d=a.makeOutput(o,s.dtype);if(0===n.util.sizeFromShape(o))return d;var l=n.scatter_util.calculateShapes(s,u,o),c=l.sliceRank,p=l.numUpdates,f=l.sliceSize,m=l.strides,h=l.outputSize,b=a.dataIdMap.get(u.dataId).id,y=a.dataIdMap.get(s.dataId).id,v=new Uint8Array(new Int32Array(m).buffer),_=a.dataIdMap.get(d.dataId).id;return gn(b,y,i[s.dtype],c,p,f,v,h,_),d}},{kernelName:n.Select,backendName:"wasm",kernelFunc:function(e){var a=e.inputs,t=e.backend,r=a.condition,u=a.t,s=a.e,i=t.dataIdMap.get(r.dataId).id,o=t.dataIdMap.get(u.dataId).id,d=t.dataIdMap.get(s.dataId).id,l=t.makeOutput(u.shape,u.dtype),c=t.dataIdMap.get(l.dataId).id,p=r.shape.length,f=u.shape.length,m=0===p||p>1||1===f?1:n.util.sizeFromShape(u.shape.slice(1));return wn(i,o,d,m,c),l},setupFunc:function(e){wn=e.wasm.cwrap("SelectV2",null,["number","number","number","number","number"])}},{kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){kn=e.wasm.cwrap(n.Sigmoid,null,["number","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs.x,r=a.dataIdMap.get(t.dataId).id,u=a.makeOutput(t.shape,t.dtype),s=a.dataIdMap.get(u.dataId).id;return 0===n.util.sizeFromShape(u.shape)||kn(r,s),u}},c(n.Sin),{kernelName:n.Slice,backendName:"wasm",kernelFunc:xn},{kernelName:n.Softmax,backendName:"wasm",setupFunc:function(e){In=e.wasm.cwrap(n.Softmax,null,["number","number","number","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs.logits,r=e.attrs.dim,u=a.dataIdMap.get(t.dataId).id,s=a.makeOutput(t.shape,t.dtype),i=a.dataIdMap.get(s.dataId).id,o=t.shape[r],d=n.util.sizeFromShape(t.shape)/o;return 0===n.util.sizeFromShape(s.shape)||In(u,i,o,d),s}},{kernelName:n.SplitV,backendName:"wasm",kernelFunc:function(e){var a=e.inputs,t=e.attrs,r=e.backend,u=a.x,s=t.numOrSizeSplits,i=t.axis,o=n.util.parseAxisParam(i,u.shape)[0],d=n.backend_util.prepareSplitSize(u,s,o),l=new Array(u.shape.length).fill(0),c=u.shape.slice();return d.map((function(e){var n=c.slice();n[o]=e;var a=xn({inputs:{x:u},attrs:{begin:l,size:n},backend:r});return l[o]+=e,a}))}},c(n.Sqrt),c(n.Square),f(n.SquaredDifference,!0),{kernelName:n.Step,backendName:"wasm",setupFunc:function(e){Sn=e.wasm.cwrap(n.Step,null,["number","number","number"])},kernelFunc:function(e){var n=e.backend,a=e.inputs,t=e.attrs.alpha,r=a.x,u=n.dataIdMap.get(r.dataId).id,s=n.makeOutput(r.shape,r.dtype),i=n.dataIdMap.get(s.dataId).id;return Sn(u,t,i),s}},{kernelName:n.StridedSlice,backendName:"wasm",setupFunc:function(e){Fn=e.wasm.cwrap(n.StridedSlice,null,["number","array","number","array","array","array","array","array","number","number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=t.x,s=r.begin,i=r.end,o=r.strides;null==o&&(o=new Array(s.length));var d=r.beginMask,l=r.endMask,c=r.ellipsisMask,p=r.newAxisMask,f=r.shrinkAxisMask,m=n.backend_util.slice_util.maskToAxes(c);if(m.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==c&&0!==p)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==c&&0!==f)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");var h=u.shape.length-s.length,b=n.backend_util.slice_util.maskToAxes(p),y=u.shape.slice();b.forEach((function(e){s[e]=0,i[e]=1,y.splice(e,0,1)}));var v=T({inputs:{x:u},attrs:{shape:y},backend:a}),_=n.backend_util.slice_util.getNormalizedAxes(v.shape,m,h,s,i,o,d,l,c),g=_.begin,w=_.end,k=_.strides;s=g,i=w,o=k;var I=n.backend_util.slice_util.maskToAxes(f);I.forEach((function(e){i[e]=s[e]+1,o[e]=1}));var M=n.backend_util.slice_util.computeOutShape(s,i,o),A=M.filter((function(e,n){return-1===I.indexOf(n)}));if(o.every((function(e){return 1===e}))){var x=xn({inputs:{x:v},attrs:{begin:s,size:M},backend:a});a.disposeData(v.dataId);var S=T({inputs:{x:x},attrs:{shape:A},backend:a});return a.disposeData(x.dataId),S}var F=a.makeOutput(A,"float32");if(!A.some((function(e){return 0===e}))){var N=a.dataIdMap.get(v.dataId).id,E=new Uint8Array(new Int32Array(n.util.computeStrides(v.shape)).buffer),C=new Uint8Array(new Int32Array(s).buffer),O=new Uint8Array(new Int32Array(i).buffer),D=new Uint8Array(new Int32Array(o).buffer),P=new Uint8Array(new Int32Array(A).buffer),R=new Uint8Array(new Int32Array(n.util.computeStrides(A)).buffer),W=a.dataIdMap.get(F.dataId).id;Fn(N,E,v.shape.length,C,O,D,P,R,A.length,W)}a.disposeData(v.dataId);var H=T({inputs:{x:F},attrs:{shape:A},backend:a});return a.disposeData(F.dataId),H}},f(n.Sub,!0),{kernelName:n.Sum,backendName:"wasm",setupFunc:function(e){Nn=e.wasm.cwrap(n.Sum,null,["number, number, number"])},kernelFunc:function(e){var a=e.backend,t=e.inputs,r=e.attrs,u=r.axis,s=r.keepDims,i=t.x,o=a.dataIdMap.get(i.dataId).id,d=o,l=i,c=I(i,u,a),p=c.transposed,f=c.axes,m=c.originalAxes,h=c.inputWasTransposed,b=f;if(h){var y=a.dataIdMap.get(p.dataId).id;y!==o&&(l=p,d=y,b=n.backend_util.getInnerMostAxes(b.length,l.shape.length))}n.backend_util.assertAxesAreInnerMostDims("sum",b,l.shape.length);var v=n.backend_util.computeOutAndReduceShapes(l.shape,b),_=v[0],g=v[1],w=n.util.sizeFromShape(g),k=a.makeOutput(_,l.dtype);if(0!==n.util.sizeFromShape(l.shape)){var M=a.dataIdMap.get(k.dataId).id;Nn(d,w,M)}if(h&&a.disposeData(p.dataId),s){var A=n.backend_util.expandShapeToKeepDim(k.shape,m);k.shape=A}return k}},c(n.Tan),c(n.Tanh),{kernelName:n.Tile,backendName:"wasm",setupFunc:function(e){En=e.wasm.cwrap(n.Tile,null,["number","array","number","array","number","number"])},kernelFunc:function(e){for(var n=e.inputs,a=e.backend,t=e.attrs,r=n.x,u=a.dataIdMap.get(r.dataId).id,s=t.reps,o=new Array(r.shape.length),d=0;d<o.length;d++)o[d]=r.shape[d]*s[d];var l=new Uint8Array(new Int32Array(r.shape).buffer),c=new Uint8Array(new Int32Array(o).buffer),p=a.makeOutput(o,r.dtype),f=a.dataIdMap.get(p.dataId).id;return En(u,l,r.shape.length,c,o.length,i[p.dtype],f),p}},{kernelName:n.TopK,backendName:"wasm",setupFunc:function(e){Tn=e.wasm.cwrap(n.TopK,null,["number","array","number","number","number","bool","number","number"])},kernelFunc:function(e){var n=e.inputs,a=e.backend,t=e.attrs,r=n.x,u=t.k,s=t.sorted,o=a.dataIdMap.get(r.dataId).id,d=new Uint8Array(new Int32Array(r.shape).buffer),l=r.shape.slice();l[l.length-1]=u;var c=a.makeOutput(l,r.dtype),p=a.dataIdMap.get(c.dataId).id,f=a.makeOutput(l,"int32"),m=a.dataIdMap.get(f.dataId).id;return Tn(o,d,r.shape.length,i[r.dtype],u,s,p,m),[c,f]}},{kernelName:n.Transform,backendName:"wasm",setupFunc:function(e){Cn=e.wasm.cwrap(n.Transform,null,["number","number","bool","number","number","number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){var a,t=e.backend,r=e.inputs,u=e.attrs,s=r.image,i=r.transforms,o=u.interpolation,d=u.fillMode,l=u.fillValue,c=u.outputShape,p=s.shape,f=p[0],m=p[1],h=p[2],b=p[3],y=null!=c?c:[m,h],v=y[0],_=y[1],g=[f,v,_,b],w=new Uint8Array(new Int32Array(n.util.computeStrides(s.shape)).buffer),k=t.makeOutput(g,s.dtype),I=t.dataIdMap.get(k.dataId).id,M=t.dataIdMap.get(s.dataId).id,A=t.dataIdMap.get(i.dataId).id,x="nearest"===o?1:2;switch(d){case"constant":a=1;break;case"reflect":a=2;break;case"wrap":a=3;break;case"nearest":a=4;break;default:a=1}return Cn(M,A,i.shape[0]>1,f,v,_,b,h,m,w,s.shape.length-1,x,a,l,I),k}},k,{kernelName:n.Unpack,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,a=e.backend,t=e.attrs,r=n.value,u=t.axis;u<0&&(u+=r.shape.length);for(var s=r.shape[u],i=r.shape.length,o=new Array(i-1),d=0,l=0;l<i;l++)l!==u&&(o[d++]=r.shape[l]);var c=new Array(s),p=new Array(i).fill(0),f=r.shape.slice();for(f[u]=1,l=0;l<c.length;l++)p[u]=l,c[l]=xn({inputs:{x:r},attrs:{begin:p,size:f},backend:a});return c.map((function(e){return{dataId:e.dataId,dtype:e.dtype,shape:o}}))}},{kernelName:n.ZerosLike,backendName:"wasm",kernelFunc:function(e){var n=e.inputs.x,a=e.backend,t=a.makeOutput(n.shape,n.dtype);return a.typedArrayFromHeap(t).fill(0),t}}];On<Dn.length;On++){var Pn=Dn[On];n.registerKernel(Pn)}var Rn=function(e,n){return(Rn=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,n){e.__proto__=n}||function(e,n){for(var a in n)n.hasOwnProperty(a)&&(e[a]=n[a])})(e,n)};function Wn(e,n,a,t){return new(a||(a=Promise))((function(r,u){function s(e){try{o(t.next(e))}catch(e){u(e)}}function i(e){try{o(t.throw(e))}catch(e){u(e)}}function o(e){var n;e.done?r(e.value):(n=e.value,n instanceof a?n:new a((function(e){e(n)}))).then(s,i)}o((t=t.apply(e,n||[])).next())}))}function Hn(e,n){var a,t,r,u,s={label:0,sent:function(){if(1&r[0])throw r[1];return r[1]},trys:[],ops:[]};return u={next:i(0),throw:i(1),return:i(2)},"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u;function i(u){return function(i){return function(u){if(a)throw new TypeError("Generator is already executing.");for(;s;)try{if(a=1,t&&(r=2&u[0]?t.return:u[0]?t.throw||((r=t.return)&&r.call(t),0):t.next)&&!(r=r.call(t,u[1])).done)return r;switch(t=0,r&&(u=[2&u[0],r.value]),u[0]){case 0:case 1:r=u;break;case 4:return s.label++,{value:u[1],done:!1};case 5:s.label++,t=u[1],u=[0];continue;case 7:u=s.ops.pop(),s.trys.pop();continue;default:if(!(r=s.trys,(r=r.length>0&&r[r.length-1])||6!==u[0]&&2!==u[0])){s=0;continue}if(3===u[0]&&(!r||u[1]>r[0]&&u[1]<r[3])){s.label=u[1];break}if(6===u[0]&&s.label<r[1]){s.label=r[1],r=u;break}if(r&&s.label<r[2]){s.label=r[2],s.ops.push(u);break}r[2]&&s.ops.pop(),s.trys.pop();continue}u=n.call(e,s)}catch(e){u=[6,e],t=0}finally{a=r=0}if(5&u[0])throw u[1];return{value:u[0]?u[1]:void 0,done:!0}}([u,i])}}}var zn=void 0,Ln=n.env();Ln.registerFlag("WASM_HAS_SIMD_SUPPORT",(function(){return Wn(zn,void 0,void 0,(function(){return Hn(this,(function(e){return[2,WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11]))]}))}))})),Ln.registerFlag("WASM_HAS_MULTITHREAD_SUPPORT",(function(){return Wn(zn,void 0,void 0,(function(){return Hn(this,(function(e){if(Ln.get("IS_NODE"))return[2,!1];try{return(new MessageChannel).port1.postMessage(new SharedArrayBuffer(1)),[2,WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,5,4,1,3,1,1,10,11,1,9,0,65,0,254,16,2,0,26,11]))]}catch(e){return[2,!1]}return[2]}))}))}));var Un="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Bn(e,n){return e(n={exports:{}},n.exports),n.exports}var jn=Bn((function(e,n){var i,o=(i="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(i=i||__filename),function(e){function n(){return D.buffer!=W&&ne(D.buffer),H}function o(){return D.buffer!=W&&ne(D.buffer),z}function d(){return D.buffer!=W&&ne(D.buffer),L}function l(){return D.buffer!=W&&ne(D.buffer),U}function c(){return D.buffer!=W&&ne(D.buffer),B}var p,f,m="undefined"!=typeof(e=e||{})?e:{};m.ready=new Promise((function(e,n){p=e,f=n}));var h,b={};for(h in m)m.hasOwnProperty(h)&&(b[h]=m[h]);var y=function(e,n){throw n},v=!1,_=!1,g=!1,w=!1;v="object"==typeof window,_="function"==typeof importScripts,g="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,w=!v&&!g&&!_;var k=m.ENVIRONMENT_IS_PTHREAD||!1;k&&(W=m.buffer);var I,M,A,x,S,F="";function N(e){return m.locateFile?m.locateFile(e,F):F+e}if(g){var E;F=_?a.dirname(F)+"/":__dirname+"/",I=function(e,n){return x||(x=t),S||(S=a),e=S.normalize(e),x.readFileSync(e,n?null:"utf8")},A=function(e){var n=I(e,!0);return n.buffer||(n=new Uint8Array(n)),q(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof oa))throw e})),process.on("unhandledRejection",ve),y=function(e){process.exit(e)},m.inspect=function(){return"[Emscripten Module object]"};try{E=r}catch(e){throw console.error('The "worker_threads" module is not supported in this node.js build - perhaps a newer version is needed?'),e}Un.Worker=E.Worker}else w?("undefined"!=typeof read&&(I=function(e){return read(e)}),A=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(q("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"function"==typeof quit&&(y=function(e){quit(e)}),"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(v||_)&&(_?F=self.location.href:"undefined"!=typeof document&&document.currentScript&&(F=document.currentScript.src),"undefined"!=typeof i&&i&&(F=i),F=0!==F.indexOf("blob:")?F.substr(0,F.lastIndexOf("/")+1):"",g?(I=function(e,n){return x||(x=t),S||(S=a),e=S.normalize(e),x.readFileSync(e,n?null:"utf8")},A=function(e){var n=I(e,!0);return n.buffer||(n=new Uint8Array(n)),q(n.buffer),n}):(I=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},_&&(A=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)}),M=function(e,n,a){var t=new XMLHttpRequest;t.open("GET",e,!0),t.responseType="arraybuffer",t.onload=function(){200==t.status||0==t.status&&t.response?n(t.response):a()},t.onerror=a,t.send(null)}));g&&"undefined"==typeof performance&&(Un.performance=u.performance);var T,C=m.print||console.log.bind(console),O=m.printErr||console.warn.bind(console);for(h in b)b.hasOwnProperty(h)&&(m[h]=b[h]);b=null,m.arguments&&m.arguments,m.thisProgram&&m.thisProgram,m.quit&&(y=m.quit),m.wasmBinary&&(T=m.wasmBinary);var D,P,R=m.noExitRuntime||!0;"object"!=typeof WebAssembly&&ve("no native wasm support detected");var W,H,z,L,U,B,j=!1;function q(e,n){e||ve("Assertion failed: "+n)}function V(e){var n=m["_"+e];return q(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function G(e,n,a,t,r){var u={string:function(e){var n=0;if(null!=e&&0!==e){var a=1+(e.length<<2);Y(e,n=ta(a),a)}return n},array:function(e){var n=ta(e.length);return $(e,n),n}},s=V(e),i=[],o=0;if(t)for(var d=0;d<t.length;d++){var l=u[a[d]];l?(0===o&&(o=na()),i[d]=l(t[d])):i[d]=t[d]}var c=s.apply(null,i);return c=function(e){return"string"===n?X(e):"boolean"===n?Boolean(e):e}(c),0!==o&&aa(o),c}function K(e,n,a,t){var r=(a=a||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!t?V(e):function(){return G(e,n,a,arguments)}}function Q(e,n,a){for(var t=n+a,r="";!(n>=t);){var u=e[n++];if(!u)return r;if(128&u){var s=63&e[n++];if(192!=(224&u)){var i=63&e[n++];if((u=224==(240&u)?(15&u)<<12|s<<6|i:(7&u)<<18|s<<12|i<<6|63&e[n++])<65536)r+=String.fromCharCode(u);else{var o=u-65536;r+=String.fromCharCode(55296|o>>10,56320|1023&o)}}else r+=String.fromCharCode((31&u)<<6|s)}else r+=String.fromCharCode(u)}return r}function X(e,n){return e?Q(o(),e,n):""}function Z(e,n,a,t){if(!(t>0))return 0;for(var r=a,u=a+t-1,s=0;s<e.length;++s){var i=e.charCodeAt(s);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++s)),i<=127){if(a>=u)break;n[a++]=i}else if(i<=2047){if(a+1>=u)break;n[a++]=192|i>>6,n[a++]=128|63&i}else if(i<=65535){if(a+2>=u)break;n[a++]=224|i>>12,n[a++]=128|i>>6&63,n[a++]=128|63&i}else{if(a+3>=u)break;n[a++]=240|i>>18,n[a++]=128|i>>12&63,n[a++]=128|i>>6&63,n[a++]=128|63&i}}return n[a]=0,a-r}function Y(e,n,a){return Z(e,o(),n,a)}function J(e){for(var n=0,a=0;a<e.length;++a){var t=e.charCodeAt(a);t>=55296&&t<=57343&&(t=65536+((1023&t)<<10)|1023&e.charCodeAt(++a)),t<=127?++n:n+=t<=2047?2:t<=65535?3:4}return n}function $(e,a){n().set(e,a)}function ee(e,n){return e%n>0&&(e+=n-e%n),e}function ne(e){W=e,m.HEAP8=H=new Int8Array(e),m.HEAP16=new Int16Array(e),m.HEAP32=L=new Int32Array(e),m.HEAPU8=z=new Uint8Array(e),m.HEAPU16=new Uint16Array(e),m.HEAPU32=U=new Uint32Array(e),m.HEAPF32=new Float32Array(e),m.HEAPF64=B=new Float64Array(e)}var ae,te=m.INITIAL_MEMORY||16777216;if(k)D=m.wasmMemory,W=m.buffer;else if(m.wasmMemory)D=m.wasmMemory;else if(!((D=new WebAssembly.Memory({initial:te/65536,maximum:32768,shared:!0})).buffer instanceof SharedArrayBuffer))throw O("requested a shared WebAssembly.Memory but the returned buffer is not a SharedArrayBuffer, indicating that while the browser has SharedArrayBuffer it does not have WebAssembly threads support - you may need to set a flag"),g&&console.log("(on node you may need: --experimental-wasm-threads --experimental-wasm-bulk-memory and also use a recent version)"),Error("bad memory");D&&(W=D.buffer),te=W.byteLength,ne(W);var re=[],ue=[],se=[],ie=[];function oe(){if(!k){if(m.preRun)for("function"==typeof m.preRun&&(m.preRun=[m.preRun]);m.preRun.length;)pe(m.preRun.shift());Ee(re)}}function de(){k||Ee(ue)}function le(){k||Ee(se)}function ce(){if(!k){if(m.postRun)for("function"==typeof m.postRun&&(m.postRun=[m.postRun]);m.postRun.length;)fe(m.postRun.shift());Ee(ie)}}function pe(e){re.unshift(e)}function fe(e){ie.unshift(e)}k||ue.push({func:function(){Ln()}});var me=0,he=null;function be(e){q(!k,"addRunDependency cannot be used in a pthread worker"),me++,m.monitorRunDependencies&&m.monitorRunDependencies(me)}function ye(e){if(me--,m.monitorRunDependencies&&m.monitorRunDependencies(me),0==me&&he){var n=he;he=null,n()}}function ve(e){m.onAbort&&m.onAbort(e),k&&console.error("Pthread aborting at "+(new Error).stack),O(e+=""),j=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.";var n=new WebAssembly.RuntimeError(e);throw f(n),n}function _e(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}m.preloadedImages={},m.preloadedAudios={};var ge="data:application/octet-stream;base64,";function we(e){return _e(e,ge)}var ke="file://";function Ie(e){return _e(e,ke)}var Me="tfjs-backend-wasm-threaded-simd.wasm";function Ae(e){try{if(e==Me&&T)return new Uint8Array(T);if(A)return A(e);throw"both async and sync fetching of the wasm failed"}catch(e){ve(e)}}function xe(){if(!T&&(v||_)){if("function"==typeof fetch&&!Ie(Me))return fetch(Me,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+Me+"'";return e.arrayBuffer()})).catch((function(){return Ae(Me)}));if(M)return new Promise((function(e,n){M(Me,(function(n){e(new Uint8Array(n))}),n)}))}return Promise.resolve().then((function(){return Ae(Me)}))}function Se(){var e={a:zn};function n(e,n){var a=e.exports;if(m.asm=a,ae=m.asm.F,P=n,!k){var t=Re.unusedWorkers.length;Re.unusedWorkers.forEach((function(e){Re.loadWasmModuleToWorker(e,(function(){--t||ye()}))}))}}function a(e){n(e.instance,e.module)}function t(n){return xe().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){O("failed to asynchronously prepare wasm: "+e),ve(e)}))}if(k||be(),m.instantiateWasm)try{return m.instantiateWasm(e,n)}catch(e){return O("Module.instantiateWasm callback failed with error: "+e),!1}return(T||"function"!=typeof WebAssembly.instantiateStreaming||we(Me)||Ie(Me)||"function"!=typeof fetch?t(a):fetch(Me,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(a,(function(e){return O("wasm streaming compile failed: "+e),O("falling back to ArrayBuffer instantiation"),t(a)}))}))).catch(f),{}}we(Me)||(Me=N(Me));var Fe={9816:function(){throw"Canceled!"},9834:function(e,n){setTimeout((function(){Zn(e,n)}),0)}};function Ne(){Re.initRuntime()}function Ee(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var a=n.func;"number"==typeof a?void 0===n.arg?ae.get(a)():ae.get(a)(n.arg):a(void 0===n.arg?null:n.arg)}else n(m)}}function Te(e,a){if(e<=0||e>n().length||!0&e||a<0)return-28;if(0==a)return 0;a>=2147483647&&(a=1/0);var t=Atomics.load(d(),ia>>2),r=0;if(t==e&&Atomics.compareExchange(d(),ia>>2,t,0)==t&&(r=1,--a<=0))return 1;var u=Atomics.notify(d(),e>>2,a);if(u>=0)return u+r;throw"Atomics.notify returned an unexpected value "+u}function Ce(e){if(k)throw"Internal Error! killThread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in killThread!";d()[e+12>>2]=0;var n=Re.pthreads[e];n.worker.terminate(),Re.freeThreadData(n),Re.runningWorkers.splice(Re.runningWorkers.indexOf(n.worker),1),n.worker.pthread=void 0}function Oe(e){if(k)throw"Internal Error! cancelThread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in cancelThread!";Re.pthreads[e].worker.postMessage({cmd:"cancel"})}function De(e){if(k)throw"Internal Error! cleanupThread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in cleanupThread!";var n=Re.pthreads[e];if(n){d()[e+12>>2]=0;var a=n.worker;Re.returnWorkerToPool(a)}}m._emscripten_futex_wake=Te;var Pe,Re={unusedWorkers:[],runningWorkers:[],initMainThreadBlock:function(){for(var e=Math.min(4,Math.max(1,(navigator.hardwareConcurrency||1)/2)),n=0;n<e;++n)Re.allocateUnusedWorker()},initRuntime:function(){for(var e=Bn(228),n=0;n<57;++n)l()[e/4+n]=0;d()[e+12>>2]=e;var a=e+152;d()[a>>2]=a;var t=Bn(512);for(n=0;n<128;++n)l()[t/4+n]=0;Atomics.store(l(),e+100>>2,t),Atomics.store(l(),e+40>>2,e),ea(e,!_,1),Xn(e)},initWorker:function(){},pthreads:{},threadExitHandlers:[],setThreadStatus:function(){},runExitHandlers:function(){for(;Re.threadExitHandlers.length>0;)Re.threadExitHandlers.pop()();k&&Gn()&&Kn()},runExitHandlersAndDeinitThread:function(e,n){Atomics.store(l(),e+56>>2,1),Atomics.store(l(),e+60>>2,0),Re.runExitHandlers(),Atomics.store(l(),e+4>>2,n),Atomics.store(l(),e+0>>2,1),Te(e+0,2147483647),ea(0,0,0)},threadExit:function(e){var n=Gn();n&&(Re.runExitHandlersAndDeinitThread(n,e),k&&postMessage({cmd:"exit"}))},threadCancel:function(){Re.runExitHandlersAndDeinitThread(Gn(),-1),postMessage({cmd:"cancelDone"})},terminateAllThreads:function(){for(var e in Re.pthreads)(t=Re.pthreads[e])&&t.worker&&Re.returnWorkerToPool(t.worker);Re.pthreads={};for(var n=0;n<Re.unusedWorkers.length;++n)(a=Re.unusedWorkers[n]).terminate();for(Re.unusedWorkers=[],n=0;n<Re.runningWorkers.length;++n){var a,t=(a=Re.runningWorkers[n]).pthread;Re.freeThreadData(t),a.terminate()}Re.runningWorkers=[]},freeThreadData:function(e){if(e){if(e.threadInfoStruct){var n=d()[e.threadInfoStruct+100>>2];d()[e.threadInfoStruct+100>>2]=0,jn(n),jn(e.threadInfoStruct)}e.threadInfoStruct=0,e.allocatedOwnStack&&e.stackBase&&jn(e.stackBase),e.stackBase=0,e.worker&&(e.worker.pthread=null)}},returnWorkerToPool:function(e){Re.runWithoutMainThreadQueuedCalls((function(){delete Re.pthreads[e.pthread.threadInfoStruct],Re.unusedWorkers.push(e),Re.runningWorkers.splice(Re.runningWorkers.indexOf(e),1),Re.freeThreadData(e.pthread),e.pthread=void 0}))},runWithoutMainThreadQueuedCalls:function(e){d()[sa>>2]=0;try{e()}finally{d()[sa>>2]=1}},receiveObjectTransfer:function(e){},loadWasmModuleToWorker:function(e,n){e.onmessage=function(a){var t=a.data,r=t.cmd;if(e.pthread&&(Re.currentProxiedOperationCallerThread=e.pthread.threadInfoStruct),t.targetThread&&t.targetThread!=Gn()){var u=Re.pthreads[t.targetThread];return u?u.worker.postMessage(a.data,t.transferList):console.error('Internal error! Worker sent a message "'+r+'" to target pthread '+t.targetThread+", but that thread no longer exists!"),void(Re.currentProxiedOperationCallerThread=void 0)}if("processQueuedMainThreadWork"===r)Qn();else if("spawnThread"===r)Dn(a.data);else if("cleanupThread"===r)De(t.thread);else if("killThread"===r)Ce(t.thread);else if("cancelThread"===r)Oe(t.thread);else if("loaded"===r)e.loaded=!0,n&&n(e),e.runPthread&&(e.runPthread(),delete e.runPthread);else if("print"===r)C("Thread "+t.threadId+": "+t.text);else if("printErr"===r)O("Thread "+t.threadId+": "+t.text);else if("alert"===r)alert("Thread "+t.threadId+": "+t.text);else if("exit"===r)e.pthread&&Atomics.load(l(),e.pthread.threadInfoStruct+64>>2)&&Re.returnWorkerToPool(e);else if("exitProcess"===r)try{la(t.returnCode)}catch(a){if(a instanceof oa)return;throw a}else"cancelDone"===r?Re.returnWorkerToPool(e):"objectTransfer"===r?Re.receiveObjectTransfer(a.data):"setimmediate"===a.data.target?e.postMessage(a.data):O("worker sent an unknown command "+r);Re.currentProxiedOperationCallerThread=void 0},e.onerror=function(e){O("pthread sent an error! "+e.filename+":"+e.lineno+": "+e.message)},g&&(e.on("message",(function(n){e.onmessage({data:n})})),e.on("error",(function(n){e.onerror(n)})),e.on("exit",(function(e){}))),e.postMessage({cmd:"load",urlOrBlob:m.mainScriptUrlOrBlob||i,wasmMemory:D,wasmModule:P})},allocateUnusedWorker:function(){var e=N("tfjs-backend-wasm-threaded-simd.worker.js");Re.unusedWorkers.push(new Worker(e))},getNewWorker:function(){return 0==Re.unusedWorkers.length&&(Re.allocateUnusedWorker(),Re.loadWasmModuleToWorker(Re.unusedWorkers[0])),Re.unusedWorkers.length>0?Re.unusedWorkers.pop():null},busySpinWait:function(e){for(var n=performance.now()+e;performance.now()<n;);}};function We(e,n){ra(e,n),aa(e)}function He(){return R}function ze(e,n){return ae.get(e)(n)}function Le(e,n,a,t){ve("Assertion failed: "+X(e)+", at: "+[n?X(n):"unknown filename",a,t?X(t):"unknown function"])}function Ue(e,n){_main(e,n)}function Be(e){return d()[qn()>>2]=e,e}function je(e,n){if(k)return Ye(1,1,e,n)}function qe(e,n){if(e==n)postMessage({cmd:"processQueuedMainThreadWork"});else if(k)postMessage({targetThread:e,cmd:"processThreadQueue"});else{var a=Re.pthreads[e],t=a&&a.worker;if(!t)return;t.postMessage({cmd:"processThreadQueue"})}return 1}function Ve(){ve()}function Ge(e,n,a){var t=en(n,a);return Fe[e].apply(null,t)}function Ke(e,n){}function Qe(e,a,t){if(e<=0||e>n().length||!0&e)return-28;if(v){if(Atomics.load(d(),e>>2)!=a)return-6;var r=performance.now(),u=r+t;for(Atomics.exchange(d(),ia>>2,e);;){if((r=performance.now())>u)return Atomics.exchange(d(),ia>>2,0),-73;if(0==Atomics.exchange(d(),ia>>2,0))break;if(Qn(),Atomics.load(d(),e>>2)!=a)return-6;Atomics.exchange(d(),ia>>2,e)}return 0}var s=Atomics.wait(d(),e>>2,a,t);if("timed-out"===s)return-73;if("not-equal"===s)return-6;if("ok"===s)return 0;throw"Atomics.wait returned an unexpected value "+s}function Xe(e,n,a){o().copyWithin(e,n,n+a)}function Ze(){return g?s.cpus().length:navigator.hardwareConcurrency}function Ye(e,n){for(var a=arguments.length-2,t=na(),r=a,u=ta(8*r),s=u>>3,i=0;i<a;i++){var o=arguments[2+i];c()[s+i]=o}var d=Jn(e,r,u,n);return aa(t),d}m.establishStackSpace=We,m.getNoExitRuntime=He,m.invokeEntryPoint=ze,Pe=g?function(){var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:k?function(){return performance.now()-m.__performance_now_clock_drift}:"undefined"!=typeof dateNow?dateNow:function(){return performance.now()};var Je=[],$e=[];function en(e,n){var a;for($e.length=0,n>>=2;a=o()[e++];){var t=a<105;t&&1&n&&n++,$e.push(t?c()[n++>>1]:d()[n]),++n}return $e}function nn(e,n,a){Je.length=n;for(var t=a>>3,r=0;r<n;r++)Je[r]=c()[t+r];return(e<0?Fe[-e-1]:Hn[e]).apply(null,Je)}function an(){return o().length}function tn(e){try{return D.grow(e-W.byteLength+65535>>>16),ne(D.buffer),1}catch(e){}}function rn(e){var n=an();if(e<=n)return!1;var a=2147483648;if(e>a)return!1;for(var t=1;t<=4;t*=2){var r=n*(1+.2/t);if(r=Math.min(r,e+100663296),tn(Math.min(a,ee(Math.max(e,r),65536))))return!0}return!1}var un={inEventHandler:0,removeAllEventListeners:function(){for(var e=un.eventHandlers.length-1;e>=0;--e)un._removeHandler(e);un.eventHandlers=[],un.deferredCalls=[]},registerRemoveEventListeners:function(){un.removeEventListenersRegistered||(un.removeEventListenersRegistered=!0)},deferredCalls:[],deferCall:function(e,n,a){function t(e,n){if(e.length!=n.length)return!1;for(var a in e)if(e[a]!=n[a])return!1;return!0}for(var r in un.deferredCalls){var u=un.deferredCalls[r];if(u.targetFunction==e&&t(u.argsList,a))return}un.deferredCalls.push({targetFunction:e,precedence:n,argsList:a}),un.deferredCalls.sort((function(e,n){return e.precedence<n.precedence}))},removeDeferredCalls:function(e){for(var n=0;n<un.deferredCalls.length;++n)un.deferredCalls[n].targetFunction==e&&(un.deferredCalls.splice(n,1),--n)},canPerformEventHandlerRequests:function(){return un.inEventHandler&&un.currentEventHandler.allowsDeferredCalls},runDeferredCalls:function(){if(un.canPerformEventHandlerRequests())for(var e=0;e<un.deferredCalls.length;++e){var n=un.deferredCalls[e];un.deferredCalls.splice(e,1),--e,n.targetFunction.apply(null,n.argsList)}},eventHandlers:[],removeAllHandlersOnTarget:function(e,n){for(var a=0;a<un.eventHandlers.length;++a)un.eventHandlers[a].target!=e||n&&n!=un.eventHandlers[a].eventTypeString||un._removeHandler(a--)},_removeHandler:function(e){var n=un.eventHandlers[e];n.target.removeEventListener(n.eventTypeString,n.eventListenerFunc,n.useCapture),un.eventHandlers.splice(e,1)},registerOrRemoveHandler:function(e){var n=function(n){++un.inEventHandler,un.currentEventHandler=e,un.runDeferredCalls(),e.handlerFunc(n),un.runDeferredCalls(),--un.inEventHandler};if(e.callbackfunc)e.eventListenerFunc=n,e.target.addEventListener(e.eventTypeString,n,e.useCapture),un.eventHandlers.push(e),un.registerRemoveEventListeners();else for(var a=0;a<un.eventHandlers.length;++a)un.eventHandlers[a].target==e.target&&un.eventHandlers[a].eventTypeString==e.eventTypeString&&un._removeHandler(a--)},queueEventHandlerOnThread_iiii:function(e,n,a,t,r){var u=na(),s=ta(12);d()[s>>2]=a,d()[s+4>>2]=t,d()[s+8>>2]=r,$n(0,e,637534208,n,t,s),aa(u)},getTargetThreadForEventCallback:function(e){switch(e){case 1:return 0;case 2:return Re.currentProxiedOperationCallerThread;default:return e}},getNodeNameForTarget:function(e){return e?e==window?"#window":e==screen?"#screen":e&&e.nodeName?e.nodeName:"":""},fullscreenEnabled:function(){return document.fullscreenEnabled||document.webkitFullscreenEnabled}};function sn(e){var n=J(e)+1,a=Bn(n);return Y(e,a,n),a}function on(e,n,a,t){var r=na(),u=ta(12),s=0;n&&(s=sn(n)),d()[u>>2]=s,d()[u+4>>2]=a,d()[u+8>>2]=t,$n(0,e,657457152,0,s,u),aa(r)}function dn(e,n,a,t){on(e,n=n?X(n):"",a,t)}function ln(e){return e>2?X(e):e}var cn=[0,"undefined"!=typeof document?document:0,"undefined"!=typeof window?window:0];function pn(e){return e=ln(e),cn[e]||("undefined"!=typeof document?document.querySelector(e):void 0)}function fn(e){return pn(e)}function mn(e,n,a){var t=fn(e);if(!t)return-4;if(t.canvasSharedPtr&&(d()[t.canvasSharedPtr>>2]=n,d()[t.canvasSharedPtr+4>>2]=a),!t.offscreenCanvas&&t.controlTransferredOffscreen)return t.canvasSharedPtr?(dn(d()[t.canvasSharedPtr+8>>2],e,n,a),1):-4;t.offscreenCanvas&&(t=t.offscreenCanvas);var r=!1;if(t.GLctxObject&&t.GLctxObject.GLctx){var u=t.GLctxObject.GLctx.getParameter(2978);r=0===u[0]&&0===u[1]&&u[2]===t.width&&u[3]===t.height}return t.width=n,t.height=a,r&&t.GLctxObject.GLctx.viewport(0,0,n,a),0}function hn(e,n,a){return k?Ye(2,1,e,n,a):mn(e,n,a)}function bn(e,n,a){return fn(e)?mn(e,n,a):hn(e,n,a)}function yn(e){}function vn(e,n){}function _n(e){var n=e.getExtension("ANGLE_instanced_arrays");if(n)return e.vertexAttribDivisor=function(e,a){n.vertexAttribDivisorANGLE(e,a)},e.drawArraysInstanced=function(e,a,t,r){n.drawArraysInstancedANGLE(e,a,t,r)},e.drawElementsInstanced=function(e,a,t,r,u){n.drawElementsInstancedANGLE(e,a,t,r,u)},1}function gn(e){var n=e.getExtension("OES_vertex_array_object");if(n)return e.createVertexArray=function(){return n.createVertexArrayOES()},e.deleteVertexArray=function(e){n.deleteVertexArrayOES(e)},e.bindVertexArray=function(e){n.bindVertexArrayOES(e)},e.isVertexArray=function(e){return n.isVertexArrayOES(e)},1}function wn(e){var n=e.getExtension("WEBGL_draw_buffers");if(n)return e.drawBuffers=function(e,a){n.drawBuffersWEBGL(e,a)},1}function kn(e){return!!(e.multiDrawWebgl=e.getExtension("WEBGL_multi_draw"))}var In={counter:1,buffers:[],programs:[],framebuffers:[],renderbuffers:[],textures:[],uniforms:[],shaders:[],vaos:[],contexts:{},offscreenCanvases:{},timerQueriesEXT:[],programInfos:{},stringCache:{},unpackAlignment:4,recordError:function(e){In.lastError||(In.lastError=e)},getNewId:function(e){for(var n=In.counter++,a=e.length;a<n;a++)e[a]=null;return n},getSource:function(e,n,a,t){for(var r="",u=0;u<n;++u){var s=t?d()[t+4*u>>2]:-1;r+=X(d()[a+4*u>>2],s<0?void 0:s)}return r},createContext:function(e,n){var a=e.getContext("webgl",n);return a?In.registerContext(a,n):0},registerContext:function(e,n){var a=Bn(8);d()[a+4>>2]=Gn();var t={handle:a,attributes:n,version:n.majorVersion,GLctx:e};return e.canvas&&(e.canvas.GLctxObject=t),In.contexts[a]=t,("undefined"==typeof n.enableExtensionsByDefault||n.enableExtensionsByDefault)&&In.initExtensions(t),a},makeContextCurrent:function(e){return In.currentContext=In.contexts[e],m.ctx=Sn=In.currentContext&&In.currentContext.GLctx,!(e&&!Sn)},getContext:function(e){return In.contexts[e]},deleteContext:function(e){In.currentContext===In.contexts[e]&&(In.currentContext=null),"object"==typeof un&&un.removeAllHandlersOnTarget(In.contexts[e].GLctx.canvas),In.contexts[e]&&In.contexts[e].GLctx.canvas&&(In.contexts[e].GLctx.canvas.GLctxObject=void 0),jn(In.contexts[e].handle),In.contexts[e]=null},initExtensions:function(e){if(e||(e=In.currentContext),!e.initExtensionsDone){e.initExtensionsDone=!0;var n=e.GLctx;_n(n),gn(n),wn(n),n.disjointTimerQueryExt=n.getExtension("EXT_disjoint_timer_query"),kn(n),(n.getSupportedExtensions()||[]).forEach((function(e){e.indexOf("lose_context")<0&&e.indexOf("debug")<0&&n.getExtension(e)}))}},populateUniformTable:function(e){for(var n=In.programs[e],a=In.programInfos[e]={uniforms:{},maxUniformLength:0,maxAttributeLength:-1,maxUniformBlockNameLength:-1},t=a.uniforms,r=Sn.getProgramParameter(n,35718),u=0;u<r;++u){var s=Sn.getActiveUniform(n,u),i=s.name;a.maxUniformLength=Math.max(a.maxUniformLength,i.length+1),"]"==i.slice(-1)&&(i=i.slice(0,i.lastIndexOf("[")));var o=Sn.getUniformLocation(n,i);if(o){var d=In.getNewId(In.uniforms);t[i]=[s.size,d],In.uniforms[d]=o;for(var l=1;l<s.size;++l){var c=i+"["+l+"]";o=Sn.getUniformLocation(n,c),d=In.getNewId(In.uniforms),In.uniforms[d]=o}}}}},Mn=["default","low-power","high-performance"];function An(e,n){var a=n>>2,t=d()[a+6],r={alpha:!!d()[a+0],depth:!!d()[a+1],stencil:!!d()[a+2],antialias:!!d()[a+3],premultipliedAlpha:!!d()[a+4],preserveDrawingBuffer:!!d()[a+5],powerPreference:Mn[t],failIfMajorPerformanceCaveat:!!d()[a+7],majorVersion:d()[a+8],minorVersion:d()[a+9],enableExtensionsByDefault:d()[a+10],explicitSwapControl:d()[a+11],proxyContextToMainThread:d()[a+12],renderViaOffscreenBackBuffer:d()[a+13]},u=fn(e);return u?r.explicitSwapControl?0:In.createContext(u,r):0}function xn(e,n){return An(e,n)}var Sn,Fn={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var a=Fn.buffers[e];0===n||10===n?((1===e?C:O)(Q(a,0)),a.length=0):a.push(n)},varargs:void 0,get:function(){return Fn.varargs+=4,d()[Fn.varargs-4>>2]},getStr:function(e){return X(e)},get64:function(e,n){return e}};function Nn(e){return k?Ye(3,1,e):0}function En(e,n,a,t,r){if(k)return Ye(4,1,e,n,a,t,r)}function Tn(e,n,a,t){if(k)return Ye(5,1,e,n,a,t);for(var r=0,u=0;u<a;u++){for(var s=d()[n+8*u>>2],i=d()[n+(8*u+4)>>2],l=0;l<i;l++)Fn.printChar(e,o()[s+l]);r+=i}return d()[t>>2]=r,0}function Cn(e){var n=Re.threadExitHandlers.pop();e&&n()}function On(e,n){Re.threadExitHandlers.push((function(){ae.get(e)(n)}))}function Dn(e){if(k)throw"Internal Error! spawnThread() can only ever be called from main application thread!";var n=Re.getNewWorker();if(void 0!==n.pthread)throw"Internal error!";if(!e.pthread_ptr)throw"Internal error, no pthread ptr!";Re.runningWorkers.push(n);for(var a=Bn(512),t=0;t<128;++t)d()[a+4*t>>2]=0;var r=e.stackBase+e.stackSize,u=Re.pthreads[e.pthread_ptr]={worker:n,stackBase:e.stackBase,stackSize:e.stackSize,allocatedOwnStack:e.allocatedOwnStack,threadInfoStruct:e.pthread_ptr},s=u.threadInfoStruct>>2;Atomics.store(l(),s+16,e.detached),Atomics.store(l(),s+25,a),Atomics.store(l(),s+10,u.threadInfoStruct),Atomics.store(l(),s+20,e.stackSize),Atomics.store(l(),s+19,r),Atomics.store(l(),s+26,e.stackSize),Atomics.store(l(),s+28,r),Atomics.store(l(),s+29,e.detached);var i=Vn()+40;Atomics.store(l(),s+43,i),n.pthread=u;var o={cmd:"run",start_routine:e.startRoutine,arg:e.arg,threadInfoStruct:e.pthread_ptr,stackBase:e.stackBase,stackSize:e.stackSize};n.runPthread=function(){o.time=performance.now(),n.postMessage(o,e.transferList)},n.loaded&&(n.runPthread(),delete n.runPthread)}function Pn(e,n,a,t){if("undefined"==typeof SharedArrayBuffer)return O("Current environment does not support SharedArrayBuffer, pthreads are not available!"),6;if(!e)return O("pthread_create called with a null thread pointer!"),28;var r=[];if(k&&0===r.length)return Yn(687865856,e,n,a,t);var u=0,s=0,i=0;n&&-1!=n?(u=d()[n>>2],u+=81920,s=d()[n+8>>2],i=0!==d()[n+12>>2]):u=2097152;var o=0==s;o?s=ua(16,u):q((s-=u)>0);for(var c=Bn(228),p=0;p<57;++p)l()[(c>>2)+p]=0;d()[e>>2]=c,d()[c+12>>2]=c;var f=c+152;d()[f>>2]=f;var m={stackBase:s,stackSize:u,allocatedOwnStack:o,detached:i,startRoutine:a,pthread_ptr:c,arg:t,transferList:r};return k?(m.cmd="spawnThread",postMessage(m,r)):Dn(m),0}function Rn(e){if(k)return Ye(6,1,e);switch(e){case 30:return 16384;case 85:return 131072;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:case 80:case 81:case 79:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator&&navigator.hardwareConcurrency||1}return Be(28),-1}k||Re.initMainThreadBlock();var Wn,Hn=[null,je,hn,Nn,En,Tn,Rn],zn={e:Le,r:Ue,x:qe,b:Ve,y:Ge,j:Ke,c:Qe,d:Te,f:Pe,p:Xe,z:Ze,u:nn,q:rn,v:bn,i:yn,t:vn,w:xn,m:Nn,n:En,g:Tn,o:Ne,a:D||m.wasmMemory,k:Cn,l:On,h:Pn,s:Rn},Ln=(Se(),m.___wasm_call_ctors=function(){return(Ln=m.___wasm_call_ctors=m.asm.A).apply(null,arguments)}),Bn=(m._init=function(){return(m._init=m.asm.B).apply(null,arguments)},m._register_tensor=function(){return(m._register_tensor=m.asm.C).apply(null,arguments)},m._dispose_data=function(){return(m._dispose_data=m.asm.D).apply(null,arguments)},m._dispose=function(){return(m._dispose=m.asm.E).apply(null,arguments)},m._Abs=function(){return(m._Abs=m.asm.G).apply(null,arguments)},m._Add=function(){return(m._Add=m.asm.H).apply(null,arguments)},m._AddN=function(){return(m._AddN=m.asm.I).apply(null,arguments)},m._All=function(){return(m._All=m.asm.J).apply(null,arguments)},m._Any=function(){return(m._Any=m.asm.K).apply(null,arguments)},m._ArgMax=function(){return(m._ArgMax=m.asm.L).apply(null,arguments)},m._AvgPool=function(){return(m._AvgPool=m.asm.M).apply(null,arguments)},m._BatchMatMul=function(){return(m._BatchMatMul=m.asm.N).apply(null,arguments)},m._Ceil=function(){return(m._Ceil=m.asm.O).apply(null,arguments)},m._ClipByValue=function(){return(m._ClipByValue=m.asm.P).apply(null,arguments)},m._Conv2D=function(){return(m._Conv2D=m.asm.Q).apply(null,arguments)},m._Conv2DBackpropInput=function(){return(m._Conv2DBackpropInput=m.asm.R).apply(null,arguments)},m._Cos=function(){return(m._Cos=m.asm.S).apply(null,arguments)},m._CropAndResize=function(){return(m._CropAndResize=m.asm.T).apply(null,arguments)},m._Cumsum=function(){return(m._Cumsum=m.asm.U).apply(null,arguments)},m._DepthToSpace=function(){return(m._DepthToSpace=m.asm.V).apply(null,arguments)},m._DepthwiseConv2dNative=function(){return(m._DepthwiseConv2dNative=m.asm.W).apply(null,arguments)},m._Equal=function(){return(m._Equal=m.asm.X).apply(null,arguments)},m._Exp=function(){return(m._Exp=m.asm.Y).apply(null,arguments)},m._FlipLeftRight=function(){return(m._FlipLeftRight=m.asm.Z).apply(null,arguments)},m._Floor=function(){return(m._Floor=m.asm._).apply(null,arguments)},m._FloorDiv=function(){return(m._FloorDiv=m.asm.$).apply(null,arguments)},m._FusedBatchNorm=function(){return(m._FusedBatchNorm=m.asm.aa).apply(null,arguments)},m._FusedConv2D=function(){return(m._FusedConv2D=m.asm.ba).apply(null,arguments)},m._FusedDepthwiseConv2D=function(){return(m._FusedDepthwiseConv2D=m.asm.ca).apply(null,arguments)},m._Gather=function(){return(m._Gather=m.asm.da).apply(null,arguments)},m._GatherNd=function(){return(m._GatherNd=m.asm.ea).apply(null,arguments)},m._Greater=function(){return(m._Greater=m.asm.fa).apply(null,arguments)},m._GreaterEqual=function(){return(m._GreaterEqual=m.asm.ga).apply(null,arguments)},m._LeakyRelu=function(){return(m._LeakyRelu=m.asm.ha).apply(null,arguments)},m._Less=function(){return(m._Less=m.asm.ia).apply(null,arguments)},m._LessEqual=function(){return(m._LessEqual=m.asm.ja).apply(null,arguments)},m._Log=function(){return(m._Log=m.asm.ka).apply(null,arguments)},m._LogicalAnd=function(){return(m._LogicalAnd=m.asm.la).apply(null,arguments)},m._Max=function(){return(m._Max=m.asm.ma).apply(null,arguments)},m._MaxPool=function(){return(m._MaxPool=m.asm.na).apply(null,arguments)},m._Maximum=function(){return(m._Maximum=m.asm.oa).apply(null,arguments)},m._Mean=function(){return(m._Mean=m.asm.pa).apply(null,arguments)},m._Min=function(){return(m._Min=m.asm.qa).apply(null,arguments)},m._Minimum=function(){return(m._Minimum=m.asm.ra).apply(null,arguments)},m._MirrorPad=function(){return(m._MirrorPad=m.asm.sa).apply(null,arguments)},m._Multiply=function(){return(m._Multiply=m.asm.ta).apply(null,arguments)},m._Neg=function(){return(m._Neg=m.asm.ua).apply(null,arguments)},m._NonMaxSuppressionV3=function(){return(m._NonMaxSuppressionV3=m.asm.va).apply(null,arguments)},m._NonMaxSuppressionV4=function(){return(m._NonMaxSuppressionV4=m.asm.wa).apply(null,arguments)},m._NonMaxSuppressionV5=function(){return(m._NonMaxSuppressionV5=m.asm.xa).apply(null,arguments)},m._NotEqual=function(){return(m._NotEqual=m.asm.ya).apply(null,arguments)},m._OneHot=function(){return(m._OneHot=m.asm.za).apply(null,arguments)},m._PadV2=function(){return(m._PadV2=m.asm.Aa).apply(null,arguments)},m._Pow=function(){return(m._Pow=m.asm.Ba).apply(null,arguments)},m._Prelu=function(){return(m._Prelu=m.asm.Ca).apply(null,arguments)},m._Prod=function(){return(m._Prod=m.asm.Da).apply(null,arguments)},m._RealDiv=function(){return(m._RealDiv=m.asm.Ea).apply(null,arguments)},m._Relu=function(){return(m._Relu=m.asm.Fa).apply(null,arguments)},m._Relu6=function(){return(m._Relu6=m.asm.Ga).apply(null,arguments)},m._ResizeBilinear=function(){return(m._ResizeBilinear=m.asm.Ha).apply(null,arguments)},m._Reverse=function(){return(m._Reverse=m.asm.Ia).apply(null,arguments)},m._RotateWithOffset=function(){return(m._RotateWithOffset=m.asm.Ja).apply(null,arguments)},m._Round=function(){return(m._Round=m.asm.Ka).apply(null,arguments)},m._Rsqrt=function(){return(m._Rsqrt=m.asm.La).apply(null,arguments)},m._ScatterNd=function(){return(m._ScatterNd=m.asm.Ma).apply(null,arguments)},m._SelectV2=function(){return(m._SelectV2=m.asm.Na).apply(null,arguments)},m._Sigmoid=function(){return(m._Sigmoid=m.asm.Oa).apply(null,arguments)},m._Sin=function(){return(m._Sin=m.asm.Pa).apply(null,arguments)},m._Softmax=function(){return(m._Softmax=m.asm.Qa).apply(null,arguments)},m._Sqrt=function(){return(m._Sqrt=m.asm.Ra).apply(null,arguments)},m._Square=function(){return(m._Square=m.asm.Sa).apply(null,arguments)},m._SquaredDifference=function(){return(m._SquaredDifference=m.asm.Ta).apply(null,arguments)},m._Step=function(){return(m._Step=m.asm.Ua).apply(null,arguments)},m._StridedSlice=function(){return(m._StridedSlice=m.asm.Va).apply(null,arguments)},m._Sub=function(){return(m._Sub=m.asm.Wa).apply(null,arguments)},m._Sum=function(){return(m._Sum=m.asm.Xa).apply(null,arguments)},m._Tan=function(){return(m._Tan=m.asm.Ya).apply(null,arguments)},m._Tanh=function(){return(m._Tanh=m.asm.Za).apply(null,arguments)},m._Tile=function(){return(m._Tile=m.asm._a).apply(null,arguments)},m._TopK=function(){return(m._TopK=m.asm.$a).apply(null,arguments)},m._Transform=function(){return(m._Transform=m.asm.ab).apply(null,arguments)},m._Transpose=function(){return(m._Transpose=m.asm.bb).apply(null,arguments)},m.__FusedMatMul=function(){return(m.__FusedMatMul=m.asm.cb).apply(null,arguments)},m._malloc=function(){return(Bn=m._malloc=m.asm.db).apply(null,arguments)}),jn=m._free=function(){return(jn=m._free=m.asm.eb).apply(null,arguments)},qn=m.___errno_location=function(){return(qn=m.___errno_location=m.asm.fb).apply(null,arguments)},Vn=m._emscripten_get_global_libc=function(){return(Vn=m._emscripten_get_global_libc=m.asm.gb).apply(null,arguments)},Gn=m._pthread_self=function(){return(Gn=m._pthread_self=m.asm.hb).apply(null,arguments)},Kn=m.___pthread_tsd_run_dtors=function(){return(Kn=m.___pthread_tsd_run_dtors=m.asm.ib).apply(null,arguments)},Qn=m._emscripten_main_thread_process_queued_calls=function(){return(Qn=m._emscripten_main_thread_process_queued_calls=m.asm.jb).apply(null,arguments)},Xn=(m._emscripten_current_thread_process_queued_calls=function(){return(m._emscripten_current_thread_process_queued_calls=m.asm.kb).apply(null,arguments)},m._emscripten_register_main_browser_thread_id=function(){return(Xn=m._emscripten_register_main_browser_thread_id=m.asm.lb).apply(null,arguments)}),Zn=m.__emscripten_do_dispatch_to_thread=function(){return(Zn=m.__emscripten_do_dispatch_to_thread=m.asm.mb).apply(null,arguments)},Yn=m._emscripten_sync_run_in_main_thread_4=function(){return(Yn=m._emscripten_sync_run_in_main_thread_4=m.asm.nb).apply(null,arguments)},Jn=m._emscripten_run_in_main_runtime_thread_js=function(){return(Jn=m._emscripten_run_in_main_runtime_thread_js=m.asm.ob).apply(null,arguments)},$n=m.__emscripten_call_on_thread=function(){return($n=m.__emscripten_call_on_thread=m.asm.pb).apply(null,arguments)},ea=(m._emscripten_tls_init=function(){return(m._emscripten_tls_init=m.asm.qb).apply(null,arguments)},m.__emscripten_thread_init=function(){return(ea=m.__emscripten_thread_init=m.asm.rb).apply(null,arguments)}),na=m.stackSave=function(){return(na=m.stackSave=m.asm.sb).apply(null,arguments)},aa=m.stackRestore=function(){return(aa=m.stackRestore=m.asm.tb).apply(null,arguments)},ta=m.stackAlloc=function(){return(ta=m.stackAlloc=m.asm.ub).apply(null,arguments)},ra=m._emscripten_stack_set_limits=function(){return(ra=m._emscripten_stack_set_limits=m.asm.vb).apply(null,arguments)},ua=m._memalign=function(){return(ua=m._memalign=m.asm.wb).apply(null,arguments)},sa=m.__emscripten_allow_main_runtime_queued_calls=9808,ia=m.__emscripten_main_thread_futex=11432;function oa(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function da(e){if(!(me>0)){if(k)return p(m),de(),void postMessage({cmd:"loaded"});oe(),me>0||(m.setStatus?(m.setStatus("Running..."),setTimeout((function(){setTimeout((function(){m.setStatus("")}),1),n()}),1)):n())}function n(){Wn||(Wn=!0,m.calledRun=!0,j||(de(),le(),p(m),m.onRuntimeInitialized&&m.onRuntimeInitialized(),ce()))}}function la(e,n){if(!n||!R||0!==e){if(!n&&k)throw postMessage({cmd:"exitProcess",returnCode:e}),new oa(e);R||(Re.terminateAllThreads(),m.onExit&&m.onExit(e),j=!0),y(e,new oa(e))}}if(m.cwrap=K,m.PThread=Re,m.PThread=Re,m.wasmMemory=D,m.ExitStatus=oa,he=function e(){Wn||da(),Wn||(he=e)},m.run=da,m.preInit)for("function"==typeof m.preInit&&(m.preInit=[m.preInit]);m.preInit.length>0;)m.preInit.pop()();return k&&(R=!1,Re.initWorker()),da(),e.ready});e.exports=o}));var qn=Bn((function(e,n){var r,u=(r="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(r=r||__filename),function(e){var n,u,s="undefined"!=typeof(e=e||{})?e:{};s.ready=new Promise((function(e,a){n=e,u=a}));var i,o={};for(i in s)s.hasOwnProperty(i)&&(o[i]=s[i]);var d=!1,l=!1,c=!1,p=!1;d="object"==typeof window,l="function"==typeof importScripts,c="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,p=!d&&!c&&!l;var f,m,h,b,y,v="";function _(e){return s.locateFile?s.locateFile(e,v):v+e}c?(v=l?a.dirname(v)+"/":__dirname+"/",f=function(e,n){return b||(b=t),y||(y=a),e=y.normalize(e),b.readFileSync(e,n?null:"utf8")},h=function(e){var n=f(e,!0);return n.buffer||(n=new Uint8Array(n)),A(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof Ce))throw e})),process.on("unhandledRejection",ae),s.inspect=function(){return"[Emscripten Module object]"}):p?("undefined"!=typeof read&&(f=function(e){return read(e)}),h=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(A("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(d||l)&&(l?v=self.location.href:"undefined"!=typeof document&&document.currentScript&&(v=document.currentScript.src),r&&(v=r),v=0!==v.indexOf("blob:")?v.substr(0,v.lastIndexOf("/")+1):"",f=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},l&&(h=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)}),m=function(e,n,a){var t=new XMLHttpRequest;t.open("GET",e,!0),t.responseType="arraybuffer",t.onload=function(){200==t.status||0==t.status&&t.response?n(t.response):a()},t.onerror=a,t.send(null)});var g,w,k=s.print||console.log.bind(console),I=s.printErr||console.warn.bind(console);for(i in o)o.hasOwnProperty(i)&&(s[i]=o[i]);o=null,s.arguments&&s.arguments,s.thisProgram&&s.thisProgram,s.quit&&s.quit,s.wasmBinary&&(g=s.wasmBinary),s.noExitRuntime,"object"!=typeof WebAssembly&&ae("no native wasm support detected");var M=!1;function A(e,n){e||ae("Assertion failed: "+n)}function x(e){var n=s["_"+e];return A(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function S(e,n,a,t,r){var u={string:function(e){var n=0;if(null!=e&&0!==e){var a=1+(e.length<<2);W(e,n=Te(a),a)}return n},array:function(e){var n=Te(e.length);return H(e,n),n}},s=x(e),i=[],o=0;if(t)for(var d=0;d<t.length;d++){var l=u[a[d]];l?(0===o&&(o=Ne()),i[d]=l(t[d])):i[d]=t[d]}var c=s.apply(null,i);return c=function(e){return"string"===n?P(e):"boolean"===n?Boolean(e):e}(c),0!==o&&Ee(o),c}function F(e,n,a,t){var r=(a=a||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!t?x(e):function(){return S(e,n,a,arguments)}}var N,E,T,C,O="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function D(e,n,a){for(var t=n+a,r=n;e[r]&&!(r>=t);)++r;if(r-n>16&&e.subarray&&O)return O.decode(e.subarray(n,r));for(var u="";n<r;){var s=e[n++];if(128&s){var i=63&e[n++];if(192!=(224&s)){var o=63&e[n++];if((s=224==(240&s)?(15&s)<<12|i<<6|o:(7&s)<<18|i<<12|o<<6|63&e[n++])<65536)u+=String.fromCharCode(s);else{var d=s-65536;u+=String.fromCharCode(55296|d>>10,56320|1023&d)}}else u+=String.fromCharCode((31&s)<<6|i)}else u+=String.fromCharCode(s)}return u}function P(e,n){return e?D(T,e,n):""}function R(e,n,a,t){if(!(t>0))return 0;for(var r=a,u=a+t-1,s=0;s<e.length;++s){var i=e.charCodeAt(s);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++s)),i<=127){if(a>=u)break;n[a++]=i}else if(i<=2047){if(a+1>=u)break;n[a++]=192|i>>6,n[a++]=128|63&i}else if(i<=65535){if(a+2>=u)break;n[a++]=224|i>>12,n[a++]=128|i>>6&63,n[a++]=128|63&i}else{if(a+3>=u)break;n[a++]=240|i>>18,n[a++]=128|i>>12&63,n[a++]=128|i>>6&63,n[a++]=128|63&i}}return n[a]=0,a-r}function W(e,n,a){return R(e,T,n,a)}function H(e,n){E.set(e,n)}function z(e,n){return e%n>0&&(e+=n-e%n),e}function L(e){N=e,s.HEAP8=E=new Int8Array(e),s.HEAP16=new Int16Array(e),s.HEAP32=C=new Int32Array(e),s.HEAPU8=T=new Uint8Array(e),s.HEAPU16=new Uint16Array(e),s.HEAPU32=new Uint32Array(e),s.HEAPF32=new Float32Array(e),s.HEAPF64=new Float64Array(e)}s.INITIAL_MEMORY;var U,B=[],j=[],q=[],V=[];function G(){if(s.preRun)for("function"==typeof s.preRun&&(s.preRun=[s.preRun]);s.preRun.length;)Z(s.preRun.shift());pe(B)}function K(){pe(j)}function Q(){pe(q)}function X(){if(s.postRun)for("function"==typeof s.postRun&&(s.postRun=[s.postRun]);s.postRun.length;)Y(s.postRun.shift());pe(V)}function Z(e){B.unshift(e)}function Y(e){V.unshift(e)}j.push({func:function(){Se()}});var J=0,$=null;function ee(e){J++,s.monitorRunDependencies&&s.monitorRunDependencies(J)}function ne(e){if(J--,s.monitorRunDependencies&&s.monitorRunDependencies(J),0==J&&$){var n=$;$=null,n()}}function ae(e){s.onAbort&&s.onAbort(e),I(e+=""),M=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.";var n=new WebAssembly.RuntimeError(e);throw u(n),n}function te(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}s.preloadedImages={},s.preloadedAudios={};var re="data:application/octet-stream;base64,";function ue(e){return te(e,re)}var se="file://";function ie(e){return te(e,se)}var oe="tfjs-backend-wasm.wasm";function de(e){try{if(e==oe&&g)return new Uint8Array(g);if(h)return h(e);throw"both async and sync fetching of the wasm failed"}catch(e){ae(e)}}function le(){if(!g&&(d||l)){if("function"==typeof fetch&&!ie(oe))return fetch(oe,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+oe+"'";return e.arrayBuffer()})).catch((function(){return de(oe)}));if(m)return new Promise((function(e,n){m(oe,(function(n){e(new Uint8Array(n))}),n)}))}return Promise.resolve().then((function(){return de(oe)}))}function ce(){var e={a:xe};function n(e,n){var a=e.exports;s.asm=a,L((w=s.asm.i).buffer),U=s.asm.o,ne()}function a(e){n(e.instance)}function t(n){return le().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){I("failed to asynchronously prepare wasm: "+e),ae(e)}))}if(ee(),s.instantiateWasm)try{return s.instantiateWasm(e,n)}catch(e){return I("Module.instantiateWasm callback failed with error: "+e),!1}return(g||"function"!=typeof WebAssembly.instantiateStreaming||ue(oe)||ie(oe)||"function"!=typeof fetch?t(a):fetch(oe,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(a,(function(e){return I("wasm streaming compile failed: "+e),I("falling back to ArrayBuffer instantiation"),t(a)}))}))).catch(u),{}}function pe(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var a=n.func;"number"==typeof a?void 0===n.arg?U.get(a)():U.get(a)(n.arg):a(void 0===n.arg?null:n.arg)}else n(s)}}function fe(){ae()}function me(e,n,a){T.copyWithin(e,n,n+a)}function he(){return T.length}function be(e){try{return w.grow(e-N.byteLength+65535>>>16),L(w.buffer),1}catch(e){}}function ye(e){var n=he(),a=2147483648;if(e>a)return!1;for(var t=1;t<=4;t*=2){var r=n*(1+.2/t);if(r=Math.min(r,e+100663296),be(Math.min(a,z(Math.max(e,r),65536))))return!0}return!1}ue(oe)||(oe=_(oe));var ve={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var a=ve.buffers[e];0===n||10===n?((1===e?k:I)(D(a,0)),a.length=0):a.push(n)},varargs:void 0,get:function(){return ve.varargs+=4,C[ve.varargs-4>>2]},getStr:function(e){return P(e)},get64:function(e,n){return e}};function _e(e){return 0}function ge(e,n,a,t,r){}function we(e,n,a,t){for(var r=0,u=0;u<a;u++){for(var s=C[n+8*u>>2],i=C[n+(8*u+4)>>2],o=0;o<i;o++)ve.printChar(e,T[s+o]);r+=i}return C[t>>2]=r,0}function ke(){return 6}function Ie(e){return C[Fe()>>2]=e,e}function Me(e){switch(e){case 30:return 16384;case 85:return 131072;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:case 80:case 81:case 79:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator&&navigator.hardwareConcurrency||1}return Ie(28),-1}var Ae,xe={a:fe,d:me,e:ye,f:_e,c:ge,b:we,g:ke,h:Me},Se=(ce(),s.___wasm_call_ctors=function(){return(Se=s.___wasm_call_ctors=s.asm.j).apply(null,arguments)}),Fe=(s._init=function(){return(s._init=s.asm.k).apply(null,arguments)},s._register_tensor=function(){return(s._register_tensor=s.asm.l).apply(null,arguments)},s._dispose_data=function(){return(s._dispose_data=s.asm.m).apply(null,arguments)},s._dispose=function(){return(s._dispose=s.asm.n).apply(null,arguments)},s._Abs=function(){return(s._Abs=s.asm.p).apply(null,arguments)},s._Add=function(){return(s._Add=s.asm.q).apply(null,arguments)},s._AddN=function(){return(s._AddN=s.asm.r).apply(null,arguments)},s._All=function(){return(s._All=s.asm.s).apply(null,arguments)},s._Any=function(){return(s._Any=s.asm.t).apply(null,arguments)},s._ArgMax=function(){return(s._ArgMax=s.asm.u).apply(null,arguments)},s._AvgPool=function(){return(s._AvgPool=s.asm.v).apply(null,arguments)},s._BatchMatMul=function(){return(s._BatchMatMul=s.asm.w).apply(null,arguments)},s._Ceil=function(){return(s._Ceil=s.asm.x).apply(null,arguments)},s._ClipByValue=function(){return(s._ClipByValue=s.asm.y).apply(null,arguments)},s._Conv2D=function(){return(s._Conv2D=s.asm.z).apply(null,arguments)},s._Conv2DBackpropInput=function(){return(s._Conv2DBackpropInput=s.asm.A).apply(null,arguments)},s._Cos=function(){return(s._Cos=s.asm.B).apply(null,arguments)},s._CropAndResize=function(){return(s._CropAndResize=s.asm.C).apply(null,arguments)},s._Cumsum=function(){return(s._Cumsum=s.asm.D).apply(null,arguments)},s._DepthToSpace=function(){return(s._DepthToSpace=s.asm.E).apply(null,arguments)},s._DepthwiseConv2dNative=function(){return(s._DepthwiseConv2dNative=s.asm.F).apply(null,arguments)},s._Equal=function(){return(s._Equal=s.asm.G).apply(null,arguments)},s._Exp=function(){return(s._Exp=s.asm.H).apply(null,arguments)},s._FlipLeftRight=function(){return(s._FlipLeftRight=s.asm.I).apply(null,arguments)},s._Floor=function(){return(s._Floor=s.asm.J).apply(null,arguments)},s._FloorDiv=function(){return(s._FloorDiv=s.asm.K).apply(null,arguments)},s._FusedBatchNorm=function(){return(s._FusedBatchNorm=s.asm.L).apply(null,arguments)},s._FusedConv2D=function(){return(s._FusedConv2D=s.asm.M).apply(null,arguments)},s._FusedDepthwiseConv2D=function(){return(s._FusedDepthwiseConv2D=s.asm.N).apply(null,arguments)},s._Gather=function(){return(s._Gather=s.asm.O).apply(null,arguments)},s._GatherNd=function(){return(s._GatherNd=s.asm.P).apply(null,arguments)},s._Greater=function(){return(s._Greater=s.asm.Q).apply(null,arguments)},s._GreaterEqual=function(){return(s._GreaterEqual=s.asm.R).apply(null,arguments)},s._LeakyRelu=function(){return(s._LeakyRelu=s.asm.S).apply(null,arguments)},s._Less=function(){return(s._Less=s.asm.T).apply(null,arguments)},s._LessEqual=function(){return(s._LessEqual=s.asm.U).apply(null,arguments)},s._Log=function(){return(s._Log=s.asm.V).apply(null,arguments)},s._LogicalAnd=function(){return(s._LogicalAnd=s.asm.W).apply(null,arguments)},s._Max=function(){return(s._Max=s.asm.X).apply(null,arguments)},s._MaxPool=function(){return(s._MaxPool=s.asm.Y).apply(null,arguments)},s._Maximum=function(){return(s._Maximum=s.asm.Z).apply(null,arguments)},s._Mean=function(){return(s._Mean=s.asm._).apply(null,arguments)},s._Min=function(){return(s._Min=s.asm.$).apply(null,arguments)},s._Minimum=function(){return(s._Minimum=s.asm.aa).apply(null,arguments)},s._MirrorPad=function(){return(s._MirrorPad=s.asm.ba).apply(null,arguments)},s._Multiply=function(){return(s._Multiply=s.asm.ca).apply(null,arguments)},s._Neg=function(){return(s._Neg=s.asm.da).apply(null,arguments)},s._NonMaxSuppressionV3=function(){return(s._NonMaxSuppressionV3=s.asm.ea).apply(null,arguments)},s._NonMaxSuppressionV4=function(){return(s._NonMaxSuppressionV4=s.asm.fa).apply(null,arguments)},s._NonMaxSuppressionV5=function(){return(s._NonMaxSuppressionV5=s.asm.ga).apply(null,arguments)},s._NotEqual=function(){return(s._NotEqual=s.asm.ha).apply(null,arguments)},s._OneHot=function(){return(s._OneHot=s.asm.ia).apply(null,arguments)},s._PadV2=function(){return(s._PadV2=s.asm.ja).apply(null,arguments)},s._Pow=function(){return(s._Pow=s.asm.ka).apply(null,arguments)},s._Prelu=function(){return(s._Prelu=s.asm.la).apply(null,arguments)},s._Prod=function(){return(s._Prod=s.asm.ma).apply(null,arguments)},s._RealDiv=function(){return(s._RealDiv=s.asm.na).apply(null,arguments)},s._Relu=function(){return(s._Relu=s.asm.oa).apply(null,arguments)},s._Relu6=function(){return(s._Relu6=s.asm.pa).apply(null,arguments)},s._ResizeBilinear=function(){return(s._ResizeBilinear=s.asm.qa).apply(null,arguments)},s._Reverse=function(){return(s._Reverse=s.asm.ra).apply(null,arguments)},s._RotateWithOffset=function(){return(s._RotateWithOffset=s.asm.sa).apply(null,arguments)},s._Round=function(){return(s._Round=s.asm.ta).apply(null,arguments)},s._Rsqrt=function(){return(s._Rsqrt=s.asm.ua).apply(null,arguments)},s._ScatterNd=function(){return(s._ScatterNd=s.asm.va).apply(null,arguments)},s._SelectV2=function(){return(s._SelectV2=s.asm.wa).apply(null,arguments)},s._Sigmoid=function(){return(s._Sigmoid=s.asm.xa).apply(null,arguments)},s._Sin=function(){return(s._Sin=s.asm.ya).apply(null,arguments)},s._Softmax=function(){return(s._Softmax=s.asm.za).apply(null,arguments)},s._Sqrt=function(){return(s._Sqrt=s.asm.Aa).apply(null,arguments)},s._Square=function(){return(s._Square=s.asm.Ba).apply(null,arguments)},s._SquaredDifference=function(){return(s._SquaredDifference=s.asm.Ca).apply(null,arguments)},s._Step=function(){return(s._Step=s.asm.Da).apply(null,arguments)},s._StridedSlice=function(){return(s._StridedSlice=s.asm.Ea).apply(null,arguments)},s._Sub=function(){return(s._Sub=s.asm.Fa).apply(null,arguments)},s._Sum=function(){return(s._Sum=s.asm.Ga).apply(null,arguments)},s._Tan=function(){return(s._Tan=s.asm.Ha).apply(null,arguments)},s._Tanh=function(){return(s._Tanh=s.asm.Ia).apply(null,arguments)},s._Tile=function(){return(s._Tile=s.asm.Ja).apply(null,arguments)},s._TopK=function(){return(s._TopK=s.asm.Ka).apply(null,arguments)},s._Transform=function(){return(s._Transform=s.asm.La).apply(null,arguments)},s._Transpose=function(){return(s._Transpose=s.asm.Ma).apply(null,arguments)},s.__FusedMatMul=function(){return(s.__FusedMatMul=s.asm.Na).apply(null,arguments)},s._malloc=function(){return(s._malloc=s.asm.Oa).apply(null,arguments)},s._free=function(){return(s._free=s.asm.Pa).apply(null,arguments)},s.___errno_location=function(){return(Fe=s.___errno_location=s.asm.Qa).apply(null,arguments)}),Ne=s.stackSave=function(){return(Ne=s.stackSave=s.asm.Ra).apply(null,arguments)},Ee=s.stackRestore=function(){return(Ee=s.stackRestore=s.asm.Sa).apply(null,arguments)},Te=s.stackAlloc=function(){return(Te=s.stackAlloc=s.asm.Ta).apply(null,arguments)};function Ce(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function Oe(e){function a(){Ae||(Ae=!0,s.calledRun=!0,M||(K(),Q(),n(s),s.onRuntimeInitialized&&s.onRuntimeInitialized(),X()))}J>0||(G(),J>0||(s.setStatus?(s.setStatus("Running..."),setTimeout((function(){setTimeout((function(){s.setStatus("")}),1),a()}),1)):a()))}if(s.cwrap=F,$=function e(){Ae||Oe(),Ae||($=e)},s.run=Oe,s.preInit)for("function"==typeof s.preInit&&(s.preInit=[s.preInit]);s.preInit.length>0;)s.preInit.pop()();return Oe(),e.ready});e.exports=u})),Vn=function(e){function a(a){var t=e.call(this)||this;return t.wasm=a,t.dataIdNextNumber=1,t.wasm.tfjs.init(),t.dataIdMap=new n.DataStorage(t,n.engine()),t}return function(e,n){function a(){this.constructor=e}Rn(e,n),e.prototype=null===n?Object.create(n):(a.prototype=n.prototype,new a)}(a,e),a.prototype.write=function(e,n,a){var t={id:this.dataIdNextNumber++};return this.move(t,e,n,a,1),t},a.prototype.numDataIds=function(){return this.dataIdMap.numDataIds()},a.prototype.time=function(e){return Wn(this,void 0,void 0,(function(){var a;return Hn(this,(function(t){return a=n.util.now(),e(),[2,{kernelMs:n.util.now()-a}]}))}))},a.prototype.move=function(e,a,t,r,u){var s=this.dataIdNextNumber++;if("string"!==r){var i=n.util.sizeFromShape(t),o=i*n.util.bytesPerElement(r),d=this.wasm._malloc(o);this.dataIdMap.set(e,{id:s,memoryOffset:d,shape:t,dtype:r,refCount:u}),this.wasm.tfjs.registerTensor(s,i,d),null!=a&&this.wasm.HEAPU8.set(new Uint8Array(a.buffer,a.byteOffset,o),d)}else{var l=a;this.dataIdMap.set(e,{id:s,stringBytes:l,shape:t,dtype:r,memoryOffset:null,refCount:u})}},a.prototype.read=function(e){return Wn(this,void 0,void 0,(function(){return Hn(this,(function(n){return[2,this.readSync(e)]}))}))},a.prototype.readSync=function(e){var a=this.dataIdMap.get(e),t=a.memoryOffset,r=a.dtype,u=a.shape,s=a.stringBytes;return"string"===r?s:function(e,n){switch(n){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error("Unknown dtype "+n)}}(this.wasm.HEAPU8.slice(t,t+n.util.sizeFromShape(u)*n.util.bytesPerElement(r)).buffer,r)},a.prototype.disposeData=function(e,n){if(void 0===n&&(n=!1),this.dataIdMap.has(e)){var a=this.dataIdMap.get(e);if(a.refCount--,!n&&a.refCount>0)return!1;this.wasm._free(a.memoryOffset),this.wasm.tfjs.disposeData(a.id),this.dataIdMap.delete(e)}return!0},a.prototype.refCount=function(e){return this.dataIdMap.has(e)?this.dataIdMap.get(e).refCount:0},a.prototype.incRef=function(e){var n=this.dataIdMap.get(e);null!=n&&n.refCount++},a.prototype.floatPrecision=function(){return 32},a.prototype.getMemoryOffset=function(e){return this.dataIdMap.get(e).memoryOffset},a.prototype.dispose=function(){this.wasm.tfjs.dispose(),"PThread"in this.wasm&&this.wasm.PThread.terminateAllThreads(),this.wasm=null},a.prototype.memory=function(){return{unreliable:!1}},a.prototype.makeOutput=function(e,a,t){var r;if(null==t)r=this.write(null,e,a);else{var u=this.dataIdNextNumber++;r={id:u},this.dataIdMap.set(r,{id:u,memoryOffset:t,shape:e,dtype:a,refCount:1});var s=n.util.sizeFromShape(e);this.wasm.tfjs.registerTensor(u,s,t)}return{dataId:r,shape:e,dtype:a}},a.prototype.typedArrayFromHeap=function(e){var a=e.shape,t=e.dtype,r=e.dataId,u=this.wasm.HEAPU8.buffer,s=this.dataIdMap.get(r).memoryOffset,i=n.util.sizeFromShape(a);switch(t){case"float32":return new Float32Array(u,s,i);case"int32":return new Int32Array(u,s,i);case"bool":return new Uint8Array(u,s,i);default:throw new Error("Unknown dtype "+t)}},a}(n.KernelBackend);function Gn(e,n,a){if(null!=Xn)return Xn;var t="tfjs-backend-wasm.wasm";return e&&n?t="tfjs-backend-wasm-threaded-simd.wasm":e&&(t="tfjs-backend-wasm-simd.wasm"),null!=Yn&&null!=Yn[t]?Yn[t]:a+t}function Kn(){return Wn(this,void 0,void 0,(function(){var e,a,t;return Hn(this,(function(r){switch(r.label){case 0:return[4,Promise.all([n.env().getAsync("WASM_HAS_SIMD_SUPPORT"),n.env().getAsync("WASM_HAS_MULTITHREAD_SUPPORT")])];case 1:return e=r.sent(),a=e[0],t=e[1],[2,new Promise((function(e,r){var u={locateFile:function(e,n){if(e.endsWith(".worker.js")){var r=new Blob(['var Module={};function threadPrintErr(){var text=Array.prototype.slice.call(arguments).join(" ");console.error(text)}function threadAlert(){var text=Array.prototype.slice.call(arguments).join(" ");postMessage({cmd:"alert",text:text,threadId:Module["_pthread_self"]()})}var err=threadPrintErr;this.alert=threadAlert;Module["instantiateWasm"]=function(info,receiveInstance){var instance=new WebAssembly.Instance(Module["wasmModule"],info);Module["wasmModule"]=null;receiveInstance(instance);return instance.exports};function moduleLoaded(){}this.onmessage=function(e){try{if(e.data.cmd==="load"){Module["wasmModule"]=e.data.wasmModule;Module["wasmMemory"]=e.data.wasmMemory;Module["buffer"]=Module["wasmMemory"].buffer;Module["ENVIRONMENT_IS_PTHREAD"]=true;if(typeof e.data.urlOrBlob==="string"){importScripts(e.data.urlOrBlob)}else{var objectUrl=URL.createObjectURL(e.data.urlOrBlob);importScripts(objectUrl);URL.revokeObjectURL(objectUrl)}WasmBackendModuleThreadedSimd(Module).then(function(instance){Module=instance;moduleLoaded()})}else if(e.data.cmd==="objectTransfer"){Module["PThread"].receiveObjectTransfer(e.data)}else if(e.data.cmd==="run"){Module["__performance_now_clock_drift"]=performance.now()-e.data.time;Module["__emscripten_thread_init"](e.data.threadInfoStruct,0,0);var max=e.data.stackBase;var top=e.data.stackBase+e.data.stackSize;Module["establishStackSpace"](top,max);Module["_emscripten_tls_init"]();Module["PThread"].receiveObjectTransfer(e.data);Module["PThread"].setThreadStatus(Module["_pthread_self"](),1);try{var result=Module["invokeEntryPoint"](e.data.start_routine,e.data.arg);if(!Module["getNoExitRuntime"]())Module["PThread"].threadExit(result)}catch(ex){if(ex==="Canceled!"){Module["PThread"].threadCancel()}else if(ex!="unwind"){if(ex instanceof Module["ExitStatus"]){if(Module["getNoExitRuntime"]()){}else{Module["PThread"].threadExit(ex.status)}}else{Module["PThread"].threadExit(-2);throw ex}}}}else if(e.data.cmd==="cancel"){if(Module["_pthread_self"]()){Module["PThread"].threadCancel()}}else if(e.data.target==="setimmediate"){}else if(e.data.cmd==="processThreadQueue"){if(Module["_pthread_self"]()){Module["_emscripten_current_thread_process_queued_calls"]()}}else{err("worker.js received unknown command "+e.data.cmd);err(e.data)}}catch(ex){err("worker.js onmessage() captured an uncaught exception: "+ex);if(ex&&ex.stack)err(ex.stack);throw ex}};if(typeof process==="object"&&typeof process.versions==="object"&&typeof process.versions.node==="string"){self={location:{href:__filename}};var onmessage=this.onmessage;var nodeWorkerThreads=require("worker_threads");global.Worker=nodeWorkerThreads.Worker;var parentPort=nodeWorkerThreads.parentPort;parentPort.on("message",function(data){onmessage({data:data})});var nodeFS=require("fs");var nodeRead=function(filename){return nodeFS.readFileSync(filename,"utf8")};function globalEval(x){global.require=require;global.Module=Module;eval.call(null,x)}importScripts=function(f){globalEval(nodeRead(f))};postMessage=function(msg){parentPort.postMessage(msg)};if(typeof performance==="undefined"){performance={now:function(){return Date.now()}}}}'],{type:"application/javascript"});return URL.createObjectURL(r)}return e.endsWith(".wasm")?Gn(a,t,null!=Zn?Zn:n):n+e}};$n&&(u.instantiateWasm=function(e){return function(a,t){return n.util.fetch(e,{credentials:"same-origin"}).then((function(n){n.ok||a.env.a("failed to load wasm binary file at '"+e+"'"),n.arrayBuffer().then((function(e){WebAssembly.instantiate(e,a).then((function(e){t(e.instance,e.module)}))}))})),{}}}(Gn(a,t,null!=Zn?Zn:"")));var s,i=!1;u.onAbort=function(){if(!i&&!Jn){Jn=!0;r({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})}},t&&a&&null==Xn?(u.mainScriptUrlOrBlob=new Blob(["var WasmBackendModuleThreadedSimd = "+jn.toString()],{type:"text/javascript"}),s=jn(u)):s=qn(u),s.then((function(n){i=!0,Jn=!1;n.tfjs={init:n.cwrap("init",null,[]),registerTensor:n.cwrap("register_tensor",null,["number","number","number"]),disposeData:n.cwrap("dispose_data",null,["number"]),dispose:n.cwrap("dispose",null,[])},e({wasm:n})}))}))]}}))}))}var Qn=["tfjs-backend-wasm.wasm","tfjs-backend-wasm-simd.wasm","tfjs-backend-wasm-threaded-simd.wasm"],Xn=null,Zn=null,Yn={},Jn=!1,$n=!1;n.registerBackend("wasm",(function(){return Wn(undefined,void 0,void 0,(function(){var e;return Hn(this,(function(n){switch(n.label){case 0:return[4,Kn()];case 1:return e=n.sent().wasm,[2,new Vn(e)]}}))}))}),2),e.BackendWasm=Vn,e.setWasmPath=function(e,a){if(void 0===a&&(a=!1),n.deprecationWarn("setWasmPath has been deprecated in favor of setWasmPaths and will be removed in a future release."),Jn)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");Xn=e,$n=a},e.setWasmPaths=function(e,n){if(void 0===n&&(n=!1),Jn)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPaths()` before you call `tf.setBackend()` or `tf.ready()`");if("string"==typeof e)Zn=e;else{Yn=e;var a=Qn.filter((function(e){return null==Yn[e]}));if(a.length>0)throw new Error("There were no entries found for the following binaries: "+a.join(",")+". Please either call setWasmPaths with a map providing a path for each binary, or with a string indicating the directory where all the binaries can be found.")}$n=n},e.version_wasm="3.7.0",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-wasm.min.js.map
